FIX_SPEC = {
    "tags": {
        1: {"num": 1, "names": ["Account"], "type": "STRING"},
        2: {"num": 2, "names": ["AdvId"], "type": "STRING"},
        3: {"num": 3, "names": ["AdvRefID"], "type": "STRING"},
        4: {"num": 4, "names": ["AdvSide"], "type": "CHAR", "enum_type": True},
        5: {
            "num": 5,
            "names": ["AdvTransType"],
            "type": "STRING",
            "enum_type": True,
        },
        6: {"num": 6, "names": ["AvgPx"], "type": "PRICE"},
        7: {"num": 7, "names": ["BeginSeqNo"], "type": "SEQNUM"},
        8: {"num": 8, "names": ["BeginString"], "type": "STRING"},
        9: {"num": 9, "names": ["BodyLength"], "type": "LENGTH"},
        10: {"num": 10, "names": ["CheckSum"], "type": "STRING"},
        11: {"num": 11, "names": ["ClOrdID"], "type": "STRING"},
        12: {"num": 12, "names": ["Commission"], "type": "AMT"},
        13: {
            "num": 13,
            "names": ["CommType"],
            "type": "CHAR",
            "enum_type": True,
        },
        14: {"num": 14, "names": ["CumQty"], "type": "QTY"},
        15: {"num": 15, "names": ["Currency"], "type": "CURRENCY"},
        16: {"num": 16, "names": ["EndSeqNo"], "type": "SEQNUM"},
        17: {"num": 17, "names": ["ExecID"], "type": "STRING"},
        18: {
            "num": 18,
            "names": ["ExecInst"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        19: {"num": 19, "names": ["ExecRefID"], "type": "STRING"},
        21: {
            "num": 21,
            "names": ["HandlInst"],
            "type": "CHAR",
            "enum_type": True,
        },
        22: {
            "num": 22,
            "names": ["SecurityIDSource"],
            "type": "STRING",
            "enum_type": True,
        },
        23: {"num": 23, "names": ["IOIID"], "type": "STRING"},
        25: {
            "num": 25,
            "names": ["IOIQltyInd"],
            "type": "CHAR",
            "enum_type": True,
        },
        26: {"num": 26, "names": ["IOIRefID"], "type": "STRING"},
        27: {
            "num": 27,
            "names": ["IOIQty"],
            "type": "STRING",
            "enum_type": True,
        },
        28: {
            "num": 28,
            "names": ["IOITransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        29: {
            "num": 29,
            "names": ["LastCapacity"],
            "type": "CHAR",
            "enum_type": True,
        },
        30: {"num": 30, "names": ["LastMkt"], "type": "EXCHANGE"},
        31: {"num": 31, "names": ["LastPx"], "type": "PRICE"},
        32: {"num": 32, "names": ["LastQty"], "type": "QTY"},
        33: {"num": 33, "names": ["NoLinesOfText"], "type": "NUMINGROUP"},
        34: {"num": 34, "names": ["MsgSeqNum"], "type": "SEQNUM"},
        35: {
            "num": 35,
            "names": ["MsgType"],
            "type": "STRING",
            "enum_type": True,
        },
        36: {"num": 36, "names": ["NewSeqNo"], "type": "SEQNUM"},
        37: {"num": 37, "names": ["OrderID"], "type": "STRING"},
        38: {"num": 38, "names": ["OrderQty"], "type": "QTY"},
        39: {
            "num": 39,
            "names": ["OrdStatus"],
            "type": "CHAR",
            "enum_type": True,
        },
        40: {
            "num": 40,
            "names": ["OrdType"],
            "type": "CHAR",
            "enum_type": True,
        },
        41: {"num": 41, "names": ["OrigClOrdID"], "type": "STRING"},
        42: {"num": 42, "names": ["OrigTime"], "type": "UTCTIMESTAMP"},
        43: {
            "num": 43,
            "names": ["PossDupFlag"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        44: {"num": 44, "names": ["Price"], "type": "PRICE"},
        45: {"num": 45, "names": ["RefSeqNum"], "type": "SEQNUM"},
        48: {"num": 48, "names": ["SecurityID"], "type": "STRING"},
        49: {"num": 49, "names": ["SenderCompID"], "type": "STRING"},
        50: {"num": 50, "names": ["SenderSubID"], "type": "STRING"},
        52: {"num": 52, "names": ["SendingTime"], "type": "UTCTIMESTAMP"},
        53: {"num": 53, "names": ["Quantity"], "type": "QTY"},
        54: {"num": 54, "names": ["Side"], "type": "CHAR", "enum_type": True},
        55: {"num": 55, "names": ["Symbol"], "type": "STRING"},
        56: {"num": 56, "names": ["TargetCompID"], "type": "STRING"},
        57: {"num": 57, "names": ["TargetSubID"], "type": "STRING"},
        58: {"num": 58, "names": ["Text"], "type": "STRING"},
        59: {
            "num": 59,
            "names": ["TimeInForce"],
            "type": "CHAR",
            "enum_type": True,
        },
        60: {"num": 60, "names": ["TransactTime"], "type": "UTCTIMESTAMP"},
        61: {
            "num": 61,
            "names": ["Urgency"],
            "type": "CHAR",
            "enum_type": True,
        },
        62: {"num": 62, "names": ["ValidUntilTime"], "type": "UTCTIMESTAMP"},
        63: {
            "num": 63,
            "names": ["SettlType"],
            "type": "STRING",
            "enum_type": True,
        },
        64: {"num": 64, "names": ["SettlDate"], "type": "LOCALMKTDATE"},
        65: {
            "num": 65,
            "names": ["SymbolSfx"],
            "type": "STRING",
            "enum_type": True,
        },
        66: {"num": 66, "names": ["ListID"], "type": "STRING"},
        67: {"num": 67, "names": ["ListSeqNo"], "type": "INT"},
        68: {"num": 68, "names": ["TotNoOrders"], "type": "INT"},
        69: {"num": 69, "names": ["ListExecInst"], "type": "STRING"},
        70: {"num": 70, "names": ["AllocID"], "type": "STRING"},
        71: {
            "num": 71,
            "names": ["AllocTransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        72: {"num": 72, "names": ["RefAllocID"], "type": "STRING"},
        73: {"num": 73, "names": ["NoOrders"], "type": "NUMINGROUP"},
        74: {"num": 74, "names": ["AvgPxPrecision"], "type": "INT"},
        75: {"num": 75, "names": ["TradeDate"], "type": "LOCALMKTDATE"},
        77: {
            "num": 77,
            "names": ["PositionEffect"],
            "type": "CHAR",
            "enum_type": True,
        },
        78: {"num": 78, "names": ["NoAllocs"], "type": "NUMINGROUP"},
        79: {"num": 79, "names": ["AllocAccount"], "type": "STRING"},
        80: {"num": 80, "names": ["AllocQty"], "type": "QTY"},
        81: {
            "num": 81,
            "names": ["ProcessCode"],
            "type": "CHAR",
            "enum_type": True,
        },
        82: {"num": 82, "names": ["NoRpts"], "type": "INT"},
        83: {"num": 83, "names": ["RptSeq"], "type": "INT"},
        84: {"num": 84, "names": ["CxlQty"], "type": "QTY"},
        85: {"num": 85, "names": ["NoDlvyInst"], "type": "NUMINGROUP"},
        87: {
            "num": 87,
            "names": ["AllocStatus"],
            "type": "INT",
            "enum_type": True,
        },
        88: {
            "num": 88,
            "names": ["AllocRejCode"],
            "type": "INT",
            "enum_type": True,
        },
        89: {"num": 89, "names": ["Signature"], "type": "DATA"},
        90: {"num": 90, "names": ["SecureDataLen"], "type": "LENGTH"},
        91: {"num": 91, "names": ["SecureData"], "type": "DATA"},
        93: {"num": 93, "names": ["SignatureLength"], "type": "LENGTH"},
        94: {
            "num": 94,
            "names": ["EmailType"],
            "type": "CHAR",
            "enum_type": True,
        },
        95: {"num": 95, "names": ["RawDataLength"], "type": "LENGTH"},
        96: {"num": 96, "names": ["RawData"], "type": "DATA"},
        97: {
            "num": 97,
            "names": ["PossResend"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        98: {
            "num": 98,
            "names": ["EncryptMethod"],
            "type": "INT",
            "enum_type": True,
        },
        99: {"num": 99, "names": ["StopPx"], "type": "PRICE"},
        100: {"num": 100, "names": ["ExDestination"], "type": "EXCHANGE"},
        102: {
            "num": 102,
            "names": ["CxlRejReason"],
            "type": "INT",
            "enum_type": True,
        },
        103: {
            "num": 103,
            "names": ["OrdRejReason"],
            "type": "INT",
            "enum_type": True,
        },
        104: {
            "num": 104,
            "names": ["IOIQualifier"],
            "type": "CHAR",
            "enum_type": True,
        },
        106: {"num": 106, "names": ["Issuer"], "type": "STRING"},
        107: {"num": 107, "names": ["SecurityDesc"], "type": "STRING"},
        108: {"num": 108, "names": ["HeartBtInt"], "type": "INT"},
        110: {"num": 110, "names": ["MinQty"], "type": "QTY"},
        111: {"num": 111, "names": ["MaxFloor"], "type": "QTY"},
        112: {"num": 112, "names": ["TestReqID"], "type": "STRING"},
        113: {
            "num": 113,
            "names": ["ReportToExch"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        114: {
            "num": 114,
            "names": ["LocateReqd"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        115: {"num": 115, "names": ["OnBehalfOfCompID"], "type": "STRING"},
        116: {"num": 116, "names": ["OnBehalfOfSubID"], "type": "STRING"},
        117: {"num": 117, "names": ["QuoteID"], "type": "STRING"},
        118: {"num": 118, "names": ["NetMoney"], "type": "AMT"},
        119: {"num": 119, "names": ["SettlCurrAmt"], "type": "AMT"},
        120: {"num": 120, "names": ["SettlCurrency"], "type": "CURRENCY"},
        121: {
            "num": 121,
            "names": ["ForexReq"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        122: {
            "num": 122,
            "names": ["OrigSendingTime"],
            "type": "UTCTIMESTAMP",
        },
        123: {
            "num": 123,
            "names": ["GapFillFlag"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        124: {"num": 124, "names": ["NoExecs"], "type": "NUMINGROUP"},
        126: {"num": 126, "names": ["ExpireTime"], "type": "UTCTIMESTAMP"},
        127: {
            "num": 127,
            "names": ["DKReason"],
            "type": "CHAR",
            "enum_type": True,
        },
        128: {"num": 128, "names": ["DeliverToCompID"], "type": "STRING"},
        129: {"num": 129, "names": ["DeliverToSubID"], "type": "STRING"},
        130: {
            "num": 130,
            "names": ["IOINaturalFlag"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        131: {"num": 131, "names": ["QuoteReqID"], "type": "STRING"},
        132: {"num": 132, "names": ["BidPx"], "type": "PRICE"},
        133: {"num": 133, "names": ["OfferPx"], "type": "PRICE"},
        134: {"num": 134, "names": ["BidSize"], "type": "QTY"},
        135: {"num": 135, "names": ["OfferSize"], "type": "QTY"},
        136: {"num": 136, "names": ["NoMiscFees"], "type": "NUMINGROUP"},
        137: {"num": 137, "names": ["MiscFeeAmt"], "type": "AMT"},
        138: {"num": 138, "names": ["MiscFeeCurr"], "type": "CURRENCY"},
        139: {
            "num": 139,
            "names": ["MiscFeeType"],
            "type": "STRING",
            "enum_type": True,
        },
        140: {"num": 140, "names": ["PrevClosePx"], "type": "PRICE"},
        141: {
            "num": 141,
            "names": ["ResetSeqNumFlag"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        142: {"num": 142, "names": ["SenderLocationID"], "type": "STRING"},
        143: {"num": 143, "names": ["TargetLocationID"], "type": "STRING"},
        144: {"num": 144, "names": ["OnBehalfOfLocationID"], "type": "STRING"},
        145: {"num": 145, "names": ["DeliverToLocationID"], "type": "STRING"},
        146: {"num": 146, "names": ["NoRelatedSym"], "type": "NUMINGROUP"},
        147: {"num": 147, "names": ["Subject"], "type": "STRING"},
        148: {"num": 148, "names": ["Headline"], "type": "STRING"},
        149: {"num": 149, "names": ["URLLink"], "type": "STRING"},
        150: {
            "num": 150,
            "names": ["ExecType"],
            "type": "CHAR",
            "enum_type": True,
        },
        151: {"num": 151, "names": ["LeavesQty"], "type": "QTY"},
        152: {"num": 152, "names": ["CashOrderQty"], "type": "QTY"},
        153: {"num": 153, "names": ["AllocAvgPx"], "type": "PRICE"},
        154: {"num": 154, "names": ["AllocNetMoney"], "type": "AMT"},
        155: {"num": 155, "names": ["SettlCurrFxRate"], "type": "FLOAT"},
        156: {
            "num": 156,
            "names": ["SettlCurrFxRateCalc"],
            "type": "CHAR",
            "enum_type": True,
        },
        157: {"num": 157, "names": ["NumDaysInterest"], "type": "INT"},
        158: {
            "num": 158,
            "names": ["AccruedInterestRate"],
            "type": "PERCENTAGE",
        },
        159: {"num": 159, "names": ["AccruedInterestAmt"], "type": "AMT"},
        160: {
            "num": 160,
            "names": ["SettlInstMode"],
            "type": "CHAR",
            "enum_type": True,
        },
        161: {"num": 161, "names": ["AllocText"], "type": "STRING"},
        162: {"num": 162, "names": ["SettlInstID"], "type": "STRING"},
        163: {
            "num": 163,
            "names": ["SettlInstTransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        164: {"num": 164, "names": ["EmailThreadID"], "type": "STRING"},
        165: {
            "num": 165,
            "names": ["SettlInstSource"],
            "type": "CHAR",
            "enum_type": True,
        },
        167: {
            "num": 167,
            "names": ["SecurityType"],
            "type": "STRING",
            "enum_type": True,
        },
        168: {"num": 168, "names": ["EffectiveTime"], "type": "UTCTIMESTAMP"},
        169: {
            "num": 169,
            "names": ["StandInstDbType"],
            "type": "INT",
            "enum_type": True,
        },
        170: {"num": 170, "names": ["StandInstDbName"], "type": "STRING"},
        171: {"num": 171, "names": ["StandInstDbID"], "type": "STRING"},
        172: {
            "num": 172,
            "names": ["SettlDeliveryType"],
            "type": "INT",
            "enum_type": True,
        },
        188: {"num": 188, "names": ["BidSpotRate"], "type": "PRICE"},
        189: {
            "num": 189,
            "names": ["BidForwardPoints"],
            "type": "PRICEOFFSET",
        },
        190: {"num": 190, "names": ["OfferSpotRate"], "type": "PRICE"},
        191: {
            "num": 191,
            "names": ["OfferForwardPoints"],
            "type": "PRICEOFFSET",
        },
        192: {"num": 192, "names": ["OrderQty2"], "type": "QTY"},
        193: {"num": 193, "names": ["SettlDate2"], "type": "LOCALMKTDATE"},
        194: {"num": 194, "names": ["LastSpotRate"], "type": "PRICE"},
        195: {
            "num": 195,
            "names": ["LastForwardPoints"],
            "type": "PRICEOFFSET",
        },
        196: {"num": 196, "names": ["AllocLinkID"], "type": "STRING"},
        197: {
            "num": 197,
            "names": ["AllocLinkType"],
            "type": "INT",
            "enum_type": True,
        },
        198: {"num": 198, "names": ["SecondaryOrderID"], "type": "STRING"},
        199: {"num": 199, "names": ["NoIOIQualifiers"], "type": "NUMINGROUP"},
        200: {"num": 200, "names": ["MaturityMonthYear"], "type": "MONTHYEAR"},
        201: {
            "num": 201,
            "names": ["PutOrCall"],
            "type": "INT",
            "enum_type": True,
        },
        202: {"num": 202, "names": ["StrikePrice"], "type": "PRICE"},
        203: {
            "num": 203,
            "names": ["CoveredOrUncovered"],
            "type": "INT",
            "enum_type": True,
        },
        206: {"num": 206, "names": ["OptAttribute"], "type": "CHAR"},
        207: {"num": 207, "names": ["SecurityExchange"], "type": "EXCHANGE"},
        208: {
            "num": 208,
            "names": ["NotifyBrokerOfCredit"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        209: {
            "num": 209,
            "names": ["AllocHandlInst"],
            "type": "INT",
            "enum_type": True,
        },
        210: {"num": 210, "names": ["MaxShow"], "type": "QTY"},
        211: {"num": 211, "names": ["PegOffsetValue"], "type": "FLOAT"},
        212: {"num": 212, "names": ["XmlDataLen"], "type": "LENGTH"},
        213: {"num": 213, "names": ["XmlData"], "type": "DATA"},
        214: {"num": 214, "names": ["SettlInstRefID"], "type": "STRING"},
        215: {"num": 215, "names": ["NoRoutingIDs"], "type": "NUMINGROUP"},
        216: {
            "num": 216,
            "names": ["RoutingType"],
            "type": "INT",
            "enum_type": True,
        },
        217: {"num": 217, "names": ["RoutingID"], "type": "STRING"},
        218: {"num": 218, "names": ["Spread"], "type": "PRICEOFFSET"},
        220: {
            "num": 220,
            "names": ["BenchmarkCurveCurrency"],
            "type": "CURRENCY",
        },
        221: {
            "num": 221,
            "names": ["BenchmarkCurveName"],
            "type": "STRING",
            "enum_type": True,
        },
        222: {"num": 222, "names": ["BenchmarkCurvePoint"], "type": "STRING"},
        223: {"num": 223, "names": ["CouponRate"], "type": "PERCENTAGE"},
        224: {
            "num": 224,
            "names": ["CouponPaymentDate"],
            "type": "LOCALMKTDATE",
        },
        225: {"num": 225, "names": ["IssueDate"], "type": "LOCALMKTDATE"},
        226: {"num": 226, "names": ["RepurchaseTerm"], "type": "INT"},
        227: {"num": 227, "names": ["RepurchaseRate"], "type": "PERCENTAGE"},
        228: {"num": 228, "names": ["Factor"], "type": "FLOAT"},
        229: {
            "num": 229,
            "names": ["TradeOriginationDate"],
            "type": "LOCALMKTDATE",
        },
        230: {"num": 230, "names": ["ExDate"], "type": "LOCALMKTDATE"},
        231: {"num": 231, "names": ["ContractMultiplier"], "type": "FLOAT"},
        232: {"num": 232, "names": ["NoStipulations"], "type": "NUMINGROUP"},
        233: {
            "num": 233,
            "names": ["StipulationType"],
            "type": "STRING",
            "enum_type": True,
        },
        234: {"num": 234, "names": ["StipulationValue"], "type": "STRING"},
        235: {
            "num": 235,
            "names": ["YieldType"],
            "type": "STRING",
            "enum_type": True,
        },
        236: {"num": 236, "names": ["Yield"], "type": "PERCENTAGE"},
        237: {"num": 237, "names": ["TotalTakedown"], "type": "AMT"},
        238: {"num": 238, "names": ["Concession"], "type": "AMT"},
        239: {
            "num": 239,
            "names": ["RepoCollateralSecurityType"],
            "type": "STRING",
        },
        240: {"num": 240, "names": ["RedemptionDate"], "type": "LOCALMKTDATE"},
        241: {
            "num": 241,
            "names": ["UnderlyingCouponPaymentDate"],
            "type": "LOCALMKTDATE",
        },
        242: {
            "num": 242,
            "names": ["UnderlyingIssueDate"],
            "type": "LOCALMKTDATE",
        },
        243: {
            "num": 243,
            "names": ["UnderlyingRepoCollateralSecurityType"],
            "type": "STRING",
        },
        244: {
            "num": 244,
            "names": ["UnderlyingRepurchaseTerm"],
            "type": "INT",
        },
        245: {
            "num": 245,
            "names": ["UnderlyingRepurchaseRate"],
            "type": "PERCENTAGE",
        },
        246: {"num": 246, "names": ["UnderlyingFactor"], "type": "FLOAT"},
        247: {
            "num": 247,
            "names": ["UnderlyingRedemptionDate"],
            "type": "LOCALMKTDATE",
        },
        248: {
            "num": 248,
            "names": ["LegCouponPaymentDate"],
            "type": "LOCALMKTDATE",
        },
        249: {"num": 249, "names": ["LegIssueDate"], "type": "LOCALMKTDATE"},
        250: {
            "num": 250,
            "names": ["LegRepoCollateralSecurityType"],
            "type": "STRING",
        },
        251: {"num": 251, "names": ["LegRepurchaseTerm"], "type": "INT"},
        252: {
            "num": 252,
            "names": ["LegRepurchaseRate"],
            "type": "PERCENTAGE",
        },
        253: {"num": 253, "names": ["LegFactor"], "type": "FLOAT"},
        254: {
            "num": 254,
            "names": ["LegRedemptionDate"],
            "type": "LOCALMKTDATE",
        },
        255: {"num": 255, "names": ["CreditRating"], "type": "STRING"},
        256: {
            "num": 256,
            "names": ["UnderlyingCreditRating"],
            "type": "STRING",
        },
        257: {"num": 257, "names": ["LegCreditRating"], "type": "STRING"},
        258: {
            "num": 258,
            "names": ["TradedFlatSwitch"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        259: {
            "num": 259,
            "names": ["BasisFeatureDate"],
            "type": "LOCALMKTDATE",
        },
        260: {"num": 260, "names": ["BasisFeaturePrice"], "type": "PRICE"},
        262: {"num": 262, "names": ["MDReqID"], "type": "STRING"},
        263: {
            "num": 263,
            "names": ["SubscriptionRequestType"],
            "type": "CHAR",
            "enum_type": True,
        },
        264: {"num": 264, "names": ["MarketDepth"], "type": "INT"},
        265: {
            "num": 265,
            "names": ["MDUpdateType"],
            "type": "INT",
            "enum_type": True,
        },
        266: {
            "num": 266,
            "names": ["AggregatedBook"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        267: {"num": 267, "names": ["NoMDEntryTypes"], "type": "NUMINGROUP"},
        268: {"num": 268, "names": ["NoMDEntries"], "type": "NUMINGROUP"},
        269: {
            "num": 269,
            "names": ["MDEntryType"],
            "type": "CHAR",
            "enum_type": True,
        },
        270: {"num": 270, "names": ["MDEntryPx"], "type": "PRICE"},
        271: {"num": 271, "names": ["MDEntrySize"], "type": "QTY"},
        272: {"num": 272, "names": ["MDEntryDate"], "type": "UTCDATEONLY"},
        273: {"num": 273, "names": ["MDEntryTime"], "type": "UTCTIMEONLY"},
        274: {
            "num": 274,
            "names": ["TickDirection"],
            "type": "CHAR",
            "enum_type": True,
        },
        275: {"num": 275, "names": ["MDMkt"], "type": "EXCHANGE"},
        276: {
            "num": 276,
            "names": ["QuoteCondition"],
            "type": "MULTIPLESTRINGVALUE",
            "enum_type": True,
        },
        277: {
            "num": 277,
            "names": ["TradeCondition"],
            "type": "MULTIPLESTRINGVALUE",
            "enum_type": True,
        },
        278: {"num": 278, "names": ["MDEntryID"], "type": "STRING"},
        279: {
            "num": 279,
            "names": ["MDUpdateAction"],
            "type": "CHAR",
            "enum_type": True,
        },
        280: {"num": 280, "names": ["MDEntryRefID"], "type": "STRING"},
        281: {
            "num": 281,
            "names": ["MDReqRejReason"],
            "type": "CHAR",
            "enum_type": True,
        },
        282: {"num": 282, "names": ["MDEntryOriginator"], "type": "STRING"},
        283: {"num": 283, "names": ["LocationID"], "type": "STRING"},
        284: {"num": 284, "names": ["DeskID"], "type": "STRING"},
        285: {
            "num": 285,
            "names": ["DeleteReason"],
            "type": "CHAR",
            "enum_type": True,
        },
        286: {
            "num": 286,
            "names": ["OpenCloseSettlFlag"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        287: {"num": 287, "names": ["SellerDays"], "type": "INT"},
        288: {"num": 288, "names": ["MDEntryBuyer"], "type": "STRING"},
        289: {"num": 289, "names": ["MDEntrySeller"], "type": "STRING"},
        290: {"num": 290, "names": ["MDEntryPositionNo"], "type": "INT"},
        291: {
            "num": 291,
            "names": ["FinancialStatus"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        292: {
            "num": 292,
            "names": ["CorporateAction"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        293: {"num": 293, "names": ["DefBidSize"], "type": "QTY"},
        294: {"num": 294, "names": ["DefOfferSize"], "type": "QTY"},
        295: {"num": 295, "names": ["NoQuoteEntries"], "type": "NUMINGROUP"},
        296: {"num": 296, "names": ["NoQuoteSets"], "type": "NUMINGROUP"},
        297: {
            "num": 297,
            "names": ["QuoteStatus"],
            "type": "INT",
            "enum_type": True,
        },
        298: {
            "num": 298,
            "names": ["QuoteCancelType"],
            "type": "INT",
            "enum_type": True,
        },
        299: {"num": 299, "names": ["QuoteEntryID"], "type": "STRING"},
        300: {
            "num": 300,
            "names": ["QuoteRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        301: {
            "num": 301,
            "names": ["QuoteResponseLevel"],
            "type": "INT",
            "enum_type": True,
        },
        302: {"num": 302, "names": ["QuoteSetID"], "type": "STRING"},
        303: {
            "num": 303,
            "names": ["QuoteRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        304: {"num": 304, "names": ["TotNoQuoteEntries"], "type": "INT"},
        305: {
            "num": 305,
            "names": ["UnderlyingSecurityIDSource"],
            "type": "STRING",
        },
        306: {"num": 306, "names": ["UnderlyingIssuer"], "type": "STRING"},
        307: {
            "num": 307,
            "names": ["UnderlyingSecurityDesc"],
            "type": "STRING",
        },
        308: {
            "num": 308,
            "names": ["UnderlyingSecurityExchange"],
            "type": "EXCHANGE",
        },
        309: {"num": 309, "names": ["UnderlyingSecurityID"], "type": "STRING"},
        310: {
            "num": 310,
            "names": ["UnderlyingSecurityType"],
            "type": "STRING",
        },
        311: {"num": 311, "names": ["UnderlyingSymbol"], "type": "STRING"},
        312: {"num": 312, "names": ["UnderlyingSymbolSfx"], "type": "STRING"},
        313: {
            "num": 313,
            "names": ["UnderlyingMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        315: {"num": 315, "names": ["UnderlyingPutOrCall"], "type": "INT"},
        316: {"num": 316, "names": ["UnderlyingStrikePrice"], "type": "PRICE"},
        317: {"num": 317, "names": ["UnderlyingOptAttribute"], "type": "CHAR"},
        318: {"num": 318, "names": ["UnderlyingCurrency"], "type": "CURRENCY"},
        320: {"num": 320, "names": ["SecurityReqID"], "type": "STRING"},
        321: {
            "num": 321,
            "names": ["SecurityRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        322: {"num": 322, "names": ["SecurityResponseID"], "type": "STRING"},
        323: {
            "num": 323,
            "names": ["SecurityResponseType"],
            "type": "INT",
            "enum_type": True,
        },
        324: {"num": 324, "names": ["SecurityStatusReqID"], "type": "STRING"},
        325: {
            "num": 325,
            "names": ["UnsolicitedIndicator"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        326: {
            "num": 326,
            "names": ["SecurityTradingStatus"],
            "type": "INT",
            "enum_type": True,
        },
        327: {
            "num": 327,
            "names": ["HaltReasonInt"],
            "type": "INT",
            "enum_type": True,
        },
        328: {
            "num": 328,
            "names": ["InViewOfCommon"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        329: {
            "num": 329,
            "names": ["DueToRelated"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        330: {"num": 330, "names": ["BuyVolume"], "type": "QTY"},
        331: {"num": 331, "names": ["SellVolume"], "type": "QTY"},
        332: {"num": 332, "names": ["HighPx"], "type": "PRICE"},
        333: {"num": 333, "names": ["LowPx"], "type": "PRICE"},
        334: {
            "num": 334,
            "names": ["Adjustment"],
            "type": "INT",
            "enum_type": True,
        },
        335: {"num": 335, "names": ["TradSesReqID"], "type": "STRING"},
        336: {
            "num": 336,
            "names": ["TradingSessionID"],
            "type": "STRING",
            "enum_type": True,
        },
        337: {"num": 337, "names": ["ContraTrader"], "type": "STRING"},
        338: {
            "num": 338,
            "names": ["TradSesMethod"],
            "type": "INT",
            "enum_type": True,
        },
        339: {
            "num": 339,
            "names": ["TradSesMode"],
            "type": "INT",
            "enum_type": True,
        },
        340: {
            "num": 340,
            "names": ["TradSesStatus"],
            "type": "INT",
            "enum_type": True,
        },
        341: {
            "num": 341,
            "names": ["TradSesStartTime"],
            "type": "UTCTIMESTAMP",
        },
        342: {
            "num": 342,
            "names": ["TradSesOpenTime"],
            "type": "UTCTIMESTAMP",
        },
        343: {
            "num": 343,
            "names": ["TradSesPreCloseTime"],
            "type": "UTCTIMESTAMP",
        },
        344: {
            "num": 344,
            "names": ["TradSesCloseTime"],
            "type": "UTCTIMESTAMP",
        },
        345: {"num": 345, "names": ["TradSesEndTime"], "type": "UTCTIMESTAMP"},
        346: {"num": 346, "names": ["NumberOfOrders"], "type": "INT"},
        347: {"num": 347, "names": ["MessageEncoding"], "type": "STRING"},
        348: {"num": 348, "names": ["EncodedIssuerLen"], "type": "LENGTH"},
        349: {"num": 349, "names": ["EncodedIssuer"], "type": "DATA"},
        350: {
            "num": 350,
            "names": ["EncodedSecurityDescLen"],
            "type": "LENGTH",
        },
        351: {"num": 351, "names": ["EncodedSecurityDesc"], "type": "DATA"},
        352: {
            "num": 352,
            "names": ["EncodedListExecInstLen"],
            "type": "LENGTH",
        },
        353: {"num": 353, "names": ["EncodedListExecInst"], "type": "DATA"},
        354: {"num": 354, "names": ["EncodedTextLen"], "type": "LENGTH"},
        355: {"num": 355, "names": ["EncodedText"], "type": "DATA"},
        356: {"num": 356, "names": ["EncodedSubjectLen"], "type": "LENGTH"},
        357: {"num": 357, "names": ["EncodedSubject"], "type": "DATA"},
        358: {"num": 358, "names": ["EncodedHeadlineLen"], "type": "LENGTH"},
        359: {"num": 359, "names": ["EncodedHeadline"], "type": "DATA"},
        360: {"num": 360, "names": ["EncodedAllocTextLen"], "type": "LENGTH"},
        361: {"num": 361, "names": ["EncodedAllocText"], "type": "DATA"},
        362: {
            "num": 362,
            "names": ["EncodedUnderlyingIssuerLen"],
            "type": "LENGTH",
        },
        363: {
            "num": 363,
            "names": ["EncodedUnderlyingIssuer"],
            "type": "DATA",
        },
        364: {
            "num": 364,
            "names": ["EncodedUnderlyingSecurityDescLen"],
            "type": "LENGTH",
        },
        365: {
            "num": 365,
            "names": ["EncodedUnderlyingSecurityDesc"],
            "type": "DATA",
        },
        366: {"num": 366, "names": ["AllocPrice"], "type": "PRICE"},
        367: {
            "num": 367,
            "names": ["QuoteSetValidUntilTime"],
            "type": "UTCTIMESTAMP",
        },
        368: {"num": 368, "names": ["QuoteEntryRejectReason"], "type": "INT"},
        369: {
            "num": 369,
            "names": ["LastMsgSeqNumProcessed"],
            "type": "SEQNUM",
        },
        371: {"num": 371, "names": ["RefTagID"], "type": "INT"},
        372: {"num": 372, "names": ["RefMsgType"], "type": "STRING"},
        373: {
            "num": 373,
            "names": ["SessionRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        374: {
            "num": 374,
            "names": ["BidRequestTransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        375: {"num": 375, "names": ["ContraBroker"], "type": "STRING"},
        376: {"num": 376, "names": ["ComplianceID"], "type": "STRING"},
        377: {
            "num": 377,
            "names": ["SolicitedFlag"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        378: {
            "num": 378,
            "names": ["ExecRestatementReason"],
            "type": "INT",
            "enum_type": True,
        },
        379: {"num": 379, "names": ["BusinessRejectRefID"], "type": "STRING"},
        380: {
            "num": 380,
            "names": ["BusinessRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        381: {"num": 381, "names": ["GrossTradeAmt"], "type": "AMT"},
        382: {"num": 382, "names": ["NoContraBrokers"], "type": "NUMINGROUP"},
        383: {"num": 383, "names": ["MaxMessageSize"], "type": "LENGTH"},
        384: {"num": 384, "names": ["NoMsgTypes"], "type": "NUMINGROUP"},
        385: {
            "num": 385,
            "names": ["MsgDirection"],
            "type": "CHAR",
            "enum_type": True,
        },
        386: {
            "num": 386,
            "names": ["NoTradingSessions"],
            "type": "NUMINGROUP",
        },
        387: {"num": 387, "names": ["TotalVolumeTraded"], "type": "QTY"},
        388: {
            "num": 388,
            "names": ["DiscretionInst"],
            "type": "CHAR",
            "enum_type": True,
        },
        389: {"num": 389, "names": ["DiscretionOffsetValue"], "type": "FLOAT"},
        390: {"num": 390, "names": ["BidID"], "type": "STRING"},
        391: {"num": 391, "names": ["ClientBidID"], "type": "STRING"},
        392: {"num": 392, "names": ["ListName"], "type": "STRING"},
        393: {"num": 393, "names": ["TotNoRelatedSym"], "type": "INT"},
        394: {
            "num": 394,
            "names": ["BidType"],
            "type": "INT",
            "enum_type": True,
        },
        395: {"num": 395, "names": ["NumTickets"], "type": "INT"},
        396: {"num": 396, "names": ["SideValue1"], "type": "AMT"},
        397: {"num": 397, "names": ["SideValue2"], "type": "AMT"},
        398: {"num": 398, "names": ["NoBidDescriptors"], "type": "NUMINGROUP"},
        399: {
            "num": 399,
            "names": ["BidDescriptorType"],
            "type": "INT",
            "enum_type": True,
        },
        400: {"num": 400, "names": ["BidDescriptor"], "type": "STRING"},
        401: {
            "num": 401,
            "names": ["SideValueInd"],
            "type": "INT",
            "enum_type": True,
        },
        402: {"num": 402, "names": ["LiquidityPctLow"], "type": "PERCENTAGE"},
        403: {"num": 403, "names": ["LiquidityPctHigh"], "type": "PERCENTAGE"},
        404: {"num": 404, "names": ["LiquidityValue"], "type": "AMT"},
        405: {"num": 405, "names": ["EFPTrackingError"], "type": "PERCENTAGE"},
        406: {"num": 406, "names": ["FairValue"], "type": "AMT"},
        407: {"num": 407, "names": ["OutsideIndexPct"], "type": "PERCENTAGE"},
        408: {"num": 408, "names": ["ValueOfFutures"], "type": "AMT"},
        409: {
            "num": 409,
            "names": ["LiquidityIndType"],
            "type": "INT",
            "enum_type": True,
        },
        410: {
            "num": 410,
            "names": ["WtAverageLiquidity"],
            "type": "PERCENTAGE",
        },
        411: {
            "num": 411,
            "names": ["ExchangeForPhysical"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        412: {"num": 412, "names": ["OutMainCntryUIndex"], "type": "AMT"},
        413: {"num": 413, "names": ["CrossPercent"], "type": "PERCENTAGE"},
        414: {
            "num": 414,
            "names": ["ProgRptReqs"],
            "type": "INT",
            "enum_type": True,
        },
        415: {"num": 415, "names": ["ProgPeriodInterval"], "type": "INT"},
        416: {
            "num": 416,
            "names": ["IncTaxInd"],
            "type": "INT",
            "enum_type": True,
        },
        417: {"num": 417, "names": ["NumBidders"], "type": "INT"},
        418: {
            "num": 418,
            "names": ["BidTradeType"],
            "type": "CHAR",
            "enum_type": True,
        },
        419: {
            "num": 419,
            "names": ["BasisPxType"],
            "type": "CHAR",
            "enum_type": True,
        },
        420: {"num": 420, "names": ["NoBidComponents"], "type": "NUMINGROUP"},
        421: {"num": 421, "names": ["Country"], "type": "COUNTRY"},
        422: {"num": 422, "names": ["TotNoStrikes"], "type": "INT"},
        423: {
            "num": 423,
            "names": ["PriceType"],
            "type": "INT",
            "enum_type": True,
        },
        424: {"num": 424, "names": ["DayOrderQty"], "type": "QTY"},
        425: {"num": 425, "names": ["DayCumQty"], "type": "QTY"},
        426: {"num": 426, "names": ["DayAvgPx"], "type": "PRICE"},
        427: {
            "num": 427,
            "names": ["GTBookingInst"],
            "type": "INT",
            "enum_type": True,
        },
        428: {"num": 428, "names": ["NoStrikes"], "type": "NUMINGROUP"},
        429: {
            "num": 429,
            "names": ["ListStatusType"],
            "type": "INT",
            "enum_type": True,
        },
        430: {
            "num": 430,
            "names": ["NetGrossInd"],
            "type": "INT",
            "enum_type": True,
        },
        431: {
            "num": 431,
            "names": ["ListOrderStatus"],
            "type": "INT",
            "enum_type": True,
        },
        432: {"num": 432, "names": ["ExpireDate"], "type": "LOCALMKTDATE"},
        433: {
            "num": 433,
            "names": ["ListExecInstType"],
            "type": "CHAR",
            "enum_type": True,
        },
        434: {
            "num": 434,
            "names": ["CxlRejResponseTo"],
            "type": "CHAR",
            "enum_type": True,
        },
        435: {
            "num": 435,
            "names": ["UnderlyingCouponRate"],
            "type": "PERCENTAGE",
        },
        436: {
            "num": 436,
            "names": ["UnderlyingContractMultiplier"],
            "type": "FLOAT",
        },
        437: {"num": 437, "names": ["ContraTradeQty"], "type": "QTY"},
        438: {
            "num": 438,
            "names": ["ContraTradeTime"],
            "type": "UTCTIMESTAMP",
        },
        441: {"num": 441, "names": ["LiquidityNumSecurities"], "type": "INT"},
        442: {
            "num": 442,
            "names": ["MultiLegReportingType"],
            "type": "CHAR",
            "enum_type": True,
        },
        443: {"num": 443, "names": ["StrikeTime"], "type": "UTCTIMESTAMP"},
        444: {"num": 444, "names": ["ListStatusText"], "type": "STRING"},
        445: {
            "num": 445,
            "names": ["EncodedListStatusTextLen"],
            "type": "LENGTH",
        },
        446: {"num": 446, "names": ["EncodedListStatusText"], "type": "DATA"},
        447: {
            "num": 447,
            "names": ["PartyIDSource"],
            "type": "CHAR",
            "enum_type": True,
        },
        448: {"num": 448, "names": ["PartyID"], "type": "STRING"},
        451: {"num": 451, "names": ["NetChgPrevDay"], "type": "PRICEOFFSET"},
        452: {
            "num": 452,
            "names": ["PartyRole"],
            "type": "INT",
            "enum_type": True,
        },
        453: {"num": 453, "names": ["NoPartyIDs"], "type": "NUMINGROUP"},
        454: {"num": 454, "names": ["NoSecurityAltID"], "type": "NUMINGROUP"},
        455: {"num": 455, "names": ["SecurityAltID"], "type": "STRING"},
        456: {"num": 456, "names": ["SecurityAltIDSource"], "type": "STRING"},
        457: {
            "num": 457,
            "names": ["NoUnderlyingSecurityAltID"],
            "type": "NUMINGROUP",
        },
        458: {
            "num": 458,
            "names": ["UnderlyingSecurityAltID"],
            "type": "STRING",
        },
        459: {
            "num": 459,
            "names": ["UnderlyingSecurityAltIDSource"],
            "type": "STRING",
        },
        460: {
            "num": 460,
            "names": ["Product"],
            "type": "INT",
            "enum_type": True,
        },
        461: {"num": 461, "names": ["CFICode"], "type": "STRING"},
        462: {"num": 462, "names": ["UnderlyingProduct"], "type": "INT"},
        463: {"num": 463, "names": ["UnderlyingCFICode"], "type": "STRING"},
        464: {
            "num": 464,
            "names": ["TestMessageIndicator"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        466: {"num": 466, "names": ["BookingRefID"], "type": "STRING"},
        467: {"num": 467, "names": ["IndividualAllocID"], "type": "STRING"},
        468: {
            "num": 468,
            "names": ["RoundingDirection"],
            "type": "CHAR",
            "enum_type": True,
        },
        469: {"num": 469, "names": ["RoundingModulus"], "type": "FLOAT"},
        470: {"num": 470, "names": ["CountryOfIssue"], "type": "COUNTRY"},
        471: {
            "num": 471,
            "names": ["StateOrProvinceOfIssue"],
            "type": "STRING",
        },
        472: {"num": 472, "names": ["LocaleOfIssue"], "type": "STRING"},
        473: {"num": 473, "names": ["NoRegistDtls"], "type": "NUMINGROUP"},
        474: {"num": 474, "names": ["MailingDtls"], "type": "STRING"},
        475: {
            "num": 475,
            "names": ["InvestorCountryOfResidence"],
            "type": "COUNTRY",
        },
        476: {"num": 476, "names": ["PaymentRef"], "type": "STRING"},
        477: {
            "num": 477,
            "names": ["DistribPaymentMethod"],
            "type": "INT",
            "enum_type": True,
        },
        478: {"num": 478, "names": ["CashDistribCurr"], "type": "CURRENCY"},
        479: {"num": 479, "names": ["CommCurrency"], "type": "CURRENCY"},
        480: {
            "num": 480,
            "names": ["CancellationRights"],
            "type": "CHAR",
            "enum_type": True,
        },
        481: {
            "num": 481,
            "names": ["MoneyLaunderingStatus"],
            "type": "CHAR",
            "enum_type": True,
        },
        482: {"num": 482, "names": ["MailingInst"], "type": "STRING"},
        483: {"num": 483, "names": ["TransBkdTime"], "type": "UTCTIMESTAMP"},
        484: {
            "num": 484,
            "names": ["ExecPriceType"],
            "type": "CHAR",
            "enum_type": True,
        },
        485: {"num": 485, "names": ["ExecPriceAdjustment"], "type": "FLOAT"},
        486: {"num": 486, "names": ["DateOfBirth"], "type": "LOCALMKTDATE"},
        487: {
            "num": 487,
            "names": ["TradeReportTransType"],
            "type": "INT",
            "enum_type": True,
        },
        488: {"num": 488, "names": ["CardHolderName"], "type": "STRING"},
        489: {"num": 489, "names": ["CardNumber"], "type": "STRING"},
        490: {"num": 490, "names": ["CardExpDate"], "type": "LOCALMKTDATE"},
        491: {"num": 491, "names": ["CardIssNum"], "type": "STRING"},
        492: {
            "num": 492,
            "names": ["PaymentMethod"],
            "type": "INT",
            "enum_type": True,
        },
        493: {"num": 493, "names": ["RegistAcctType"], "type": "STRING"},
        494: {"num": 494, "names": ["Designation"], "type": "STRING"},
        495: {
            "num": 495,
            "names": ["TaxAdvantageType"],
            "type": "INT",
            "enum_type": True,
        },
        496: {"num": 496, "names": ["RegistRejReasonText"], "type": "STRING"},
        497: {
            "num": 497,
            "names": ["FundRenewWaiv"],
            "type": "CHAR",
            "enum_type": True,
        },
        498: {"num": 498, "names": ["CashDistribAgentName"], "type": "STRING"},
        499: {"num": 499, "names": ["CashDistribAgentCode"], "type": "STRING"},
        500: {
            "num": 500,
            "names": ["CashDistribAgentAcctNumber"],
            "type": "STRING",
        },
        501: {"num": 501, "names": ["CashDistribPayRef"], "type": "STRING"},
        502: {
            "num": 502,
            "names": ["CashDistribAgentAcctName"],
            "type": "STRING",
        },
        503: {"num": 503, "names": ["CardStartDate"], "type": "LOCALMKTDATE"},
        504: {"num": 504, "names": ["PaymentDate"], "type": "LOCALMKTDATE"},
        505: {"num": 505, "names": ["PaymentRemitterID"], "type": "STRING"},
        506: {
            "num": 506,
            "names": ["RegistStatus"],
            "type": "CHAR",
            "enum_type": True,
        },
        507: {
            "num": 507,
            "names": ["RegistRejReasonCode"],
            "type": "INT",
            "enum_type": True,
        },
        508: {"num": 508, "names": ["RegistRefID"], "type": "STRING"},
        509: {"num": 509, "names": ["RegistDtls"], "type": "STRING"},
        510: {"num": 510, "names": ["NoDistribInsts"], "type": "NUMINGROUP"},
        511: {"num": 511, "names": ["RegistEmail"], "type": "STRING"},
        512: {
            "num": 512,
            "names": ["DistribPercentage"],
            "type": "PERCENTAGE",
        },
        513: {"num": 513, "names": ["RegistID"], "type": "STRING"},
        514: {
            "num": 514,
            "names": ["RegistTransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        515: {
            "num": 515,
            "names": ["ExecValuationPoint"],
            "type": "UTCTIMESTAMP",
        },
        516: {"num": 516, "names": ["OrderPercent"], "type": "PERCENTAGE"},
        517: {
            "num": 517,
            "names": ["OwnershipType"],
            "type": "CHAR",
            "enum_type": True,
        },
        518: {"num": 518, "names": ["NoContAmts"], "type": "NUMINGROUP"},
        519: {
            "num": 519,
            "names": ["ContAmtType"],
            "type": "INT",
            "enum_type": True,
        },
        520: {"num": 520, "names": ["ContAmtValue"], "type": "FLOAT"},
        521: {"num": 521, "names": ["ContAmtCurr"], "type": "CURRENCY"},
        522: {
            "num": 522,
            "names": ["OwnerType"],
            "type": "INT",
            "enum_type": True,
        },
        523: {"num": 523, "names": ["PartySubID"], "type": "STRING"},
        524: {"num": 524, "names": ["NestedPartyID"], "type": "STRING"},
        525: {"num": 525, "names": ["NestedPartyIDSource"], "type": "CHAR"},
        526: {"num": 526, "names": ["SecondaryClOrdID"], "type": "STRING"},
        527: {"num": 527, "names": ["SecondaryExecID"], "type": "STRING"},
        528: {
            "num": 528,
            "names": ["OrderCapacity"],
            "type": "CHAR",
            "enum_type": True,
        },
        529: {
            "num": 529,
            "names": ["OrderRestrictions"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        530: {
            "num": 530,
            "names": ["MassCancelRequestType"],
            "type": "CHAR",
            "enum_type": True,
        },
        531: {
            "num": 531,
            "names": ["MassCancelResponse"],
            "type": "CHAR",
            "enum_type": True,
        },
        532: {
            "num": 532,
            "names": ["MassCancelRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        533: {"num": 533, "names": ["TotalAffectedOrders"], "type": "INT"},
        534: {"num": 534, "names": ["NoAffectedOrders"], "type": "NUMINGROUP"},
        535: {"num": 535, "names": ["AffectedOrderID"], "type": "STRING"},
        536: {
            "num": 536,
            "names": ["AffectedSecondaryOrderID"],
            "type": "STRING",
        },
        537: {
            "num": 537,
            "names": ["QuoteType"],
            "type": "INT",
            "enum_type": True,
        },
        538: {"num": 538, "names": ["NestedPartyRole"], "type": "INT"},
        539: {"num": 539, "names": ["NoNestedPartyIDs"], "type": "NUMINGROUP"},
        540: {"num": 540, "names": ["TotalAccruedInterestAmt"], "type": "AMT"},
        541: {"num": 541, "names": ["MaturityDate"], "type": "LOCALMKTDATE"},
        542: {
            "num": 542,
            "names": ["UnderlyingMaturityDate"],
            "type": "LOCALMKTDATE",
        },
        543: {"num": 543, "names": ["InstrRegistry"], "type": "STRING"},
        544: {
            "num": 544,
            "names": ["CashMargin"],
            "type": "CHAR",
            "enum_type": True,
        },
        545: {"num": 545, "names": ["NestedPartySubID"], "type": "STRING"},
        546: {
            "num": 546,
            "names": ["Scope"],
            "type": "MULTIPLECHARVALUE",
            "enum_type": True,
        },
        547: {
            "num": 547,
            "names": ["MDImplicitDelete"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        548: {"num": 548, "names": ["CrossID"], "type": "STRING"},
        549: {
            "num": 549,
            "names": ["CrossType"],
            "type": "INT",
            "enum_type": True,
        },
        550: {
            "num": 550,
            "names": ["CrossPrioritization"],
            "type": "INT",
            "enum_type": True,
        },
        551: {"num": 551, "names": ["OrigCrossID"], "type": "STRING"},
        552: {
            "num": 552,
            "names": ["NoSides"],
            "type": "NUMINGROUP",
            "enum_type": True,
        },
        553: {"num": 553, "names": ["Username"], "type": "STRING"},
        554: {"num": 554, "names": ["Password"], "type": "STRING"},
        555: {"num": 555, "names": ["NoLegs"], "type": "NUMINGROUP"},
        556: {"num": 556, "names": ["LegCurrency"], "type": "CURRENCY"},
        557: {"num": 557, "names": ["TotNoSecurityTypes"], "type": "INT"},
        558: {"num": 558, "names": ["NoSecurityTypes"], "type": "NUMINGROUP"},
        559: {
            "num": 559,
            "names": ["SecurityListRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        560: {
            "num": 560,
            "names": ["SecurityRequestResult"],
            "type": "INT",
            "enum_type": True,
        },
        561: {"num": 561, "names": ["RoundLot"], "type": "QTY"},
        562: {"num": 562, "names": ["MinTradeVol"], "type": "QTY"},
        563: {
            "num": 563,
            "names": ["MultiLegRptTypeReq"],
            "type": "INT",
            "enum_type": True,
        },
        564: {"num": 564, "names": ["LegPositionEffect"], "type": "CHAR"},
        565: {"num": 565, "names": ["LegCoveredOrUncovered"], "type": "INT"},
        566: {"num": 566, "names": ["LegPrice"], "type": "PRICE"},
        567: {
            "num": 567,
            "names": ["TradSesStatusRejReason"],
            "type": "INT",
            "enum_type": True,
        },
        568: {"num": 568, "names": ["TradeRequestID"], "type": "STRING"},
        569: {
            "num": 569,
            "names": ["TradeRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        570: {
            "num": 570,
            "names": ["PreviouslyReported"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        571: {"num": 571, "names": ["TradeReportID"], "type": "STRING"},
        572: {"num": 572, "names": ["TradeReportRefID"], "type": "STRING"},
        573: {
            "num": 573,
            "names": ["MatchStatus"],
            "type": "CHAR",
            "enum_type": True,
        },
        574: {
            "num": 574,
            "names": ["MatchType"],
            "type": "STRING",
            "enum_type": True,
        },
        575: {
            "num": 575,
            "names": ["OddLot"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        576: {
            "num": 576,
            "names": ["NoClearingInstructions"],
            "type": "NUMINGROUP",
        },
        577: {
            "num": 577,
            "names": ["ClearingInstruction"],
            "type": "INT",
            "enum_type": True,
        },
        578: {"num": 578, "names": ["TradeInputSource"], "type": "STRING"},
        579: {"num": 579, "names": ["TradeInputDevice"], "type": "STRING"},
        580: {"num": 580, "names": ["NoDates"], "type": "NUMINGROUP"},
        581: {
            "num": 581,
            "names": ["AccountType"],
            "type": "INT",
            "enum_type": True,
        },
        582: {
            "num": 582,
            "names": ["CustOrderCapacity"],
            "type": "INT",
            "enum_type": True,
        },
        583: {"num": 583, "names": ["ClOrdLinkID"], "type": "STRING"},
        584: {"num": 584, "names": ["MassStatusReqID"], "type": "STRING"},
        585: {
            "num": 585,
            "names": ["MassStatusReqType"],
            "type": "INT",
            "enum_type": True,
        },
        586: {"num": 586, "names": ["OrigOrdModTime"], "type": "UTCTIMESTAMP"},
        587: {"num": 587, "names": ["LegSettlType"], "type": "CHAR"},
        588: {"num": 588, "names": ["LegSettlDate"], "type": "LOCALMKTDATE"},
        589: {
            "num": 589,
            "names": ["DayBookingInst"],
            "type": "CHAR",
            "enum_type": True,
        },
        590: {
            "num": 590,
            "names": ["BookingUnit"],
            "type": "CHAR",
            "enum_type": True,
        },
        591: {
            "num": 591,
            "names": ["PreallocMethod"],
            "type": "CHAR",
            "enum_type": True,
        },
        592: {
            "num": 592,
            "names": ["UnderlyingCountryOfIssue"],
            "type": "COUNTRY",
        },
        593: {
            "num": 593,
            "names": ["UnderlyingStateOrProvinceOfIssue"],
            "type": "STRING",
        },
        594: {
            "num": 594,
            "names": ["UnderlyingLocaleOfIssue"],
            "type": "STRING",
        },
        595: {
            "num": 595,
            "names": ["UnderlyingInstrRegistry"],
            "type": "STRING",
        },
        596: {"num": 596, "names": ["LegCountryOfIssue"], "type": "COUNTRY"},
        597: {
            "num": 597,
            "names": ["LegStateOrProvinceOfIssue"],
            "type": "STRING",
        },
        598: {"num": 598, "names": ["LegLocaleOfIssue"], "type": "STRING"},
        599: {"num": 599, "names": ["LegInstrRegistry"], "type": "STRING"},
        600: {"num": 600, "names": ["LegSymbol"], "type": "STRING"},
        601: {"num": 601, "names": ["LegSymbolSfx"], "type": "STRING"},
        602: {"num": 602, "names": ["LegSecurityID"], "type": "STRING"},
        603: {"num": 603, "names": ["LegSecurityIDSource"], "type": "STRING"},
        604: {
            "num": 604,
            "names": ["NoLegSecurityAltID"],
            "type": "NUMINGROUP",
        },
        605: {"num": 605, "names": ["LegSecurityAltID"], "type": "STRING"},
        606: {
            "num": 606,
            "names": ["LegSecurityAltIDSource"],
            "type": "STRING",
        },
        607: {"num": 607, "names": ["LegProduct"], "type": "INT"},
        608: {"num": 608, "names": ["LegCFICode"], "type": "STRING"},
        609: {"num": 609, "names": ["LegSecurityType"], "type": "STRING"},
        610: {
            "num": 610,
            "names": ["LegMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        611: {
            "num": 611,
            "names": ["LegMaturityDate"],
            "type": "LOCALMKTDATE",
        },
        612: {"num": 612, "names": ["LegStrikePrice"], "type": "PRICE"},
        613: {"num": 613, "names": ["LegOptAttribute"], "type": "CHAR"},
        614: {"num": 614, "names": ["LegContractMultiplier"], "type": "FLOAT"},
        615: {"num": 615, "names": ["LegCouponRate"], "type": "PERCENTAGE"},
        616: {
            "num": 616,
            "names": ["LegSecurityExchange"],
            "type": "EXCHANGE",
        },
        617: {"num": 617, "names": ["LegIssuer"], "type": "STRING"},
        618: {"num": 618, "names": ["EncodedLegIssuerLen"], "type": "LENGTH"},
        619: {"num": 619, "names": ["EncodedLegIssuer"], "type": "DATA"},
        620: {"num": 620, "names": ["LegSecurityDesc"], "type": "STRING"},
        621: {
            "num": 621,
            "names": ["EncodedLegSecurityDescLen"],
            "type": "LENGTH",
        },
        622: {"num": 622, "names": ["EncodedLegSecurityDesc"], "type": "DATA"},
        623: {"num": 623, "names": ["LegRatioQty"], "type": "FLOAT"},
        624: {"num": 624, "names": ["LegSide"], "type": "CHAR"},
        625: {
            "num": 625,
            "names": ["TradingSessionSubID"],
            "type": "STRING",
            "enum_type": True,
        },
        626: {
            "num": 626,
            "names": ["AllocType"],
            "type": "INT",
            "enum_type": True,
        },
        627: {"num": 627, "names": ["NoHops"], "type": "NUMINGROUP"},
        628: {"num": 628, "names": ["HopCompID"], "type": "STRING"},
        629: {"num": 629, "names": ["HopSendingTime"], "type": "UTCTIMESTAMP"},
        630: {"num": 630, "names": ["HopRefID"], "type": "SEQNUM"},
        631: {"num": 631, "names": ["MidPx"], "type": "PRICE"},
        632: {"num": 632, "names": ["BidYield"], "type": "PERCENTAGE"},
        633: {"num": 633, "names": ["MidYield"], "type": "PERCENTAGE"},
        634: {"num": 634, "names": ["OfferYield"], "type": "PERCENTAGE"},
        635: {
            "num": 635,
            "names": ["ClearingFeeIndicator"],
            "type": "STRING",
            "enum_type": True,
        },
        636: {
            "num": 636,
            "names": ["WorkingIndicator"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        637: {"num": 637, "names": ["LegLastPx"], "type": "PRICE"},
        638: {
            "num": 638,
            "names": ["PriorityIndicator"],
            "type": "INT",
            "enum_type": True,
        },
        639: {
            "num": 639,
            "names": ["PriceImprovement"],
            "type": "PRICEOFFSET",
        },
        640: {"num": 640, "names": ["Price2"], "type": "PRICE"},
        641: {
            "num": 641,
            "names": ["LastForwardPoints2"],
            "type": "PRICEOFFSET",
        },
        642: {
            "num": 642,
            "names": ["BidForwardPoints2"],
            "type": "PRICEOFFSET",
        },
        643: {
            "num": 643,
            "names": ["OfferForwardPoints2"],
            "type": "PRICEOFFSET",
        },
        644: {"num": 644, "names": ["RFQReqID"], "type": "STRING"},
        645: {"num": 645, "names": ["MktBidPx"], "type": "PRICE"},
        646: {"num": 646, "names": ["MktOfferPx"], "type": "PRICE"},
        647: {"num": 647, "names": ["MinBidSize"], "type": "QTY"},
        648: {"num": 648, "names": ["MinOfferSize"], "type": "QTY"},
        649: {"num": 649, "names": ["QuoteStatusReqID"], "type": "STRING"},
        650: {
            "num": 650,
            "names": ["LegalConfirm"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        651: {"num": 651, "names": ["UnderlyingLastPx"], "type": "PRICE"},
        652: {"num": 652, "names": ["UnderlyingLastQty"], "type": "QTY"},
        654: {"num": 654, "names": ["LegRefID"], "type": "STRING"},
        655: {"num": 655, "names": ["ContraLegRefID"], "type": "STRING"},
        656: {"num": 656, "names": ["SettlCurrBidFxRate"], "type": "FLOAT"},
        657: {"num": 657, "names": ["SettlCurrOfferFxRate"], "type": "FLOAT"},
        658: {
            "num": 658,
            "names": ["QuoteRequestRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        659: {"num": 659, "names": ["SideComplianceID"], "type": "STRING"},
        660: {
            "num": 660,
            "names": ["AcctIDSource"],
            "type": "INT",
            "enum_type": True,
        },
        661: {"num": 661, "names": ["AllocAcctIDSource"], "type": "INT"},
        662: {"num": 662, "names": ["BenchmarkPrice"], "type": "PRICE"},
        663: {"num": 663, "names": ["BenchmarkPriceType"], "type": "INT"},
        664: {"num": 664, "names": ["ConfirmID"], "type": "STRING"},
        665: {
            "num": 665,
            "names": ["ConfirmStatus"],
            "type": "INT",
            "enum_type": True,
        },
        666: {
            "num": 666,
            "names": ["ConfirmTransType"],
            "type": "INT",
            "enum_type": True,
        },
        667: {
            "num": 667,
            "names": ["ContractSettlMonth"],
            "type": "MONTHYEAR",
        },
        668: {
            "num": 668,
            "names": ["DeliveryForm"],
            "type": "INT",
            "enum_type": True,
        },
        669: {"num": 669, "names": ["LastParPx"], "type": "PRICE"},
        670: {"num": 670, "names": ["NoLegAllocs"], "type": "NUMINGROUP"},
        671: {"num": 671, "names": ["LegAllocAccount"], "type": "STRING"},
        672: {"num": 672, "names": ["LegIndividualAllocID"], "type": "STRING"},
        673: {"num": 673, "names": ["LegAllocQty"], "type": "QTY"},
        674: {"num": 674, "names": ["LegAllocAcctIDSource"], "type": "STRING"},
        675: {"num": 675, "names": ["LegSettlCurrency"], "type": "CURRENCY"},
        676: {
            "num": 676,
            "names": ["LegBenchmarkCurveCurrency"],
            "type": "CURRENCY",
        },
        677: {
            "num": 677,
            "names": ["LegBenchmarkCurveName"],
            "type": "STRING",
        },
        678: {
            "num": 678,
            "names": ["LegBenchmarkCurvePoint"],
            "type": "STRING",
        },
        679: {"num": 679, "names": ["LegBenchmarkPrice"], "type": "PRICE"},
        680: {"num": 680, "names": ["LegBenchmarkPriceType"], "type": "INT"},
        681: {"num": 681, "names": ["LegBidPx"], "type": "PRICE"},
        682: {"num": 682, "names": ["LegIOIQty"], "type": "STRING"},
        683: {
            "num": 683,
            "names": ["NoLegStipulations"],
            "type": "NUMINGROUP",
        },
        684: {"num": 684, "names": ["LegOfferPx"], "type": "PRICE"},
        685: {"num": 685, "names": ["LegOrderQty"], "type": "QTY"},
        686: {"num": 686, "names": ["LegPriceType"], "type": "INT"},
        687: {"num": 687, "names": ["LegQty"], "type": "QTY"},
        688: {"num": 688, "names": ["LegStipulationType"], "type": "STRING"},
        689: {"num": 689, "names": ["LegStipulationValue"], "type": "STRING"},
        690: {
            "num": 690,
            "names": ["LegSwapType"],
            "type": "INT",
            "enum_type": True,
        },
        691: {"num": 691, "names": ["Pool"], "type": "STRING"},
        692: {
            "num": 692,
            "names": ["QuotePriceType"],
            "type": "INT",
            "enum_type": True,
        },
        693: {"num": 693, "names": ["QuoteRespID"], "type": "STRING"},
        694: {
            "num": 694,
            "names": ["QuoteRespType"],
            "type": "INT",
            "enum_type": True,
        },
        695: {"num": 695, "names": ["QuoteQualifier"], "type": "CHAR"},
        696: {
            "num": 696,
            "names": ["YieldRedemptionDate"],
            "type": "LOCALMKTDATE",
        },
        697: {"num": 697, "names": ["YieldRedemptionPrice"], "type": "PRICE"},
        698: {
            "num": 698,
            "names": ["YieldRedemptionPriceType"],
            "type": "INT",
        },
        699: {"num": 699, "names": ["BenchmarkSecurityID"], "type": "STRING"},
        700: {"num": 700, "names": ["ReversalIndicator"], "type": "BOOLEAN"},
        701: {"num": 701, "names": ["YieldCalcDate"], "type": "LOCALMKTDATE"},
        702: {"num": 702, "names": ["NoPositions"], "type": "NUMINGROUP"},
        703: {
            "num": 703,
            "names": ["PosType"],
            "type": "STRING",
            "enum_type": True,
        },
        704: {"num": 704, "names": ["LongQty"], "type": "QTY"},
        705: {"num": 705, "names": ["ShortQty"], "type": "QTY"},
        706: {
            "num": 706,
            "names": ["PosQtyStatus"],
            "type": "INT",
            "enum_type": True,
        },
        707: {
            "num": 707,
            "names": ["PosAmtType"],
            "type": "STRING",
            "enum_type": True,
        },
        708: {"num": 708, "names": ["PosAmt"], "type": "AMT"},
        709: {
            "num": 709,
            "names": ["PosTransType"],
            "type": "INT",
            "enum_type": True,
        },
        710: {"num": 710, "names": ["PosReqID"], "type": "STRING"},
        711: {"num": 711, "names": ["NoUnderlyings"], "type": "NUMINGROUP"},
        712: {
            "num": 712,
            "names": ["PosMaintAction"],
            "type": "INT",
            "enum_type": True,
        },
        713: {"num": 713, "names": ["OrigPosReqRefID"], "type": "STRING"},
        714: {"num": 714, "names": ["PosMaintRptRefID"], "type": "STRING"},
        715: {
            "num": 715,
            "names": ["ClearingBusinessDate"],
            "type": "LOCALMKTDATE",
        },
        716: {
            "num": 716,
            "names": ["SettlSessID"],
            "type": "STRING",
            "enum_type": True,
        },
        717: {"num": 717, "names": ["SettlSessSubID"], "type": "STRING"},
        718: {
            "num": 718,
            "names": ["AdjustmentType"],
            "type": "INT",
            "enum_type": True,
        },
        719: {
            "num": 719,
            "names": ["ContraryInstructionIndicator"],
            "type": "BOOLEAN",
        },
        720: {
            "num": 720,
            "names": ["PriorSpreadIndicator"],
            "type": "BOOLEAN",
        },
        721: {"num": 721, "names": ["PosMaintRptID"], "type": "STRING"},
        722: {
            "num": 722,
            "names": ["PosMaintStatus"],
            "type": "INT",
            "enum_type": True,
        },
        723: {
            "num": 723,
            "names": ["PosMaintResult"],
            "type": "INT",
            "enum_type": True,
        },
        724: {
            "num": 724,
            "names": ["PosReqType"],
            "type": "INT",
            "enum_type": True,
        },
        725: {
            "num": 725,
            "names": ["ResponseTransportType"],
            "type": "INT",
            "enum_type": True,
        },
        726: {"num": 726, "names": ["ResponseDestination"], "type": "STRING"},
        727: {"num": 727, "names": ["TotalNumPosReports"], "type": "INT"},
        728: {
            "num": 728,
            "names": ["PosReqResult"],
            "type": "INT",
            "enum_type": True,
        },
        729: {
            "num": 729,
            "names": ["PosReqStatus"],
            "type": "INT",
            "enum_type": True,
        },
        730: {"num": 730, "names": ["SettlPrice"], "type": "PRICE"},
        731: {
            "num": 731,
            "names": ["SettlPriceType"],
            "type": "INT",
            "enum_type": True,
        },
        732: {"num": 732, "names": ["UnderlyingSettlPrice"], "type": "PRICE"},
        733: {
            "num": 733,
            "names": ["UnderlyingSettlPriceType"],
            "type": "INT",
        },
        734: {"num": 734, "names": ["PriorSettlPrice"], "type": "PRICE"},
        735: {
            "num": 735,
            "names": ["NoQuoteQualifiers"],
            "type": "NUMINGROUP",
        },
        736: {"num": 736, "names": ["AllocSettlCurrency"], "type": "CURRENCY"},
        737: {"num": 737, "names": ["AllocSettlCurrAmt"], "type": "AMT"},
        738: {"num": 738, "names": ["InterestAtMaturity"], "type": "AMT"},
        739: {"num": 739, "names": ["LegDatedDate"], "type": "LOCALMKTDATE"},
        740: {"num": 740, "names": ["LegPool"], "type": "STRING"},
        741: {"num": 741, "names": ["AllocInterestAtMaturity"], "type": "AMT"},
        742: {"num": 742, "names": ["AllocAccruedInterestAmt"], "type": "AMT"},
        743: {"num": 743, "names": ["DeliveryDate"], "type": "LOCALMKTDATE"},
        744: {
            "num": 744,
            "names": ["AssignmentMethod"],
            "type": "CHAR",
            "enum_type": True,
        },
        745: {"num": 745, "names": ["AssignmentUnit"], "type": "QTY"},
        746: {"num": 746, "names": ["OpenInterest"], "type": "AMT"},
        747: {
            "num": 747,
            "names": ["ExerciseMethod"],
            "type": "CHAR",
            "enum_type": True,
        },
        748: {"num": 748, "names": ["TotNumTradeReports"], "type": "INT"},
        749: {
            "num": 749,
            "names": ["TradeRequestResult"],
            "type": "INT",
            "enum_type": True,
        },
        750: {
            "num": 750,
            "names": ["TradeRequestStatus"],
            "type": "INT",
            "enum_type": True,
        },
        751: {
            "num": 751,
            "names": ["TradeReportRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        752: {
            "num": 752,
            "names": ["SideMultiLegReportingType"],
            "type": "INT",
            "enum_type": True,
        },
        753: {"num": 753, "names": ["NoPosAmt"], "type": "NUMINGROUP"},
        754: {"num": 754, "names": ["AutoAcceptIndicator"], "type": "BOOLEAN"},
        755: {"num": 755, "names": ["AllocReportID"], "type": "STRING"},
        756: {
            "num": 756,
            "names": ["NoNested2PartyIDs"],
            "type": "NUMINGROUP",
        },
        757: {"num": 757, "names": ["Nested2PartyID"], "type": "STRING"},
        758: {"num": 758, "names": ["Nested2PartyIDSource"], "type": "CHAR"},
        759: {"num": 759, "names": ["Nested2PartyRole"], "type": "INT"},
        760: {"num": 760, "names": ["Nested2PartySubID"], "type": "STRING"},
        761: {
            "num": 761,
            "names": ["BenchmarkSecurityIDSource"],
            "type": "STRING",
        },
        762: {"num": 762, "names": ["SecuritySubType"], "type": "STRING"},
        763: {
            "num": 763,
            "names": ["UnderlyingSecuritySubType"],
            "type": "STRING",
        },
        764: {"num": 764, "names": ["LegSecuritySubType"], "type": "STRING"},
        765: {
            "num": 765,
            "names": ["AllowableOneSidednessPct"],
            "type": "PERCENTAGE",
        },
        766: {
            "num": 766,
            "names": ["AllowableOneSidednessValue"],
            "type": "AMT",
        },
        767: {
            "num": 767,
            "names": ["AllowableOneSidednessCurr"],
            "type": "CURRENCY",
        },
        768: {
            "num": 768,
            "names": ["NoTrdRegTimestamps"],
            "type": "NUMINGROUP",
        },
        769: {
            "num": 769,
            "names": ["TrdRegTimestamp"],
            "type": "UTCTIMESTAMP",
        },
        770: {
            "num": 770,
            "names": ["TrdRegTimestampType"],
            "type": "INT",
            "enum_type": True,
        },
        771: {
            "num": 771,
            "names": ["TrdRegTimestampOrigin"],
            "type": "STRING",
        },
        772: {"num": 772, "names": ["ConfirmRefID"], "type": "STRING"},
        773: {
            "num": 773,
            "names": ["ConfirmType"],
            "type": "INT",
            "enum_type": True,
        },
        774: {
            "num": 774,
            "names": ["ConfirmRejReason"],
            "type": "INT",
            "enum_type": True,
        },
        775: {
            "num": 775,
            "names": ["BookingType"],
            "type": "INT",
            "enum_type": True,
        },
        776: {"num": 776, "names": ["IndividualAllocRejCode"], "type": "INT"},
        777: {"num": 777, "names": ["SettlInstMsgID"], "type": "STRING"},
        778: {"num": 778, "names": ["NoSettlInst"], "type": "NUMINGROUP"},
        779: {"num": 779, "names": ["LastUpdateTime"], "type": "UTCTIMESTAMP"},
        780: {
            "num": 780,
            "names": ["AllocSettlInstType"],
            "type": "INT",
            "enum_type": True,
        },
        781: {"num": 781, "names": ["NoSettlPartyIDs"], "type": "NUMINGROUP"},
        782: {"num": 782, "names": ["SettlPartyID"], "type": "STRING"},
        783: {"num": 783, "names": ["SettlPartyIDSource"], "type": "CHAR"},
        784: {"num": 784, "names": ["SettlPartyRole"], "type": "INT"},
        785: {"num": 785, "names": ["SettlPartySubID"], "type": "STRING"},
        786: {"num": 786, "names": ["SettlPartySubIDType"], "type": "INT"},
        787: {
            "num": 787,
            "names": ["DlvyInstType"],
            "type": "CHAR",
            "enum_type": True,
        },
        788: {
            "num": 788,
            "names": ["TerminationType"],
            "type": "INT",
            "enum_type": True,
        },
        789: {
            "num": 789,
            "names": ["NextExpectedMsgSeqNum"],
            "type": "SEQNUM",
        },
        790: {"num": 790, "names": ["OrdStatusReqID"], "type": "STRING"},
        791: {"num": 791, "names": ["SettlInstReqID"], "type": "STRING"},
        792: {
            "num": 792,
            "names": ["SettlInstReqRejCode"],
            "type": "INT",
            "enum_type": True,
        },
        793: {"num": 793, "names": ["SecondaryAllocID"], "type": "STRING"},
        794: {
            "num": 794,
            "names": ["AllocReportType"],
            "type": "INT",
            "enum_type": True,
        },
        795: {"num": 795, "names": ["AllocReportRefID"], "type": "STRING"},
        796: {
            "num": 796,
            "names": ["AllocCancReplaceReason"],
            "type": "INT",
            "enum_type": True,
        },
        797: {"num": 797, "names": ["CopyMsgIndicator"], "type": "BOOLEAN"},
        798: {
            "num": 798,
            "names": ["AllocAccountType"],
            "type": "INT",
            "enum_type": True,
        },
        799: {"num": 799, "names": ["OrderAvgPx"], "type": "PRICE"},
        800: {"num": 800, "names": ["OrderBookingQty"], "type": "QTY"},
        801: {
            "num": 801,
            "names": ["NoSettlPartySubIDs"],
            "type": "NUMINGROUP",
        },
        802: {"num": 802, "names": ["NoPartySubIDs"], "type": "NUMINGROUP"},
        803: {
            "num": 803,
            "names": ["PartySubIDType"],
            "type": "INT",
            "enum_type": True,
        },
        804: {
            "num": 804,
            "names": ["NoNestedPartySubIDs"],
            "type": "NUMINGROUP",
        },
        805: {"num": 805, "names": ["NestedPartySubIDType"], "type": "INT"},
        806: {
            "num": 806,
            "names": ["NoNested2PartySubIDs"],
            "type": "NUMINGROUP",
        },
        807: {"num": 807, "names": ["Nested2PartySubIDType"], "type": "INT"},
        808: {
            "num": 808,
            "names": ["AllocIntermedReqType"],
            "type": "INT",
            "enum_type": True,
        },
        810: {"num": 810, "names": ["UnderlyingPx"], "type": "PRICE"},
        811: {"num": 811, "names": ["PriceDelta"], "type": "FLOAT"},
        812: {"num": 812, "names": ["ApplQueueMax"], "type": "INT"},
        813: {"num": 813, "names": ["ApplQueueDepth"], "type": "INT"},
        814: {
            "num": 814,
            "names": ["ApplQueueResolution"],
            "type": "INT",
            "enum_type": True,
        },
        815: {
            "num": 815,
            "names": ["ApplQueueAction"],
            "type": "INT",
            "enum_type": True,
        },
        816: {"num": 816, "names": ["NoAltMDSource"], "type": "NUMINGROUP"},
        817: {"num": 817, "names": ["AltMDSourceID"], "type": "STRING"},
        818: {
            "num": 818,
            "names": ["SecondaryTradeReportID"],
            "type": "STRING",
        },
        819: {
            "num": 819,
            "names": ["AvgPxIndicator"],
            "type": "INT",
            "enum_type": True,
        },
        820: {"num": 820, "names": ["TradeLinkID"], "type": "STRING"},
        821: {"num": 821, "names": ["OrderInputDevice"], "type": "STRING"},
        822: {
            "num": 822,
            "names": ["UnderlyingTradingSessionID"],
            "type": "STRING",
        },
        823: {
            "num": 823,
            "names": ["UnderlyingTradingSessionSubID"],
            "type": "STRING",
        },
        824: {"num": 824, "names": ["TradeLegRefID"], "type": "STRING"},
        825: {"num": 825, "names": ["ExchangeRule"], "type": "STRING"},
        826: {
            "num": 826,
            "names": ["TradeAllocIndicator"],
            "type": "INT",
            "enum_type": True,
        },
        827: {
            "num": 827,
            "names": ["ExpirationCycle"],
            "type": "INT",
            "enum_type": True,
        },
        828: {
            "num": 828,
            "names": ["TrdType"],
            "type": "INT",
            "enum_type": True,
        },
        829: {
            "num": 829,
            "names": ["TrdSubType"],
            "type": "INT",
            "enum_type": True,
        },
        830: {"num": 830, "names": ["TransferReason"], "type": "STRING"},
        832: {"num": 832, "names": ["TotNumAssignmentReports"], "type": "INT"},
        833: {"num": 833, "names": ["AsgnRptID"], "type": "STRING"},
        834: {"num": 834, "names": ["ThresholdAmount"], "type": "PRICEOFFSET"},
        835: {
            "num": 835,
            "names": ["PegMoveType"],
            "type": "INT",
            "enum_type": True,
        },
        836: {
            "num": 836,
            "names": ["PegOffsetType"],
            "type": "INT",
            "enum_type": True,
        },
        837: {
            "num": 837,
            "names": ["PegLimitType"],
            "type": "INT",
            "enum_type": True,
        },
        838: {
            "num": 838,
            "names": ["PegRoundDirection"],
            "type": "INT",
            "enum_type": True,
        },
        839: {"num": 839, "names": ["PeggedPrice"], "type": "PRICE"},
        840: {
            "num": 840,
            "names": ["PegScope"],
            "type": "INT",
            "enum_type": True,
        },
        841: {
            "num": 841,
            "names": ["DiscretionMoveType"],
            "type": "INT",
            "enum_type": True,
        },
        842: {
            "num": 842,
            "names": ["DiscretionOffsetType"],
            "type": "INT",
            "enum_type": True,
        },
        843: {
            "num": 843,
            "names": ["DiscretionLimitType"],
            "type": "INT",
            "enum_type": True,
        },
        844: {
            "num": 844,
            "names": ["DiscretionRoundDirection"],
            "type": "INT",
            "enum_type": True,
        },
        845: {"num": 845, "names": ["DiscretionPrice"], "type": "PRICE"},
        846: {
            "num": 846,
            "names": ["DiscretionScope"],
            "type": "INT",
            "enum_type": True,
        },
        847: {
            "num": 847,
            "names": ["TargetStrategy"],
            "type": "INT",
            "enum_type": True,
        },
        848: {
            "num": 848,
            "names": ["TargetStrategyParameters"],
            "type": "STRING",
        },
        849: {
            "num": 849,
            "names": ["ParticipationRate"],
            "type": "PERCENTAGE",
        },
        850: {
            "num": 850,
            "names": ["TargetStrategyPerformance"],
            "type": "FLOAT",
        },
        851: {
            "num": 851,
            "names": ["LastLiquidityInd"],
            "type": "INT",
            "enum_type": True,
        },
        852: {
            "num": 852,
            "names": ["PublishTrdIndicator"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        853: {
            "num": 853,
            "names": ["ShortSaleReason"],
            "type": "INT",
            "enum_type": True,
        },
        854: {
            "num": 854,
            "names": ["QtyType"],
            "type": "INT",
            "enum_type": True,
        },
        855: {"num": 855, "names": ["SecondaryTrdType"], "type": "INT"},
        856: {
            "num": 856,
            "names": ["TradeReportType"],
            "type": "INT",
            "enum_type": True,
        },
        857: {
            "num": 857,
            "names": ["AllocNoOrdersType"],
            "type": "INT",
            "enum_type": True,
        },
        858: {"num": 858, "names": ["SharedCommission"], "type": "AMT"},
        859: {"num": 859, "names": ["ConfirmReqID"], "type": "STRING"},
        860: {"num": 860, "names": ["AvgParPx"], "type": "PRICE"},
        861: {"num": 861, "names": ["ReportedPx"], "type": "PRICE"},
        862: {"num": 862, "names": ["NoCapacities"], "type": "NUMINGROUP"},
        863: {"num": 863, "names": ["OrderCapacityQty"], "type": "QTY"},
        864: {"num": 864, "names": ["NoEvents"], "type": "NUMINGROUP"},
        865: {
            "num": 865,
            "names": ["EventType"],
            "type": "INT",
            "enum_type": True,
        },
        866: {"num": 866, "names": ["EventDate"], "type": "LOCALMKTDATE"},
        867: {"num": 867, "names": ["EventPx"], "type": "PRICE"},
        868: {"num": 868, "names": ["EventText"], "type": "STRING"},
        869: {"num": 869, "names": ["PctAtRisk"], "type": "PERCENTAGE"},
        870: {"num": 870, "names": ["NoInstrAttrib"], "type": "NUMINGROUP"},
        871: {
            "num": 871,
            "names": ["InstrAttribType"],
            "type": "INT",
            "enum_type": True,
        },
        872: {"num": 872, "names": ["InstrAttribValue"], "type": "STRING"},
        873: {"num": 873, "names": ["DatedDate"], "type": "LOCALMKTDATE"},
        874: {
            "num": 874,
            "names": ["InterestAccrualDate"],
            "type": "LOCALMKTDATE",
        },
        875: {
            "num": 875,
            "names": ["CPProgram"],
            "type": "INT",
            "enum_type": True,
        },
        876: {"num": 876, "names": ["CPRegType"], "type": "STRING"},
        877: {"num": 877, "names": ["UnderlyingCPProgram"], "type": "STRING"},
        878: {"num": 878, "names": ["UnderlyingCPRegType"], "type": "STRING"},
        879: {"num": 879, "names": ["UnderlyingQty"], "type": "QTY"},
        880: {"num": 880, "names": ["TrdMatchID"], "type": "STRING"},
        881: {
            "num": 881,
            "names": ["SecondaryTradeReportRefID"],
            "type": "STRING",
        },
        882: {"num": 882, "names": ["UnderlyingDirtyPrice"], "type": "PRICE"},
        883: {"num": 883, "names": ["UnderlyingEndPrice"], "type": "PRICE"},
        884: {"num": 884, "names": ["UnderlyingStartValue"], "type": "AMT"},
        885: {"num": 885, "names": ["UnderlyingCurrentValue"], "type": "AMT"},
        886: {"num": 886, "names": ["UnderlyingEndValue"], "type": "AMT"},
        887: {
            "num": 887,
            "names": ["NoUnderlyingStips"],
            "type": "NUMINGROUP",
        },
        888: {"num": 888, "names": ["UnderlyingStipType"], "type": "STRING"},
        889: {"num": 889, "names": ["UnderlyingStipValue"], "type": "STRING"},
        890: {"num": 890, "names": ["MaturityNetMoney"], "type": "AMT"},
        891: {
            "num": 891,
            "names": ["MiscFeeBasis"],
            "type": "INT",
            "enum_type": True,
        },
        892: {"num": 892, "names": ["TotNoAllocs"], "type": "INT"},
        893: {
            "num": 893,
            "names": ["LastFragment"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        894: {"num": 894, "names": ["CollReqID"], "type": "STRING"},
        895: {
            "num": 895,
            "names": ["CollAsgnReason"],
            "type": "INT",
            "enum_type": True,
        },
        896: {
            "num": 896,
            "names": ["CollInquiryQualifier"],
            "type": "INT",
            "enum_type": True,
        },
        897: {"num": 897, "names": ["NoTrades"], "type": "NUMINGROUP"},
        898: {"num": 898, "names": ["MarginRatio"], "type": "PERCENTAGE"},
        899: {"num": 899, "names": ["MarginExcess"], "type": "AMT"},
        900: {"num": 900, "names": ["TotalNetValue"], "type": "AMT"},
        901: {"num": 901, "names": ["CashOutstanding"], "type": "AMT"},
        902: {"num": 902, "names": ["CollAsgnID"], "type": "STRING"},
        903: {
            "num": 903,
            "names": ["CollAsgnTransType"],
            "type": "INT",
            "enum_type": True,
        },
        904: {"num": 904, "names": ["CollRespID"], "type": "STRING"},
        905: {
            "num": 905,
            "names": ["CollAsgnRespType"],
            "type": "INT",
            "enum_type": True,
        },
        906: {
            "num": 906,
            "names": ["CollAsgnRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        907: {"num": 907, "names": ["CollAsgnRefID"], "type": "STRING"},
        908: {"num": 908, "names": ["CollRptID"], "type": "STRING"},
        909: {"num": 909, "names": ["CollInquiryID"], "type": "STRING"},
        910: {
            "num": 910,
            "names": ["CollStatus"],
            "type": "INT",
            "enum_type": True,
        },
        911: {"num": 911, "names": ["TotNumReports"], "type": "INT"},
        912: {
            "num": 912,
            "names": ["LastRptRequested"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        913: {"num": 913, "names": ["AgreementDesc"], "type": "STRING"},
        914: {"num": 914, "names": ["AgreementID"], "type": "STRING"},
        915: {"num": 915, "names": ["AgreementDate"], "type": "LOCALMKTDATE"},
        916: {"num": 916, "names": ["StartDate"], "type": "LOCALMKTDATE"},
        917: {"num": 917, "names": ["EndDate"], "type": "LOCALMKTDATE"},
        918: {"num": 918, "names": ["AgreementCurrency"], "type": "CURRENCY"},
        919: {
            "num": 919,
            "names": ["DeliveryType"],
            "type": "INT",
            "enum_type": True,
        },
        920: {"num": 920, "names": ["EndAccruedInterestAmt"], "type": "AMT"},
        921: {"num": 921, "names": ["StartCash"], "type": "AMT"},
        922: {"num": 922, "names": ["EndCash"], "type": "AMT"},
        923: {"num": 923, "names": ["UserRequestID"], "type": "STRING"},
        924: {
            "num": 924,
            "names": ["UserRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        925: {"num": 925, "names": ["NewPassword"], "type": "STRING"},
        926: {
            "num": 926,
            "names": ["UserStatus"],
            "type": "INT",
            "enum_type": True,
        },
        927: {"num": 927, "names": ["UserStatusText"], "type": "STRING"},
        928: {
            "num": 928,
            "names": ["StatusValue"],
            "type": "INT",
            "enum_type": True,
        },
        929: {"num": 929, "names": ["StatusText"], "type": "STRING"},
        930: {"num": 930, "names": ["RefCompID"], "type": "STRING"},
        931: {"num": 931, "names": ["RefSubID"], "type": "STRING"},
        932: {"num": 932, "names": ["NetworkResponseID"], "type": "STRING"},
        933: {"num": 933, "names": ["NetworkRequestID"], "type": "STRING"},
        934: {
            "num": 934,
            "names": ["LastNetworkResponseID"],
            "type": "STRING",
        },
        935: {
            "num": 935,
            "names": ["NetworkRequestType"],
            "type": "INT",
            "enum_type": True,
        },
        936: {"num": 936, "names": ["NoCompIDs"], "type": "NUMINGROUP"},
        937: {
            "num": 937,
            "names": ["NetworkStatusResponseType"],
            "type": "INT",
            "enum_type": True,
        },
        938: {
            "num": 938,
            "names": ["NoCollInquiryQualifier"],
            "type": "NUMINGROUP",
        },
        939: {
            "num": 939,
            "names": ["TrdRptStatus"],
            "type": "INT",
            "enum_type": True,
        },
        940: {
            "num": 940,
            "names": ["AffirmStatus"],
            "type": "INT",
            "enum_type": True,
        },
        941: {
            "num": 941,
            "names": ["UnderlyingStrikeCurrency"],
            "type": "CURRENCY",
        },
        942: {"num": 942, "names": ["LegStrikeCurrency"], "type": "CURRENCY"},
        943: {"num": 943, "names": ["TimeBracket"], "type": "STRING"},
        944: {
            "num": 944,
            "names": ["CollAction"],
            "type": "INT",
            "enum_type": True,
        },
        945: {
            "num": 945,
            "names": ["CollInquiryStatus"],
            "type": "INT",
            "enum_type": True,
        },
        946: {
            "num": 946,
            "names": ["CollInquiryResult"],
            "type": "INT",
            "enum_type": True,
        },
        947: {"num": 947, "names": ["StrikeCurrency"], "type": "CURRENCY"},
        948: {
            "num": 948,
            "names": ["NoNested3PartyIDs"],
            "type": "NUMINGROUP",
        },
        949: {"num": 949, "names": ["Nested3PartyID"], "type": "STRING"},
        950: {"num": 950, "names": ["Nested3PartyIDSource"], "type": "CHAR"},
        951: {"num": 951, "names": ["Nested3PartyRole"], "type": "INT"},
        952: {
            "num": 952,
            "names": ["NoNested3PartySubIDs"],
            "type": "NUMINGROUP",
        },
        953: {"num": 953, "names": ["Nested3PartySubID"], "type": "STRING"},
        954: {"num": 954, "names": ["Nested3PartySubIDType"], "type": "INT"},
        955: {
            "num": 955,
            "names": ["LegContractSettlMonth"],
            "type": "MONTHYEAR",
        },
        956: {
            "num": 956,
            "names": ["LegInterestAccrualDate"],
            "type": "LOCALMKTDATE",
        },
        957: {
            "num": 957,
            "names": ["NoStrategyParameters"],
            "type": "NUMINGROUP",
        },
        958: {
            "num": 958,
            "names": ["StrategyParameterName"],
            "type": "STRING",
        },
        959: {
            "num": 959,
            "names": ["StrategyParameterType"],
            "type": "INT",
            "enum_type": True,
        },
        960: {
            "num": 960,
            "names": ["StrategyParameterValue"],
            "type": "STRING",
        },
        961: {"num": 961, "names": ["HostCrossID"], "type": "STRING"},
        962: {
            "num": 962,
            "names": ["SideTimeInForce"],
            "type": "UTCTIMESTAMP",
        },
        963: {"num": 963, "names": ["MDReportID"], "type": "INT"},
        964: {"num": 964, "names": ["SecurityReportID"], "type": "INT"},
        965: {
            "num": 965,
            "names": ["SecurityStatus"],
            "type": "STRING",
            "enum_type": True,
        },
        966: {"num": 966, "names": ["SettleOnOpenFlag"], "type": "STRING"},
        967: {"num": 967, "names": ["StrikeMultiplier"], "type": "FLOAT"},
        968: {"num": 968, "names": ["StrikeValue"], "type": "FLOAT"},
        969: {"num": 969, "names": ["MinPriceIncrement"], "type": "FLOAT"},
        970: {"num": 970, "names": ["PositionLimit"], "type": "INT"},
        971: {"num": 971, "names": ["NTPositionLimit"], "type": "INT"},
        972: {
            "num": 972,
            "names": ["UnderlyingAllocationPercent"],
            "type": "PERCENTAGE",
        },
        973: {"num": 973, "names": ["UnderlyingCashAmount"], "type": "AMT"},
        974: {
            "num": 974,
            "names": ["UnderlyingCashType"],
            "type": "STRING",
            "enum_type": True,
        },
        975: {
            "num": 975,
            "names": ["UnderlyingSettlementType"],
            "type": "INT",
            "enum_type": True,
        },
        976: {"num": 976, "names": ["QuantityDate"], "type": "LOCALMKTDATE"},
        977: {"num": 977, "names": ["ContIntRptID"], "type": "STRING"},
        978: {"num": 978, "names": ["LateIndicator"], "type": "BOOLEAN"},
        979: {"num": 979, "names": ["InputSource"], "type": "STRING"},
        980: {
            "num": 980,
            "names": ["SecurityUpdateAction"],
            "type": "CHAR",
            "enum_type": True,
        },
        981: {"num": 981, "names": ["NoExpiration"], "type": "NUMINGROUP"},
        982: {
            "num": 982,
            "names": ["ExpirationQtyType"],
            "type": "INT",
            "enum_type": True,
        },
        983: {"num": 983, "names": ["ExpQty"], "type": "QTY"},
        984: {
            "num": 984,
            "names": ["NoUnderlyingAmounts"],
            "type": "NUMINGROUP",
        },
        985: {"num": 985, "names": ["UnderlyingPayAmount"], "type": "AMT"},
        986: {"num": 986, "names": ["UnderlyingCollectAmount"], "type": "AMT"},
        987: {
            "num": 987,
            "names": ["UnderlyingSettlementDate"],
            "type": "LOCALMKTDATE",
        },
        988: {
            "num": 988,
            "names": ["UnderlyingSettlementStatus"],
            "type": "STRING",
        },
        989: {
            "num": 989,
            "names": ["SecondaryIndividualAllocID"],
            "type": "STRING",
        },
        990: {"num": 990, "names": ["LegReportID"], "type": "STRING"},
        991: {"num": 991, "names": ["RndPx"], "type": "PRICE"},
        992: {
            "num": 992,
            "names": ["IndividualAllocType"],
            "type": "INT",
            "enum_type": True,
        },
        993: {
            "num": 993,
            "names": ["AllocCustomerCapacity"],
            "type": "STRING",
        },
        994: {"num": 994, "names": ["TierCode"], "type": "STRING"},
        996: {
            "num": 996,
            "names": ["UnitOfMeasure"],
            "type": "STRING",
            "enum_type": True,
        },
        997: {
            "num": 997,
            "names": ["TimeUnit"],
            "type": "STRING",
            "enum_type": True,
        },
        998: {
            "num": 998,
            "names": ["UnderlyingUnitOfMeasure"],
            "type": "STRING",
        },
        999: {"num": 999, "names": ["LegUnitOfMeasure"], "type": "STRING"},
        1000: {"num": 1000, "names": ["UnderlyingTimeUnit"], "type": "STRING"},
        1001: {"num": 1001, "names": ["LegTimeUnit"], "type": "STRING"},
        1002: {
            "num": 1002,
            "names": ["AllocMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1003: {"num": 1003, "names": ["TradeID"], "type": "STRING"},
        1005: {"num": 1005, "names": ["SideTradeReportID"], "type": "STRING"},
        1006: {"num": 1006, "names": ["SideFillStationCd"], "type": "STRING"},
        1007: {"num": 1007, "names": ["SideReasonCd"], "type": "STRING"},
        1008: {"num": 1008, "names": ["SideTrdSubTyp"], "type": "INT"},
        1009: {"num": 1009, "names": ["SideLastQty"], "type": "INT"},
        1011: {"num": 1011, "names": ["MessageEventSource"], "type": "STRING"},
        1012: {
            "num": 1012,
            "names": ["SideTrdRegTimestamp"],
            "type": "UTCTIMESTAMP",
        },
        1013: {
            "num": 1013,
            "names": ["SideTrdRegTimestampType"],
            "type": "INT",
        },
        1014: {
            "num": 1014,
            "names": ["SideTrdRegTimestampSrc"],
            "type": "STRING",
        },
        1015: {
            "num": 1015,
            "names": ["AsOfIndicator"],
            "type": "CHAR",
            "enum_type": True,
        },
        1016: {"num": 1016, "names": ["NoSideTrdRegTS"], "type": "NUMINGROUP"},
        1017: {"num": 1017, "names": ["LegOptionRatio"], "type": "FLOAT"},
        1018: {
            "num": 1018,
            "names": ["NoInstrumentParties"],
            "type": "NUMINGROUP",
        },
        1019: {"num": 1019, "names": ["InstrumentPartyID"], "type": "STRING"},
        1020: {"num": 1020, "names": ["TradeVolume"], "type": "QTY"},
        1021: {
            "num": 1021,
            "names": ["MDBookType"],
            "type": "INT",
            "enum_type": True,
        },
        1022: {"num": 1022, "names": ["MDFeedType"], "type": "STRING"},
        1023: {"num": 1023, "names": ["MDPriceLevel"], "type": "INT"},
        1024: {
            "num": 1024,
            "names": ["MDOriginType"],
            "type": "INT",
            "enum_type": True,
        },
        1025: {"num": 1025, "names": ["FirstPx"], "type": "PRICE"},
        1026: {"num": 1026, "names": ["MDEntrySpotRate"], "type": "FLOAT"},
        1027: {
            "num": 1027,
            "names": ["MDEntryForwardPoints"],
            "type": "PRICEOFFSET",
        },
        1028: {
            "num": 1028,
            "names": ["ManualOrderIndicator"],
            "type": "BOOLEAN",
        },
        1029: {"num": 1029, "names": ["CustDirectedOrder"], "type": "BOOLEAN"},
        1030: {"num": 1030, "names": ["ReceivedDeptID"], "type": "STRING"},
        1031: {
            "num": 1031,
            "names": ["CustOrderHandlingInst"],
            "type": "MULTIPLESTRINGVALUE",
            "enum_type": True,
        },
        1032: {
            "num": 1032,
            "names": ["OrderHandlingInstSource"],
            "type": "INT",
            "enum_type": True,
        },
        1033: {
            "num": 1033,
            "names": ["DeskType"],
            "type": "STRING",
            "enum_type": True,
        },
        1034: {
            "num": 1034,
            "names": ["DeskTypeSource"],
            "type": "INT",
            "enum_type": True,
        },
        1035: {
            "num": 1035,
            "names": ["DeskOrderHandlingInst"],
            "type": "MULTIPLESTRINGVALUE",
            "enum_type": True,
        },
        1036: {
            "num": 1036,
            "names": ["ExecAckStatus"],
            "type": "CHAR",
            "enum_type": True,
        },
        1037: {
            "num": 1037,
            "names": ["UnderlyingDeliveryAmount"],
            "type": "AMT",
        },
        1038: {"num": 1038, "names": ["UnderlyingCapValue"], "type": "AMT"},
        1039: {
            "num": 1039,
            "names": ["UnderlyingSettlMethod"],
            "type": "STRING",
        },
        1040: {"num": 1040, "names": ["SecondaryTradeID"], "type": "STRING"},
        1041: {"num": 1041, "names": ["FirmTradeID"], "type": "STRING"},
        1042: {
            "num": 1042,
            "names": ["SecondaryFirmTradeID"],
            "type": "STRING",
        },
        1043: {
            "num": 1043,
            "names": ["CollApplType"],
            "type": "INT",
            "enum_type": True,
        },
        1044: {
            "num": 1044,
            "names": ["UnderlyingAdjustedQuantity"],
            "type": "QTY",
        },
        1045: {"num": 1045, "names": ["UnderlyingFXRate"], "type": "FLOAT"},
        1046: {
            "num": 1046,
            "names": ["UnderlyingFXRateCalc"],
            "type": "CHAR",
            "enum_type": True,
        },
        1047: {
            "num": 1047,
            "names": ["AllocPositionEffect"],
            "type": "CHAR",
            "enum_type": True,
        },
        1048: {
            "num": 1048,
            "names": ["DealingCapacity"],
            "type": "CHAR",
            "enum_type": True,
        },
        1049: {
            "num": 1049,
            "names": ["InstrmtAssignmentMethod"],
            "type": "CHAR",
        },
        1050: {
            "num": 1050,
            "names": ["InstrumentPartyIDSource"],
            "type": "CHAR",
        },
        1051: {"num": 1051, "names": ["InstrumentPartyRole"], "type": "INT"},
        1052: {
            "num": 1052,
            "names": ["NoInstrumentPartySubIDs"],
            "type": "NUMINGROUP",
        },
        1053: {
            "num": 1053,
            "names": ["InstrumentPartySubID"],
            "type": "STRING",
        },
        1054: {
            "num": 1054,
            "names": ["InstrumentPartySubIDType"],
            "type": "INT",
        },
        1055: {"num": 1055, "names": ["PositionCurrency"], "type": "STRING"},
        1056: {"num": 1056, "names": ["CalculatedCcyLastQty"], "type": "QTY"},
        1057: {
            "num": 1057,
            "names": ["AggressorIndicator"],
            "type": "BOOLEAN",
            "enum_type": True,
        },
        1058: {
            "num": 1058,
            "names": ["NoUndlyInstrumentParties"],
            "type": "NUMINGROUP",
        },
        1059: {
            "num": 1059,
            "names": ["UnderlyingInstrumentPartyID"],
            "type": "STRING",
        },
        1060: {
            "num": 1060,
            "names": ["UnderlyingInstrumentPartyIDSource"],
            "type": "CHAR",
        },
        1061: {
            "num": 1061,
            "names": ["UnderlyingInstrumentPartyRole"],
            "type": "INT",
        },
        1062: {
            "num": 1062,
            "names": ["NoUndlyInstrumentPartySubIDs"],
            "type": "NUMINGROUP",
        },
        1063: {
            "num": 1063,
            "names": ["UnderlyingInstrumentPartySubID"],
            "type": "STRING",
        },
        1064: {
            "num": 1064,
            "names": ["UnderlyingInstrumentPartySubIDType"],
            "type": "INT",
        },
        1065: {"num": 1065, "names": ["BidSwapPoints"], "type": "PRICEOFFSET"},
        1066: {
            "num": 1066,
            "names": ["OfferSwapPoints"],
            "type": "PRICEOFFSET",
        },
        1067: {
            "num": 1067,
            "names": ["LegBidForwardPoints"],
            "type": "PRICEOFFSET",
        },
        1068: {
            "num": 1068,
            "names": ["LegOfferForwardPoints"],
            "type": "PRICEOFFSET",
        },
        1069: {"num": 1069, "names": ["SwapPoints"], "type": "PRICEOFFSET"},
        1070: {
            "num": 1070,
            "names": ["MDQuoteType"],
            "type": "INT",
            "enum_type": True,
        },
        1071: {
            "num": 1071,
            "names": ["LastSwapPoints"],
            "type": "PRICEOFFSET",
        },
        1072: {"num": 1072, "names": ["SideGrossTradeAmt"], "type": "AMT"},
        1073: {
            "num": 1073,
            "names": ["LegLastForwardPoints"],
            "type": "PRICEOFFSET",
        },
        1074: {
            "num": 1074,
            "names": ["LegCalculatedCcyLastQty"],
            "type": "QTY",
        },
        1075: {"num": 1075, "names": ["LegGrossTradeAmt"], "type": "AMT"},
        1079: {"num": 1079, "names": ["MaturityTime"], "type": "TZTIMEONLY"},
        1080: {"num": 1080, "names": ["RefOrderID"], "type": "STRING"},
        1081: {
            "num": 1081,
            "names": ["RefOrderIDSource"],
            "type": "CHAR",
            "enum_type": True,
        },
        1082: {"num": 1082, "names": ["SecondaryDisplayQty"], "type": "QTY"},
        1083: {
            "num": 1083,
            "names": ["DisplayWhen"],
            "type": "CHAR",
            "enum_type": True,
        },
        1084: {
            "num": 1084,
            "names": ["DisplayMethod"],
            "type": "CHAR",
            "enum_type": True,
        },
        1085: {"num": 1085, "names": ["DisplayLowQty"], "type": "QTY"},
        1086: {"num": 1086, "names": ["DisplayHighQty"], "type": "QTY"},
        1087: {"num": 1087, "names": ["DisplayMinIncr"], "type": "QTY"},
        1088: {"num": 1088, "names": ["RefreshQty"], "type": "QTY"},
        1089: {"num": 1089, "names": ["MatchIncrement"], "type": "QTY"},
        1090: {"num": 1090, "names": ["MaxPriceLevels"], "type": "INT"},
        1091: {"num": 1091, "names": ["PreTradeAnonymity"], "type": "BOOLEAN"},
        1092: {
            "num": 1092,
            "names": ["PriceProtectionScope"],
            "type": "CHAR",
            "enum_type": True,
        },
        1093: {
            "num": 1093,
            "names": ["LotType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1094: {
            "num": 1094,
            "names": ["PegPriceType"],
            "type": "INT",
            "enum_type": True,
        },
        1095: {"num": 1095, "names": ["PeggedRefPrice"], "type": "PRICE"},
        1096: {
            "num": 1096,
            "names": ["PegSecurityIDSource"],
            "type": "STRING",
        },
        1097: {"num": 1097, "names": ["PegSecurityID"], "type": "STRING"},
        1098: {"num": 1098, "names": ["PegSymbol"], "type": "STRING"},
        1099: {"num": 1099, "names": ["PegSecurityDesc"], "type": "STRING"},
        1100: {
            "num": 1100,
            "names": ["TriggerType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1101: {
            "num": 1101,
            "names": ["TriggerAction"],
            "type": "CHAR",
            "enum_type": True,
        },
        1102: {"num": 1102, "names": ["TriggerPrice"], "type": "PRICE"},
        1103: {"num": 1103, "names": ["TriggerSymbol"], "type": "STRING"},
        1104: {"num": 1104, "names": ["TriggerSecurityID"], "type": "STRING"},
        1105: {
            "num": 1105,
            "names": ["TriggerSecurityIDSource"],
            "type": "STRING",
        },
        1106: {
            "num": 1106,
            "names": ["TriggerSecurityDesc"],
            "type": "STRING",
        },
        1107: {
            "num": 1107,
            "names": ["TriggerPriceType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1108: {
            "num": 1108,
            "names": ["TriggerPriceTypeScope"],
            "type": "CHAR",
            "enum_type": True,
        },
        1109: {
            "num": 1109,
            "names": ["TriggerPriceDirection"],
            "type": "CHAR",
            "enum_type": True,
        },
        1110: {"num": 1110, "names": ["TriggerNewPrice"], "type": "PRICE"},
        1111: {
            "num": 1111,
            "names": ["TriggerOrderType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1112: {"num": 1112, "names": ["TriggerNewQty"], "type": "QTY"},
        1113: {
            "num": 1113,
            "names": ["TriggerTradingSessionID"],
            "type": "STRING",
        },
        1114: {
            "num": 1114,
            "names": ["TriggerTradingSessionSubID"],
            "type": "STRING",
        },
        1115: {
            "num": 1115,
            "names": ["OrderCategory"],
            "type": "CHAR",
            "enum_type": True,
        },
        1116: {"num": 1116, "names": ["NoRootPartyIDs"], "type": "NUMINGROUP"},
        1117: {"num": 1117, "names": ["RootPartyID"], "type": "STRING"},
        1118: {"num": 1118, "names": ["RootPartyIDSource"], "type": "CHAR"},
        1119: {"num": 1119, "names": ["RootPartyRole"], "type": "INT"},
        1120: {
            "num": 1120,
            "names": ["NoRootPartySubIDs"],
            "type": "NUMINGROUP",
        },
        1121: {"num": 1121, "names": ["RootPartySubID"], "type": "STRING"},
        1122: {"num": 1122, "names": ["RootPartySubIDType"], "type": "INT"},
        1123: {
            "num": 1123,
            "names": ["TradeHandlingInstr"],
            "type": "CHAR",
            "enum_type": True,
        },
        1124: {
            "num": 1124,
            "names": ["OrigTradeHandlingInstr"],
            "type": "CHAR",
        },
        1125: {
            "num": 1125,
            "names": ["OrigTradeDate"],
            "type": "LOCALMKTDATE",
        },
        1126: {"num": 1126, "names": ["OrigTradeID"], "type": "STRING"},
        1127: {
            "num": 1127,
            "names": ["OrigSecondaryTradeID"],
            "type": "STRING",
        },
        1128: {
            "num": 1128,
            "names": ["ApplVerID"],
            "type": "STRING",
            "enum_type": True,
        },
        1129: {"num": 1129, "names": ["CstmApplVerID"], "type": "STRING"},
        1130: {"num": 1130, "names": ["RefApplVerID"], "type": "STRING"},
        1131: {"num": 1131, "names": ["RefCstmApplVerID"], "type": "STRING"},
        1132: {
            "num": 1132,
            "names": ["TZTransactTime"],
            "type": "TZTIMESTAMP",
        },
        1133: {
            "num": 1133,
            "names": ["ExDestinationIDSource"],
            "type": "CHAR",
            "enum_type": True,
        },
        1134: {"num": 1134, "names": ["ReportedPxDiff"], "type": "BOOLEAN"},
        1135: {"num": 1135, "names": ["RptSys"], "type": "STRING"},
        1136: {
            "num": 1136,
            "names": ["AllocClearingFeeIndicator"],
            "type": "STRING",
        },
        1137: {"num": 1137, "names": ["DefaultApplVerID"], "type": "STRING"},
        1138: {"num": 1138, "names": ["DisplayQty"], "type": "QTY"},
        1139: {
            "num": 1139,
            "names": ["ExchangeSpecialInstructions"],
            "type": "STRING",
        },
        1140: {"num": 1140, "names": ["MaxTradeVol"], "type": "QTY"},
        1141: {"num": 1141, "names": ["NoMDFeedTypes"], "type": "NUMINGROUP"},
        1142: {"num": 1142, "names": ["MatchAlgorithm"], "type": "STRING"},
        1143: {"num": 1143, "names": ["MaxPriceVariation"], "type": "FLOAT"},
        1144: {
            "num": 1144,
            "names": ["ImpliedMarketIndicator"],
            "type": "INT",
            "enum_type": True,
        },
        1145: {"num": 1145, "names": ["EventTime"], "type": "UTCTIMESTAMP"},
        1146: {
            "num": 1146,
            "names": ["MinPriceIncrementAmount"],
            "type": "AMT",
        },
        1147: {"num": 1147, "names": ["UnitOfMeasureQty"], "type": "QTY"},
        1148: {"num": 1148, "names": ["LowLimitPrice"], "type": "PRICE"},
        1149: {"num": 1149, "names": ["HighLimitPrice"], "type": "PRICE"},
        1150: {
            "num": 1150,
            "names": ["TradingReferencePrice"],
            "type": "PRICE",
        },
        1151: {"num": 1151, "names": ["SecurityGroup"], "type": "STRING"},
        1152: {"num": 1152, "names": ["LegNumber"], "type": "INT"},
        1153: {"num": 1153, "names": ["SettlementCycleNo"], "type": "INT"},
        1154: {"num": 1154, "names": ["SideCurrency"], "type": "CURRENCY"},
        1155: {
            "num": 1155,
            "names": ["SideSettlCurrency"],
            "type": "CURRENCY",
        },
        1156: {"num": 1156, "names": ["ApplExtID"], "type": "INT"},
        1157: {"num": 1157, "names": ["CcyAmt"], "type": "AMT"},
        1158: {"num": 1158, "names": ["NoSettlDetails"], "type": "NUMINGROUP"},
        1159: {
            "num": 1159,
            "names": ["SettlObligMode"],
            "type": "INT",
            "enum_type": True,
        },
        1160: {"num": 1160, "names": ["SettlObligMsgID"], "type": "STRING"},
        1161: {"num": 1161, "names": ["SettlObligID"], "type": "STRING"},
        1162: {
            "num": 1162,
            "names": ["SettlObligTransType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1163: {"num": 1163, "names": ["SettlObligRefID"], "type": "STRING"},
        1164: {
            "num": 1164,
            "names": ["SettlObligSource"],
            "type": "CHAR",
            "enum_type": True,
        },
        1165: {"num": 1165, "names": ["NoSettlOblig"], "type": "NUMINGROUP"},
        1166: {"num": 1166, "names": ["QuoteMsgID"], "type": "STRING"},
        1167: {
            "num": 1167,
            "names": ["QuoteEntryStatus"],
            "type": "INT",
            "enum_type": True,
        },
        1168: {"num": 1168, "names": ["TotNoCxldQuotes"], "type": "INT"},
        1169: {"num": 1169, "names": ["TotNoAccQuotes"], "type": "INT"},
        1170: {"num": 1170, "names": ["TotNoRejQuotes"], "type": "INT"},
        1171: {"num": 1171, "names": ["PrivateQuote"], "type": "BOOLEAN"},
        1172: {
            "num": 1172,
            "names": ["RespondentType"],
            "type": "INT",
            "enum_type": True,
        },
        1173: {"num": 1173, "names": ["MDSubBookType"], "type": "INT"},
        1174: {
            "num": 1174,
            "names": ["SecurityTradingEvent"],
            "type": "INT",
            "enum_type": True,
        },
        1175: {
            "num": 1175,
            "names": ["NoStatsIndicators"],
            "type": "NUMINGROUP",
        },
        1176: {
            "num": 1176,
            "names": ["StatsType"],
            "type": "INT",
            "enum_type": True,
        },
        1177: {"num": 1177, "names": ["NoOfSecSizes"], "type": "NUMINGROUP"},
        1178: {
            "num": 1178,
            "names": ["MDSecSizeType"],
            "type": "INT",
            "enum_type": True,
        },
        1179: {"num": 1179, "names": ["MDSecSize"], "type": "QTY"},
        1180: {"num": 1180, "names": ["ApplID"], "type": "STRING"},
        1181: {"num": 1181, "names": ["ApplSeqNum"], "type": "SEQNUM"},
        1182: {"num": 1182, "names": ["ApplBegSeqNum"], "type": "SEQNUM"},
        1183: {"num": 1183, "names": ["ApplEndSeqNum"], "type": "SEQNUM"},
        1184: {"num": 1184, "names": ["SecurityXMLLen"], "type": "LENGTH"},
        1185: {"num": 1185, "names": ["SecurityXML"], "type": "XMLDATA"},
        1186: {"num": 1186, "names": ["SecurityXMLSchema"], "type": "STRING"},
        1187: {"num": 1187, "names": ["RefreshIndicator"], "type": "BOOLEAN"},
        1188: {"num": 1188, "names": ["Volatility"], "type": "FLOAT"},
        1189: {"num": 1189, "names": ["TimeToExpiration"], "type": "FLOAT"},
        1190: {"num": 1190, "names": ["RiskFreeRate"], "type": "FLOAT"},
        1191: {"num": 1191, "names": ["PriceUnitOfMeasure"], "type": "STRING"},
        1192: {"num": 1192, "names": ["PriceUnitOfMeasureQty"], "type": "QTY"},
        1193: {
            "num": 1193,
            "names": ["SettlMethod"],
            "type": "CHAR",
            "enum_type": True,
        },
        1194: {
            "num": 1194,
            "names": ["ExerciseStyle"],
            "type": "INT",
            "enum_type": True,
        },
        1195: {"num": 1195, "names": ["OptPayoutAmount"], "type": "AMT"},
        1196: {
            "num": 1196,
            "names": ["PriceQuoteMethod"],
            "type": "STRING",
            "enum_type": True,
        },
        1197: {
            "num": 1197,
            "names": ["ValuationMethod"],
            "type": "STRING",
            "enum_type": True,
        },
        1198: {
            "num": 1198,
            "names": ["ListMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1199: {"num": 1199, "names": ["CapPrice"], "type": "PRICE"},
        1200: {"num": 1200, "names": ["FloorPrice"], "type": "PRICE"},
        1201: {"num": 1201, "names": ["NoStrikeRules"], "type": "NUMINGROUP"},
        1202: {"num": 1202, "names": ["StartStrikePxRange"], "type": "PRICE"},
        1203: {"num": 1203, "names": ["EndStrikePxRange"], "type": "PRICE"},
        1204: {"num": 1204, "names": ["StrikeIncrement"], "type": "FLOAT"},
        1205: {"num": 1205, "names": ["NoTickRules"], "type": "NUMINGROUP"},
        1206: {"num": 1206, "names": ["StartTickPriceRange"], "type": "PRICE"},
        1207: {"num": 1207, "names": ["EndTickPriceRange"], "type": "PRICE"},
        1208: {"num": 1208, "names": ["TickIncrement"], "type": "PRICE"},
        1209: {
            "num": 1209,
            "names": ["TickRuleType"],
            "type": "INT",
            "enum_type": True,
        },
        1210: {"num": 1210, "names": ["NestedInstrAttribType"], "type": "INT"},
        1211: {
            "num": 1211,
            "names": ["NestedInstrAttribValue"],
            "type": "STRING",
        },
        1212: {
            "num": 1212,
            "names": ["LegMaturityTime"],
            "type": "TZTIMEONLY",
        },
        1213: {
            "num": 1213,
            "names": ["UnderlyingMaturityTime"],
            "type": "TZTIMEONLY",
        },
        1214: {"num": 1214, "names": ["DerivativeSymbol"], "type": "STRING"},
        1215: {
            "num": 1215,
            "names": ["DerivativeSymbolSfx"],
            "type": "STRING",
        },
        1216: {
            "num": 1216,
            "names": ["DerivativeSecurityID"],
            "type": "STRING",
        },
        1217: {
            "num": 1217,
            "names": ["DerivativeSecurityIDSource"],
            "type": "STRING",
        },
        1218: {
            "num": 1218,
            "names": ["NoDerivativeSecurityAltID"],
            "type": "NUMINGROUP",
        },
        1219: {
            "num": 1219,
            "names": ["DerivativeSecurityAltID"],
            "type": "STRING",
        },
        1220: {
            "num": 1220,
            "names": ["DerivativeSecurityAltIDSource"],
            "type": "STRING",
        },
        1221: {
            "num": 1221,
            "names": ["SecondaryLowLimitPrice"],
            "type": "PRICE",
        },
        1222: {"num": 1222, "names": ["MaturityRuleID"], "type": "STRING"},
        1223: {"num": 1223, "names": ["StrikeRuleID"], "type": "STRING"},
        1224: {"num": 1224, "names": ["LegUnitOfMeasureQty"], "type": "QTY"},
        1225: {
            "num": 1225,
            "names": ["DerivativeOptPayAmount"],
            "type": "AMT",
        },
        1226: {
            "num": 1226,
            "names": ["EndMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        1227: {"num": 1227, "names": ["ProductComplex"], "type": "STRING"},
        1228: {
            "num": 1228,
            "names": ["DerivativeProductComplex"],
            "type": "STRING",
        },
        1229: {
            "num": 1229,
            "names": ["MaturityMonthYearIncrement"],
            "type": "INT",
        },
        1230: {
            "num": 1230,
            "names": ["SecondaryHighLimitPrice"],
            "type": "PRICE",
        },
        1231: {"num": 1231, "names": ["MinLotSize"], "type": "QTY"},
        1232: {
            "num": 1232,
            "names": ["NoExecInstRules"],
            "type": "NUMINGROUP",
        },
        1234: {"num": 1234, "names": ["NoLotTypeRules"], "type": "NUMINGROUP"},
        1235: {"num": 1235, "names": ["NoMatchRules"], "type": "NUMINGROUP"},
        1236: {
            "num": 1236,
            "names": ["NoMaturityRules"],
            "type": "NUMINGROUP",
        },
        1237: {"num": 1237, "names": ["NoOrdTypeRules"], "type": "NUMINGROUP"},
        1239: {
            "num": 1239,
            "names": ["NoTimeInForceRules"],
            "type": "NUMINGROUP",
        },
        1240: {
            "num": 1240,
            "names": ["SecondaryTradingReferencePrice"],
            "type": "PRICE",
        },
        1241: {
            "num": 1241,
            "names": ["StartMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        1242: {
            "num": 1242,
            "names": ["FlexProductEligibilityIndicator"],
            "type": "BOOLEAN",
        },
        1243: {
            "num": 1243,
            "names": ["DerivFlexProductEligibilityIndicator"],
            "type": "BOOLEAN",
        },
        1244: {"num": 1244, "names": ["FlexibleIndicator"], "type": "BOOLEAN"},
        1245: {"num": 1245, "names": ["TradingCurrency"], "type": "CURRENCY"},
        1246: {"num": 1246, "names": ["DerivativeProduct"], "type": "INT"},
        1247: {
            "num": 1247,
            "names": ["DerivativeSecurityGroup"],
            "type": "STRING",
        },
        1248: {"num": 1248, "names": ["DerivativeCFICode"], "type": "STRING"},
        1249: {
            "num": 1249,
            "names": ["DerivativeSecurityType"],
            "type": "STRING",
        },
        1250: {
            "num": 1250,
            "names": ["DerivativeSecuritySubType"],
            "type": "STRING",
        },
        1251: {
            "num": 1251,
            "names": ["DerivativeMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        1252: {
            "num": 1252,
            "names": ["DerivativeMaturityDate"],
            "type": "LOCALMKTDATE",
        },
        1253: {
            "num": 1253,
            "names": ["DerivativeMaturityTime"],
            "type": "TZTIMEONLY",
        },
        1254: {
            "num": 1254,
            "names": ["DerivativeSettleOnOpenFlag"],
            "type": "STRING",
        },
        1255: {
            "num": 1255,
            "names": ["DerivativeInstrmtAssignmentMethod"],
            "type": "CHAR",
        },
        1256: {
            "num": 1256,
            "names": ["DerivativeSecurityStatus"],
            "type": "STRING",
        },
        1257: {
            "num": 1257,
            "names": ["DerivativeInstrRegistry"],
            "type": "STRING",
        },
        1258: {
            "num": 1258,
            "names": ["DerivativeCountryOfIssue"],
            "type": "COUNTRY",
        },
        1259: {
            "num": 1259,
            "names": ["DerivativeStateOrProvinceOfIssue"],
            "type": "STRING",
        },
        1260: {
            "num": 1260,
            "names": ["DerivativeLocaleOfIssue"],
            "type": "STRING",
        },
        1261: {
            "num": 1261,
            "names": ["DerivativeStrikePrice"],
            "type": "PRICE",
        },
        1262: {
            "num": 1262,
            "names": ["DerivativeStrikeCurrency"],
            "type": "CURRENCY",
        },
        1263: {
            "num": 1263,
            "names": ["DerivativeStrikeMultiplier"],
            "type": "FLOAT",
        },
        1264: {
            "num": 1264,
            "names": ["DerivativeStrikeValue"],
            "type": "FLOAT",
        },
        1265: {
            "num": 1265,
            "names": ["DerivativeOptAttribute"],
            "type": "CHAR",
        },
        1266: {
            "num": 1266,
            "names": ["DerivativeContractMultiplier"],
            "type": "FLOAT",
        },
        1267: {
            "num": 1267,
            "names": ["DerivativeMinPriceIncrement"],
            "type": "FLOAT",
        },
        1268: {
            "num": 1268,
            "names": ["DerivativeMinPriceIncrementAmount"],
            "type": "AMT",
        },
        1269: {
            "num": 1269,
            "names": ["DerivativeUnitOfMeasure"],
            "type": "STRING",
        },
        1270: {
            "num": 1270,
            "names": ["DerivativeUnitOfMeasureQty"],
            "type": "QTY",
        },
        1271: {"num": 1271, "names": ["DerivativeTimeUnit"], "type": "STRING"},
        1272: {
            "num": 1272,
            "names": ["DerivativeSecurityExchange"],
            "type": "EXCHANGE",
        },
        1273: {
            "num": 1273,
            "names": ["DerivativePositionLimit"],
            "type": "INT",
        },
        1274: {
            "num": 1274,
            "names": ["DerivativeNTPositionLimit"],
            "type": "INT",
        },
        1275: {"num": 1275, "names": ["DerivativeIssuer"], "type": "STRING"},
        1276: {
            "num": 1276,
            "names": ["DerivativeIssueDate"],
            "type": "LOCALMKTDATE",
        },
        1277: {
            "num": 1277,
            "names": ["DerivativeEncodedIssuerLen"],
            "type": "LENGTH",
        },
        1278: {
            "num": 1278,
            "names": ["DerivativeEncodedIssuer"],
            "type": "DATA",
        },
        1279: {
            "num": 1279,
            "names": ["DerivativeSecurityDesc"],
            "type": "STRING",
        },
        1280: {
            "num": 1280,
            "names": ["DerivativeEncodedSecurityDescLen"],
            "type": "LENGTH",
        },
        1281: {
            "num": 1281,
            "names": ["DerivativeEncodedSecurityDesc"],
            "type": "DATA",
        },
        1282: {
            "num": 1282,
            "names": ["DerivativeSecurityXMLLen"],
            "type": "LENGTH",
        },
        1283: {
            "num": 1283,
            "names": ["DerivativeSecurityXML"],
            "type": "DATA",
        },
        1284: {
            "num": 1284,
            "names": ["DerivativeSecurityXMLSchema"],
            "type": "STRING",
        },
        1285: {
            "num": 1285,
            "names": ["DerivativeContractSettlMonth"],
            "type": "MONTHYEAR",
        },
        1286: {
            "num": 1286,
            "names": ["NoDerivativeEvents"],
            "type": "NUMINGROUP",
        },
        1287: {"num": 1287, "names": ["DerivativeEventType"], "type": "INT"},
        1288: {
            "num": 1288,
            "names": ["DerivativeEventDate"],
            "type": "LOCALMKTDATE",
        },
        1289: {
            "num": 1289,
            "names": ["DerivativeEventTime"],
            "type": "UTCTIMESTAMP",
        },
        1290: {"num": 1290, "names": ["DerivativeEventPx"], "type": "PRICE"},
        1291: {
            "num": 1291,
            "names": ["DerivativeEventText"],
            "type": "STRING",
        },
        1292: {
            "num": 1292,
            "names": ["NoDerivativeInstrumentParties"],
            "type": "NUMINGROUP",
        },
        1293: {
            "num": 1293,
            "names": ["DerivativeInstrumentPartyID"],
            "type": "STRING",
        },
        1294: {
            "num": 1294,
            "names": ["DerivativeInstrumentPartyIDSource"],
            "type": "STRING",
        },
        1295: {
            "num": 1295,
            "names": ["DerivativeInstrumentPartyRole"],
            "type": "INT",
        },
        1296: {
            "num": 1296,
            "names": ["NoDerivativeInstrumentPartySubIDs"],
            "type": "NUMINGROUP",
        },
        1297: {
            "num": 1297,
            "names": ["DerivativeInstrumentPartySubID"],
            "type": "STRING",
        },
        1298: {
            "num": 1298,
            "names": ["DerivativeInstrumentPartySubIDType"],
            "type": "INT",
        },
        1299: {
            "num": 1299,
            "names": ["DerivativeExerciseStyle"],
            "type": "CHAR",
        },
        1300: {"num": 1300, "names": ["MarketSegmentID"], "type": "STRING"},
        1301: {"num": 1301, "names": ["MarketID"], "type": "EXCHANGE"},
        1302: {
            "num": 1302,
            "names": ["MaturityMonthYearIncrementUnits"],
            "type": "INT",
            "enum_type": True,
        },
        1303: {
            "num": 1303,
            "names": ["MaturityMonthYearFormat"],
            "type": "INT",
            "enum_type": True,
        },
        1304: {"num": 1304, "names": ["StrikeExerciseStyle"], "type": "INT"},
        1305: {
            "num": 1305,
            "names": ["SecondaryPriceLimitType"],
            "type": "INT",
        },
        1306: {
            "num": 1306,
            "names": ["PriceLimitType"],
            "type": "INT",
            "enum_type": True,
        },
        1308: {"num": 1308, "names": ["ExecInstValue"], "type": "CHAR"},
        1309: {
            "num": 1309,
            "names": ["NoTradingSessionRules"],
            "type": "NUMINGROUP",
        },
        1310: {
            "num": 1310,
            "names": ["NoMarketSegments"],
            "type": "NUMINGROUP",
        },
        1311: {
            "num": 1311,
            "names": ["NoDerivativeInstrAttrib"],
            "type": "NUMINGROUP",
        },
        1312: {
            "num": 1312,
            "names": ["NoNestedInstrAttrib"],
            "type": "NUMINGROUP",
        },
        1313: {
            "num": 1313,
            "names": ["DerivativeInstrAttribType"],
            "type": "INT",
        },
        1314: {
            "num": 1314,
            "names": ["DerivativeInstrAttribValue"],
            "type": "STRING",
        },
        1315: {
            "num": 1315,
            "names": ["DerivativePriceUnitOfMeasure"],
            "type": "STRING",
        },
        1316: {
            "num": 1316,
            "names": ["DerivativePriceUnitOfMeasureQty"],
            "type": "QTY",
        },
        1317: {
            "num": 1317,
            "names": ["DerivativeSettlMethod"],
            "type": "CHAR",
        },
        1318: {
            "num": 1318,
            "names": ["DerivativePriceQuoteMethod"],
            "type": "STRING",
        },
        1319: {
            "num": 1319,
            "names": ["DerivativeValuationMethod"],
            "type": "STRING",
        },
        1320: {"num": 1320, "names": ["DerivativeListMethod"], "type": "INT"},
        1321: {"num": 1321, "names": ["DerivativeCapPrice"], "type": "PRICE"},
        1322: {
            "num": 1322,
            "names": ["DerivativeFloorPrice"],
            "type": "PRICE",
        },
        1323: {"num": 1323, "names": ["DerivativePutOrCall"], "type": "INT"},
        1324: {"num": 1324, "names": ["ListUpdateAction"], "type": "CHAR"},
        1325: {"num": 1325, "names": ["ParentMktSegmID"], "type": "STRING"},
        1326: {"num": 1326, "names": ["TradingSessionDesc"], "type": "STRING"},
        1327: {"num": 1327, "names": ["TradSesUpdateAction"], "type": "CHAR"},
        1328: {"num": 1328, "names": ["RejectText"], "type": "STRING"},
        1329: {"num": 1329, "names": ["FeeMultiplier"], "type": "FLOAT"},
        1330: {
            "num": 1330,
            "names": ["UnderlyingLegSymbol"],
            "type": "STRING",
        },
        1331: {
            "num": 1331,
            "names": ["UnderlyingLegSymbolSfx"],
            "type": "STRING",
        },
        1332: {
            "num": 1332,
            "names": ["UnderlyingLegSecurityID"],
            "type": "STRING",
        },
        1333: {
            "num": 1333,
            "names": ["UnderlyingLegSecurityIDSource"],
            "type": "STRING",
        },
        1334: {
            "num": 1334,
            "names": ["NoUnderlyingLegSecurityAltID"],
            "type": "NUMINGROUP",
        },
        1335: {
            "num": 1335,
            "names": ["UnderlyingLegSecurityAltID"],
            "type": "STRING",
        },
        1336: {
            "num": 1336,
            "names": ["UnderlyingLegSecurityAltIDSource"],
            "type": "STRING",
        },
        1337: {
            "num": 1337,
            "names": ["UnderlyingLegSecurityType"],
            "type": "STRING",
        },
        1338: {
            "num": 1338,
            "names": ["UnderlyingLegSecuritySubType"],
            "type": "STRING",
        },
        1339: {
            "num": 1339,
            "names": ["UnderlyingLegMaturityMonthYear"],
            "type": "MONTHYEAR",
        },
        1340: {
            "num": 1340,
            "names": ["UnderlyingLegStrikePrice"],
            "type": "PRICE",
        },
        1341: {
            "num": 1341,
            "names": ["UnderlyingLegSecurityExchange"],
            "type": "STRING",
        },
        1342: {
            "num": 1342,
            "names": ["NoOfLegUnderlyings"],
            "type": "NUMINGROUP",
        },
        1343: {
            "num": 1343,
            "names": ["UnderlyingLegPutOrCall"],
            "type": "INT",
        },
        1344: {
            "num": 1344,
            "names": ["UnderlyingLegCFICode"],
            "type": "STRING",
        },
        1345: {
            "num": 1345,
            "names": ["UnderlyingLegMaturityDate"],
            "type": "LOCALMKTDATE",
        },
        1346: {"num": 1346, "names": ["ApplReqID"], "type": "STRING"},
        1347: {
            "num": 1347,
            "names": ["ApplReqType"],
            "type": "INT",
            "enum_type": True,
        },
        1348: {
            "num": 1348,
            "names": ["ApplResponseType"],
            "type": "INT",
            "enum_type": True,
        },
        1349: {"num": 1349, "names": ["ApplTotalMessageCount"], "type": "INT"},
        1350: {"num": 1350, "names": ["ApplLastSeqNum"], "type": "SEQNUM"},
        1351: {"num": 1351, "names": ["NoApplIDs"], "type": "NUMINGROUP"},
        1352: {"num": 1352, "names": ["ApplResendFlag"], "type": "BOOLEAN"},
        1353: {"num": 1353, "names": ["ApplResponseID"], "type": "STRING"},
        1354: {
            "num": 1354,
            "names": ["ApplResponseError"],
            "type": "INT",
            "enum_type": True,
        },
        1355: {"num": 1355, "names": ["RefApplID"], "type": "STRING"},
        1356: {"num": 1356, "names": ["ApplReportID"], "type": "STRING"},
        1357: {"num": 1357, "names": ["RefApplLastSeqNum"], "type": "SEQNUM"},
        1358: {"num": 1358, "names": ["LegPutOrCall"], "type": "INT"},
        1361: {"num": 1361, "names": ["TotNoFills"], "type": "INT"},
        1362: {"num": 1362, "names": ["NoFills"], "type": "NUMINGROUP"},
        1363: {"num": 1363, "names": ["FillExecID"], "type": "STRING"},
        1364: {"num": 1364, "names": ["FillPx"], "type": "PRICE"},
        1365: {"num": 1365, "names": ["FillQty"], "type": "QTY"},
        1366: {"num": 1366, "names": ["LegAllocID"], "type": "STRING"},
        1367: {
            "num": 1367,
            "names": ["LegAllocSettlCurrency"],
            "type": "CURRENCY",
        },
        1368: {
            "num": 1368,
            "names": ["TradSesEvent"],
            "type": "INT",
            "enum_type": True,
        },
        1369: {"num": 1369, "names": ["MassActionReportID"], "type": "STRING"},
        1370: {
            "num": 1370,
            "names": ["NoNotAffectedOrders"],
            "type": "NUMINGROUP",
        },
        1371: {"num": 1371, "names": ["NotAffectedOrderID"], "type": "STRING"},
        1372: {"num": 1372, "names": ["NotAffOrigClOrdID"], "type": "STRING"},
        1373: {
            "num": 1373,
            "names": ["MassActionType"],
            "type": "INT",
            "enum_type": True,
        },
        1374: {
            "num": 1374,
            "names": ["MassActionScope"],
            "type": "INT",
            "enum_type": True,
        },
        1375: {
            "num": 1375,
            "names": ["MassActionResponse"],
            "type": "INT",
            "enum_type": True,
        },
        1376: {
            "num": 1376,
            "names": ["MassActionRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        1377: {
            "num": 1377,
            "names": ["MultilegModel"],
            "type": "INT",
            "enum_type": True,
        },
        1378: {
            "num": 1378,
            "names": ["MultilegPriceMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1379: {"num": 1379, "names": ["LegVolatility"], "type": "FLOAT"},
        1380: {"num": 1380, "names": ["DividendYield"], "type": "PERCENTAGE"},
        1381: {
            "num": 1381,
            "names": ["LegDividendYield"],
            "type": "PERCENTAGE",
        },
        1382: {"num": 1382, "names": ["CurrencyRatio"], "type": "FLOAT"},
        1383: {"num": 1383, "names": ["LegCurrencyRatio"], "type": "FLOAT"},
        1384: {
            "num": 1384,
            "names": ["LegExecInst"],
            "type": "MULTIPLECHARVALUE",
        },
        1385: {
            "num": 1385,
            "names": ["ContingencyType"],
            "type": "INT",
            "enum_type": True,
        },
        1386: {
            "num": 1386,
            "names": ["ListRejectReason"],
            "type": "INT",
            "enum_type": True,
        },
        1387: {
            "num": 1387,
            "names": ["NoTrdRepIndicators"],
            "type": "NUMINGROUP",
        },
        1388: {"num": 1388, "names": ["TrdRepPartyRole"], "type": "INT"},
        1389: {"num": 1389, "names": ["TrdRepIndicator"], "type": "BOOLEAN"},
        1390: {
            "num": 1390,
            "names": ["TradePublishIndicator"],
            "type": "INT",
            "enum_type": True,
        },
        1391: {
            "num": 1391,
            "names": ["UnderlyingLegOptAttribute"],
            "type": "CHAR",
        },
        1392: {
            "num": 1392,
            "names": ["UnderlyingLegSecurityDesc"],
            "type": "STRING",
        },
        1393: {"num": 1393, "names": ["MarketReqID"], "type": "STRING"},
        1394: {"num": 1394, "names": ["MarketReportID"], "type": "STRING"},
        1395: {
            "num": 1395,
            "names": ["MarketUpdateAction"],
            "type": "CHAR",
            "enum_type": True,
        },
        1396: {"num": 1396, "names": ["MarketSegmentDesc"], "type": "STRING"},
        1397: {
            "num": 1397,
            "names": ["EncodedMktSegmDescLen"],
            "type": "LENGTH",
        },
        1398: {"num": 1398, "names": ["EncodedMktSegmDesc"], "type": "DATA"},
        1399: {"num": 1399, "names": ["ApplNewSeqNum"], "type": "SEQNUM"},
        1400: {
            "num": 1400,
            "names": ["EncryptedPasswordMethod"],
            "type": "INT",
        },
        1401: {
            "num": 1401,
            "names": ["EncryptedPasswordLen"],
            "type": "LENGTH",
        },
        1402: {"num": 1402, "names": ["EncryptedPassword"], "type": "DATA"},
        1403: {
            "num": 1403,
            "names": ["EncryptedNewPasswordLen"],
            "type": "LENGTH",
        },
        1404: {"num": 1404, "names": ["EncryptedNewPassword"], "type": "DATA"},
        1405: {
            "num": 1405,
            "names": ["UnderlyingLegMaturityTime"],
            "type": "TZTIMEONLY",
        },
        1406: {"num": 1406, "names": ["RefApplExtID"], "type": "INT"},
        1407: {"num": 1407, "names": ["DefaultApplExtID"], "type": "INT"},
        1408: {
            "num": 1408,
            "names": ["DefaultCstmApplVerID"],
            "type": "STRING",
        },
        1409: {
            "num": 1409,
            "names": ["SessionStatus"],
            "type": "INT",
            "enum_type": True,
        },
        1410: {
            "num": 1410,
            "names": ["DefaultVerIndicator"],
            "type": "BOOLEAN",
        },
        1411: {"num": 1411, "names": ["Nested4PartySubIDType"], "type": "INT"},
        1412: {"num": 1412, "names": ["Nested4PartySubID"], "type": "STRING"},
        1413: {
            "num": 1413,
            "names": ["NoNested4PartySubIDs"],
            "type": "NUMINGROUP",
        },
        1414: {
            "num": 1414,
            "names": ["NoNested4PartyIDs"],
            "type": "NUMINGROUP",
        },
        1415: {"num": 1415, "names": ["Nested4PartyID"], "type": "STRING"},
        1416: {"num": 1416, "names": ["Nested4PartyIDSource"], "type": "CHAR"},
        1417: {"num": 1417, "names": ["Nested4PartyRole"], "type": "INT"},
        1418: {"num": 1418, "names": ["LegLastQty"], "type": "QTY"},
        1419: {
            "num": 1419,
            "names": ["UnderlyingExerciseStyle"],
            "type": "INT",
        },
        1420: {"num": 1420, "names": ["LegExerciseStyle"], "type": "INT"},
        1421: {
            "num": 1421,
            "names": ["LegPriceUnitOfMeasure"],
            "type": "STRING",
        },
        1422: {
            "num": 1422,
            "names": ["LegPriceUnitOfMeasureQty"],
            "type": "QTY",
        },
        1423: {
            "num": 1423,
            "names": ["UnderlyingUnitOfMeasureQty"],
            "type": "QTY",
        },
        1424: {
            "num": 1424,
            "names": ["UnderlyingPriceUnitOfMeasure"],
            "type": "STRING",
        },
        1425: {
            "num": 1425,
            "names": ["UnderlyingPriceUnitOfMeasureQty"],
            "type": "QTY",
        },
        1426: {
            "num": 1426,
            "names": ["ApplReportType"],
            "type": "INT",
            "enum_type": True,
        },
        1427: {"num": 1427, "names": ["SideExecID"], "type": "STRING"},
        1428: {"num": 1428, "names": ["OrderDelay"], "type": "INT"},
        1429: {
            "num": 1429,
            "names": ["OrderDelayUnit"],
            "type": "INT",
            "enum_type": True,
        },
        1430: {
            "num": 1430,
            "names": ["VenueType"],
            "type": "CHAR",
            "enum_type": True,
        },
        1431: {
            "num": 1431,
            "names": ["RefOrdIDReason"],
            "type": "INT",
            "enum_type": True,
        },
        1432: {
            "num": 1432,
            "names": ["OrigCustOrderCapacity"],
            "type": "INT",
            "enum_type": True,
        },
        1433: {"num": 1433, "names": ["RefApplReqID"], "type": "STRING"},
        1434: {
            "num": 1434,
            "names": ["ModelType"],
            "type": "INT",
            "enum_type": True,
        },
        1435: {
            "num": 1435,
            "names": ["ContractMultiplierUnit"],
            "type": "INT",
            "enum_type": True,
        },
        1436: {
            "num": 1436,
            "names": ["LegContractMultiplierUnit"],
            "type": "INT",
        },
        1437: {
            "num": 1437,
            "names": ["UnderlyingContractMultiplierUnit"],
            "type": "INT",
        },
        1438: {
            "num": 1438,
            "names": ["DerivativeContractMultiplierUnit"],
            "type": "INT",
        },
        1439: {
            "num": 1439,
            "names": ["FlowScheduleType"],
            "type": "INT",
            "enum_type": True,
        },
        1440: {"num": 1440, "names": ["LegFlowScheduleType"], "type": "INT"},
        1441: {
            "num": 1441,
            "names": ["UnderlyingFlowScheduleType"],
            "type": "INT",
        },
        1442: {
            "num": 1442,
            "names": ["DerivativeFlowScheduleType"],
            "type": "INT",
        },
        1443: {"num": 1443, "names": ["FillLiquidityInd"], "type": "INT"},
        1444: {"num": 1444, "names": ["SideLiquidityInd"], "type": "INT"},
        1445: {"num": 1445, "names": ["NoRateSources"], "type": "NUMINGROUP"},
        1446: {
            "num": 1446,
            "names": ["RateSource"],
            "type": "INT",
            "enum_type": True,
        },
        1447: {
            "num": 1447,
            "names": ["RateSourceType"],
            "type": "INT",
            "enum_type": True,
        },
        1448: {"num": 1448, "names": ["ReferencePage"], "type": "STRING"},
        1449: {
            "num": 1449,
            "names": ["RestructuringType"],
            "type": "STRING",
            "enum_type": True,
        },
        1450: {
            "num": 1450,
            "names": ["Seniority"],
            "type": "STRING",
            "enum_type": True,
        },
        1451: {
            "num": 1451,
            "names": ["NotionalPercentageOutstanding"],
            "type": "PERCENTAGE",
        },
        1452: {
            "num": 1452,
            "names": ["OriginalNotionalPercentageOutstanding"],
            "type": "PERCENTAGE",
        },
        1453: {
            "num": 1453,
            "names": ["UnderlyingRestructuringType"],
            "type": "STRING",
        },
        1454: {
            "num": 1454,
            "names": ["UnderlyingSeniority"],
            "type": "STRING",
        },
        1455: {
            "num": 1455,
            "names": ["UnderlyingNotionalPercentageOutstanding"],
            "type": "PERCENTAGE",
        },
        1456: {
            "num": 1456,
            "names": ["UnderlyingOriginalNotionalPercentageOutstanding"],
            "type": "PERCENTAGE",
        },
        1457: {
            "num": 1457,
            "names": ["AttachmentPoint"],
            "type": "PERCENTAGE",
        },
        1458: {
            "num": 1458,
            "names": ["DetachmentPoint"],
            "type": "PERCENTAGE",
        },
        1459: {
            "num": 1459,
            "names": ["UnderlyingAttachmentPoint"],
            "type": "PERCENTAGE",
        },
        1460: {
            "num": 1460,
            "names": ["UnderlyingDetachmentPoint"],
            "type": "PERCENTAGE",
        },
        1461: {
            "num": 1461,
            "names": ["NoTargetPartyIDs"],
            "type": "NUMINGROUP",
        },
        1462: {"num": 1462, "names": ["TargetPartyID"], "type": "STRING"},
        1463: {"num": 1463, "names": ["TargetPartyIDSource"], "type": "CHAR"},
        1464: {"num": 1464, "names": ["TargetPartyRole"], "type": "INT"},
        1465: {"num": 1465, "names": ["SecurityListID"], "type": "STRING"},
        1466: {"num": 1466, "names": ["SecurityListRefID"], "type": "STRING"},
        1467: {"num": 1467, "names": ["SecurityListDesc"], "type": "STRING"},
        1468: {
            "num": 1468,
            "names": ["EncodedSecurityListDescLen"],
            "type": "LENGTH",
        },
        1469: {
            "num": 1469,
            "names": ["EncodedSecurityListDesc"],
            "type": "DATA",
        },
        1470: {
            "num": 1470,
            "names": ["SecurityListType"],
            "type": "INT",
            "enum_type": True,
        },
        1471: {
            "num": 1471,
            "names": ["SecurityListTypeSource"],
            "type": "INT",
            "enum_type": True,
        },
        1472: {"num": 1472, "names": ["NewsID"], "type": "STRING"},
        1473: {
            "num": 1473,
            "names": ["NewsCategory"],
            "type": "INT",
            "enum_type": True,
        },
        1474: {"num": 1474, "names": ["LanguageCode"], "type": "LANGUAGE"},
        1475: {"num": 1475, "names": ["NoNewsRefIDs"], "type": "NUMINGROUP"},
        1476: {"num": 1476, "names": ["NewsRefID"], "type": "STRING"},
        1477: {
            "num": 1477,
            "names": ["NewsRefType"],
            "type": "INT",
            "enum_type": True,
        },
        1478: {
            "num": 1478,
            "names": ["StrikePriceDeterminationMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1479: {
            "num": 1479,
            "names": ["StrikePriceBoundaryMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1480: {
            "num": 1480,
            "names": ["StrikePriceBoundaryPrecision"],
            "type": "PERCENTAGE",
        },
        1481: {
            "num": 1481,
            "names": ["UnderlyingPriceDeterminationMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1482: {
            "num": 1482,
            "names": ["OptPayoutType"],
            "type": "INT",
            "enum_type": True,
        },
        1483: {
            "num": 1483,
            "names": ["NoComplexEvents"],
            "type": "NUMINGROUP",
        },
        1484: {
            "num": 1484,
            "names": ["ComplexEventType"],
            "type": "INT",
            "enum_type": True,
        },
        1485: {
            "num": 1485,
            "names": ["ComplexOptPayoutAmount"],
            "type": "AMT",
        },
        1486: {"num": 1486, "names": ["ComplexEventPrice"], "type": "PRICE"},
        1487: {
            "num": 1487,
            "names": ["ComplexEventPriceBoundaryMethod"],
            "type": "INT",
            "enum_type": True,
        },
        1488: {
            "num": 1488,
            "names": ["ComplexEventPriceBoundaryPrecision"],
            "type": "PERCENTAGE",
        },
        1489: {
            "num": 1489,
            "names": ["ComplexEventPriceTimeType"],
            "type": "INT",
            "enum_type": True,
        },
        1490: {
            "num": 1490,
            "names": ["ComplexEventCondition"],
            "type": "INT",
            "enum_type": True,
        },
        1491: {
            "num": 1491,
            "names": ["NoComplexEventDates"],
            "type": "NUMINGROUP",
        },
        1492: {
            "num": 1492,
            "names": ["ComplexEventStartDate"],
            "type": "UTCTIMESTAMP",
        },
        1493: {
            "num": 1493,
            "names": ["ComplexEventEndDate"],
            "type": "UTCTIMESTAMP",
        },
        1494: {
            "num": 1494,
            "names": ["NoComplexEventTimes"],
            "type": "NUMINGROUP",
        },
        1495: {
            "num": 1495,
            "names": ["ComplexEventStartTime"],
            "type": "UTCTIMEONLY",
        },
        1496: {
            "num": 1496,
            "names": ["ComplexEventEndTime"],
            "type": "UTCTIMEONLY",
        },
        1497: {"num": 1497, "names": ["StreamAsgnReqID"], "type": "STRING"},
        1498: {
            "num": 1498,
            "names": ["StreamAsgnReqType"],
            "type": "INT",
            "enum_type": True,
        },
        1499: {"num": 1499, "names": ["NoAsgnReqs"], "type": "NUMINGROUP"},
        1500: {"num": 1500, "names": ["MDStreamID"], "type": "STRING"},
        1501: {"num": 1501, "names": ["StreamAsgnRptID"], "type": "STRING"},
        1502: {
            "num": 1502,
            "names": ["StreamAsgnRejReason"],
            "type": "INT",
            "enum_type": True,
        },
        1503: {
            "num": 1503,
            "names": ["StreamAsgnAckType"],
            "type": "INT",
            "enum_type": True,
        },
        1504: {
            "num": 1504,
            "names": ["RelSymTransactTime"],
            "type": "UTCTIMESTAMP",
        },
        1617: {
            "num": 1617,
            "names": ["StreamAsgnType"],
            "type": "INT",
            "enum_type": True,
        },
    },
    "enum_vals_by_tag": {
        4: [
            {"value": "B", "descr": "BUY"},
            {"value": "S", "descr": "SELL"},
            {"value": "T", "descr": "TRADE"},
            {"value": "X", "descr": "CROSS"},
        ],
        5: [
            {"value": "N", "descr": "NEW"},
            {"value": "C", "descr": "CANCEL"},
            {"value": "R", "descr": "REPLACE"},
        ],
        13: [
            {"value": "1", "descr": "PER_UNIT"},
            {"value": "2", "descr": "PERCENT"},
            {"value": "3", "descr": "ABSOLUTE"},
            {"value": "4", "descr": "PERCENTAGE_WAIVED_4"},
            {"value": "5", "descr": "PERCENTAGE_WAIVED_5"},
            {"value": "6", "descr": "POINTS_PER_BOND_OR_CONTRACT"},
        ],
        18: [
            {"value": "0", "descr": "STAY_ON_OFFER_SIDE"},
            {"value": "1", "descr": "NOT_HELD"},
            {"value": "2", "descr": "WORK"},
            {"value": "3", "descr": "GO_ALONG"},
            {"value": "4", "descr": "OVER_THE_DAY"},
            {"value": "5", "descr": "HELD"},
            {"value": "6", "descr": "PARTICIPATE_DONT_INITIATE"},
            {"value": "7", "descr": "STRICT_SCALE"},
            {"value": "8", "descr": "TRY_TO_SCALE"},
            {"value": "9", "descr": "STAY_ON_BID_SIDE"},
            {"value": "A", "descr": "NO_CROSS"},
            {"value": "B", "descr": "OK_TO_CROSS"},
            {"value": "C", "descr": "CALL_FIRST"},
            {"value": "D", "descr": "PERCENT_OF_VOLUME"},
            {"value": "E", "descr": "DO_NOT_INCREASE"},
            {"value": "F", "descr": "DO_NOT_REDUCE"},
            {"value": "G", "descr": "ALL_OR_NONE"},
            {"value": "H", "descr": "REINSTATE_ON_SYSTEM_FAILURE"},
            {"value": "I", "descr": "INSTITUTIONS_ONLY"},
            {"value": "J", "descr": "REINSTATE_ON_TRADING_HALT"},
            {"value": "K", "descr": "CANCEL_ON_TRADING_HALT"},
            {"value": "L", "descr": "LAST_PEG"},
            {"value": "M", "descr": "MID_PRICE_PEG"},
            {"value": "N", "descr": "NON_NEGOTIABLE"},
            {"value": "O", "descr": "OPENING_PEG"},
            {"value": "P", "descr": "MARKET_PEG"},
            {"value": "Q", "descr": "CANCEL_ON_SYSTEM_FAILURE"},
            {"value": "R", "descr": "PRIMARY_PEG"},
            {"value": "S", "descr": "SUSPEND"},
            {
                "value": "T",
                "descr": "FIXED_PEG_TO_LOCAL_BEST_BID_OR_OFFER_AT_TIME_OF_ORDER",
            },
            {"value": "U", "descr": "CUSTOMER_DISPLAY_INSTRUCTION"},
            {"value": "V", "descr": "NETTING"},
            {"value": "W", "descr": "PEG_TO_VWAP"},
            {"value": "X", "descr": "TRADE_ALONG"},
            {"value": "Y", "descr": "TRY_TO_STOP"},
            {"value": "Z", "descr": "CANCEL_IF_NOT_BEST"},
            {"value": "a", "descr": "TRAILING_STOP_PEG"},
            {"value": "b", "descr": "STRICT_LIMIT"},
            {"value": "c", "descr": "IGNORE_PRICE_VALIDITY_CHECKS"},
            {"value": "d", "descr": "PEG_TO_LIMIT_PRICE"},
            {"value": "e", "descr": "WORK_TO_TARGET_STRATEGY"},
            {"value": "f", "descr": "INTERMARKET_SWEEP"},
            {"value": "g", "descr": "EXTERNAL_ROUTING_ALLOWED"},
            {"value": "h", "descr": "EXTERNAL_ROUTING_NOT_ALLOWED"},
            {"value": "i", "descr": "IMBALANCE_ONLY"},
            {
                "value": "j",
                "descr": "SINGLE_EXECUTION_REQUESTED_FOR_BLOCK_TRADE",
            },
            {"value": "k", "descr": "BEST_EXECUTION"},
            {"value": "l", "descr": "SUSPEND_ON_SYSTEM_FAILURE"},
            {"value": "m", "descr": "SUSPEND_ON_TRADING_HALT"},
            {"value": "n", "descr": "REINSTATE_ON_CONNECTION_LOSS"},
            {"value": "o", "descr": "CANCEL_ON_CONNECTION_LOSS"},
            {"value": "p", "descr": "SUSPEND_ON_CONNECTION_LOSS"},
            {"value": "q", "descr": "RELEASE_FROM_SUSPENSION"},
            {
                "value": "r",
                "descr": "EXECUTE_AS_DELTA_NEUTRAL_USING_VOLATILITY_PROVIDED",
            },
            {"value": "s", "descr": "EXECUTE_AS_DURATION_NEUTRAL"},
            {"value": "t", "descr": "EXECUTE_AS_FX_NEUTRAL"},
        ],
        21: [
            {
                "value": "1",
                "descr": "AUTOMATED_EXECUTION_ORDER_PRIVATE_NO_BROKER_INTERVENTION",
            },
            {
                "value": "2",
                "descr": "AUTOMATED_EXECUTION_ORDER_PUBLIC_BROKER_INTERVENTION_OK",
            },
            {"value": "3", "descr": "MANUAL_ORDER_BEST_EXECUTION"},
        ],
        22: [
            {"value": "1", "descr": "CUSIP"},
            {"value": "2", "descr": "SEDOL"},
            {"value": "3", "descr": "QUIK"},
            {"value": "4", "descr": "ISIN_NUMBER"},
            {"value": "5", "descr": "RIC_CODE"},
            {"value": "6", "descr": "ISO_CURRENCY_CODE"},
            {"value": "7", "descr": "ISO_COUNTRY_CODE"},
            {"value": "8", "descr": "EXCHANGE_SYMBOL"},
            {"value": "9", "descr": "CONSOLIDATED_TAPE_ASSOCIATION"},
            {"value": "A", "descr": "BLOOMBERG_SYMBOL"},
            {"value": "B", "descr": "WERTPAPIER"},
            {"value": "C", "descr": "DUTCH"},
            {"value": "D", "descr": "VALOREN"},
            {"value": "E", "descr": "SICOVAM"},
            {"value": "F", "descr": "BELGIAN"},
            {"value": "G", "descr": "COMMON"},
            {"value": "H", "descr": "CLEARING_HOUSE"},
            {"value": "I", "descr": "ISDA_FPML_PRODUCT_SPECIFICATION"},
            {"value": "J", "descr": "OPTION_PRICE_REPORTING_AUTHORITY"},
            {"value": "K", "descr": "ISDA_FPML_PRODUCT_URL"},
            {"value": "L", "descr": "LETTER_OF_CREDIT"},
            {"value": "M", "descr": "MARKETPLACE_ASSIGNED_IDENTIFIER"},
        ],
        25: [
            {"value": "H", "descr": "HIGH"},
            {"value": "L", "descr": "LOW"},
            {"value": "M", "descr": "MEDIUM"},
        ],
        27: [
            {"value": "S", "descr": "SMALL"},
            {"value": "M", "descr": "MEDIUM"},
            {"value": "L", "descr": "LARGE"},
            {"value": "U", "descr": "UNDISCLOSED_QUANTITY"},
        ],
        28: [
            {"value": "N", "descr": "NEW"},
            {"value": "C", "descr": "CANCEL"},
            {"value": "R", "descr": "REPLACE"},
        ],
        29: [
            {"value": "1", "descr": "AGENT"},
            {"value": "2", "descr": "CROSS_AS_AGENT"},
            {"value": "3", "descr": "CROSS_AS_PRINCIPAL"},
            {"value": "4", "descr": "PRINCIPAL"},
        ],
        35: [
            {"value": "0", "descr": "HEARTBEAT"},
            {"value": "1", "descr": "TESTREQUEST"},
            {"value": "2", "descr": "RESENDREQUEST"},
            {"value": "3", "descr": "REJECT"},
            {"value": "4", "descr": "SEQUENCERESET"},
            {"value": "5", "descr": "LOGOUT"},
            {"value": "6", "descr": "IOI"},
            {"value": "7", "descr": "ADVERTISEMENT"},
            {"value": "8", "descr": "EXECUTIONREPORT"},
            {"value": "9", "descr": "ORDERCANCELREJECT"},
            {"value": "A", "descr": "LOGON"},
            {"value": "AA", "descr": "DERIVATIVESECURITYLIST"},
            {"value": "AB", "descr": "NEWORDERMULTILEG"},
            {"value": "AC", "descr": "MULTILEGORDERCANCELREPLACE"},
            {"value": "AD", "descr": "TRADECAPTUREREPORTREQUEST"},
            {"value": "AE", "descr": "TRADECAPTUREREPORT"},
            {"value": "AF", "descr": "ORDERMASSSTATUSREQUEST"},
            {"value": "AG", "descr": "QUOTEREQUESTREJECT"},
            {"value": "AH", "descr": "RFQREQUEST"},
            {"value": "AI", "descr": "QUOTESTATUSREPORT"},
            {"value": "AJ", "descr": "QUOTERESPONSE"},
            {"value": "AK", "descr": "CONFIRMATION"},
            {"value": "AL", "descr": "POSITIONMAINTENANCEREQUEST"},
            {"value": "AM", "descr": "POSITIONMAINTENANCEREPORT"},
            {"value": "AN", "descr": "REQUESTFORPOSITIONS"},
            {"value": "AO", "descr": "REQUESTFORPOSITIONSACK"},
            {"value": "AP", "descr": "POSITIONREPORT"},
            {"value": "AQ", "descr": "TRADECAPTUREREPORTREQUESTACK"},
            {"value": "AR", "descr": "TRADECAPTUREREPORTACK"},
            {"value": "AS", "descr": "ALLOCATIONREPORT"},
            {"value": "AT", "descr": "ALLOCATIONREPORTACK"},
            {"value": "AU", "descr": "CONFIRMATIONACK"},
            {"value": "AV", "descr": "SETTLEMENTINSTRUCTIONREQUEST"},
            {"value": "AW", "descr": "ASSIGNMENTREPORT"},
            {"value": "AX", "descr": "COLLATERALREQUEST"},
            {"value": "AY", "descr": "COLLATERALASSIGNMENT"},
            {"value": "AZ", "descr": "COLLATERALRESPONSE"},
            {"value": "B", "descr": "NEWS"},
            {"value": "BA", "descr": "COLLATERALREPORT"},
            {"value": "BB", "descr": "COLLATERALINQUIRY"},
            {"value": "BC", "descr": "NETWORKCOUNTERPARTYSYSTEMSTATUSREQUEST"},
            {
                "value": "BD",
                "descr": "NETWORKCOUNTERPARTYSYSTEMSTATUSRESPONSE",
            },
            {"value": "BE", "descr": "USERREQUEST"},
            {"value": "BF", "descr": "USERRESPONSE"},
            {"value": "BG", "descr": "COLLATERALINQUIRYACK"},
            {"value": "BH", "descr": "CONFIRMATIONREQUEST"},
            {"value": "BI", "descr": "TRADINGSESSIONLISTREQUEST"},
            {"value": "BJ", "descr": "TRADINGSESSIONLIST"},
            {"value": "BK", "descr": "SECURITYLISTUPDATEREPORT"},
            {"value": "BL", "descr": "ADJUSTEDPOSITIONREPORT"},
            {"value": "BM", "descr": "ALLOCATIONINSTRUCTIONALERT"},
            {"value": "BN", "descr": "EXECUTIONACKNOWLEDGEMENT"},
            {"value": "BO", "descr": "CONTRARYINTENTIONREPORT"},
            {"value": "BP", "descr": "SECURITYDEFINITIONUPDATEREPORT"},
            {"value": "BQ", "descr": "SETTLEMENTOBLIGATIONREPORT"},
            {"value": "BR", "descr": "DERIVATIVESECURITYLISTUPDATEREPORT"},
            {"value": "BS", "descr": "TRADINGSESSIONLISTUPDATEREPORT"},
            {"value": "BT", "descr": "MARKETDEFINITIONREQUEST"},
            {"value": "BU", "descr": "MARKETDEFINITION"},
            {"value": "BV", "descr": "MARKETDEFINITIONUPDATEREPORT"},
            {"value": "BW", "descr": "APPLICATIONMESSAGEREQUEST"},
            {"value": "BX", "descr": "APPLICATIONMESSAGEREQUESTACK"},
            {"value": "BY", "descr": "APPLICATIONMESSAGEREPORT"},
            {"value": "BZ", "descr": "ORDERMASSACTIONREPORT"},
            {"value": "C", "descr": "EMAIL"},
            {"value": "CA", "descr": "ORDERMASSACTIONREQUEST"},
            {"value": "CB", "descr": "USERNOTIFICATION"},
            {"value": "CC", "descr": "STREAMASSIGNMENTREQUEST"},
            {"value": "CD", "descr": "STREAMASSIGNMENTREPORT"},
            {"value": "CE", "descr": "STREAMASSIGNMENTREPORTACK"},
            {"value": "D", "descr": "NEWORDERSINGLE"},
            {"value": "E", "descr": "NEWORDERLIST"},
            {"value": "F", "descr": "ORDERCANCELREQUEST"},
            {"value": "G", "descr": "ORDERCANCELREPLACEREQUEST"},
            {"value": "H", "descr": "ORDERSTATUSREQUEST"},
            {"value": "J", "descr": "ALLOCATIONINSTRUCTION"},
            {"value": "K", "descr": "LISTCANCELREQUEST"},
            {"value": "L", "descr": "LISTEXECUTE"},
            {"value": "M", "descr": "LISTSTATUSREQUEST"},
            {"value": "N", "descr": "LISTSTATUS"},
            {"value": "P", "descr": "ALLOCATIONINSTRUCTIONACK"},
            {"value": "Q", "descr": "DONTKNOWTRADE"},
            {"value": "R", "descr": "QUOTEREQUEST"},
            {"value": "S", "descr": "QUOTE"},
            {"value": "T", "descr": "SETTLEMENTINSTRUCTIONS"},
            {"value": "V", "descr": "MARKETDATAREQUEST"},
            {"value": "W", "descr": "MARKETDATASNAPSHOTFULLREFRESH"},
            {"value": "X", "descr": "MARKETDATAINCREMENTALREFRESH"},
            {"value": "Y", "descr": "MARKETDATAREQUESTREJECT"},
            {"value": "Z", "descr": "QUOTECANCEL"},
            {"value": "a", "descr": "QUOTESTATUSREQUEST"},
            {"value": "b", "descr": "MASSQUOTEACKNOWLEDGEMENT"},
            {"value": "c", "descr": "SECURITYDEFINITIONREQUEST"},
            {"value": "d", "descr": "SECURITYDEFINITION"},
            {"value": "e", "descr": "SECURITYSTATUSREQUEST"},
            {"value": "f", "descr": "SECURITYSTATUS"},
            {"value": "g", "descr": "TRADINGSESSIONSTATUSREQUEST"},
            {"value": "h", "descr": "TRADINGSESSIONSTATUS"},
            {"value": "i", "descr": "MASSQUOTE"},
            {"value": "j", "descr": "BUSINESSMESSAGEREJECT"},
            {"value": "k", "descr": "BIDREQUEST"},
            {"value": "l", "descr": "BIDRESPONSE"},
            {"value": "m", "descr": "LISTSTRIKEPRICE"},
            {"value": "n", "descr": "XMLNONFIX"},
            {"value": "o", "descr": "REGISTRATIONINSTRUCTIONS"},
            {"value": "p", "descr": "REGISTRATIONINSTRUCTIONSRESPONSE"},
            {"value": "q", "descr": "ORDERMASSCANCELREQUEST"},
            {"value": "r", "descr": "ORDERMASSCANCELREPORT"},
            {"value": "s", "descr": "NEWORDERCROSS"},
            {"value": "t", "descr": "CROSSORDERCANCELREPLACEREQUEST"},
            {"value": "u", "descr": "CROSSORDERCANCELREQUEST"},
            {"value": "v", "descr": "SECURITYTYPEREQUEST"},
            {"value": "w", "descr": "SECURITYTYPES"},
            {"value": "x", "descr": "SECURITYLISTREQUEST"},
            {"value": "y", "descr": "SECURITYLIST"},
            {"value": "z", "descr": "DERIVATIVESECURITYLISTREQUEST"},
        ],
        39: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "PARTIALLY_FILLED"},
            {"value": "2", "descr": "FILLED"},
            {"value": "3", "descr": "DONE_FOR_DAY"},
            {"value": "4", "descr": "CANCELED"},
            {"value": "5", "descr": "REPLACED"},
            {"value": "6", "descr": "PENDING_CANCEL"},
            {"value": "7", "descr": "STOPPED"},
            {"value": "8", "descr": "REJECTED"},
            {"value": "9", "descr": "SUSPENDED"},
            {"value": "A", "descr": "PENDING_NEW"},
            {"value": "B", "descr": "CALCULATED"},
            {"value": "C", "descr": "EXPIRED"},
            {"value": "D", "descr": "ACCEPTED_FOR_BIDDING"},
            {"value": "E", "descr": "PENDING_REPLACE"},
        ],
        40: [
            {"value": "1", "descr": "MARKET"},
            {"value": "2", "descr": "LIMIT"},
            {"value": "3", "descr": "STOP"},
            {"value": "4", "descr": "STOP_LIMIT"},
            {"value": "5", "descr": "MARKET_ON_CLOSE"},
            {"value": "6", "descr": "WITH_OR_WITHOUT"},
            {"value": "7", "descr": "LIMIT_OR_BETTER"},
            {"value": "8", "descr": "LIMIT_WITH_OR_WITHOUT"},
            {"value": "9", "descr": "ON_BASIS"},
            {"value": "A", "descr": "ON_CLOSE"},
            {"value": "B", "descr": "LIMIT_ON_CLOSE"},
            {"value": "C", "descr": "FOREX_MARKET"},
            {"value": "D", "descr": "PREVIOUSLY_QUOTED"},
            {"value": "E", "descr": "PREVIOUSLY_INDICATED"},
            {"value": "F", "descr": "FOREX_LIMIT"},
            {"value": "G", "descr": "FOREX_SWAP"},
            {"value": "H", "descr": "FOREX_PREVIOUSLY_QUOTED"},
            {"value": "I", "descr": "FUNARI"},
            {"value": "J", "descr": "MARKET_IF_TOUCHED"},
            {"value": "K", "descr": "MARKET_WITH_LEFT_OVER_AS_LIMIT"},
            {"value": "L", "descr": "PREVIOUS_FUND_VALUATION_POINT"},
            {"value": "M", "descr": "NEXT_FUND_VALUATION_POINT"},
            {"value": "P", "descr": "PEGGED"},
            {"value": "Q", "descr": "COUNTER_ORDER_SELECTION"},
        ],
        43: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        54: [
            {"value": "1", "descr": "BUY"},
            {"value": "2", "descr": "SELL"},
            {"value": "3", "descr": "BUY_MINUS"},
            {"value": "4", "descr": "SELL_PLUS"},
            {"value": "5", "descr": "SELL_SHORT"},
            {"value": "6", "descr": "SELL_SHORT_EXEMPT"},
            {"value": "7", "descr": "UNDISCLOSED"},
            {"value": "8", "descr": "CROSS"},
            {"value": "9", "descr": "CROSS_SHORT"},
            {"value": "A", "descr": "CROSS_SHORT_EXEMPT"},
            {"value": "B", "descr": "AS_DEFINED"},
            {"value": "C", "descr": "OPPOSITE"},
            {"value": "D", "descr": "SUBSCRIBE"},
            {"value": "E", "descr": "REDEEM"},
            {"value": "F", "descr": "LEND"},
            {"value": "G", "descr": "BORROW"},
        ],
        59: [
            {"value": "0", "descr": "DAY"},
            {"value": "1", "descr": "GOOD_TILL_CANCEL"},
            {"value": "2", "descr": "AT_THE_OPENING"},
            {"value": "3", "descr": "IMMEDIATE_OR_CANCEL"},
            {"value": "4", "descr": "FILL_OR_KILL"},
            {"value": "5", "descr": "GOOD_TILL_CROSSING"},
            {"value": "6", "descr": "GOOD_TILL_DATE"},
            {"value": "7", "descr": "AT_THE_CLOSE"},
            {"value": "8", "descr": "GOOD_THROUGH_CROSSING"},
            {"value": "9", "descr": "AT_CROSSING"},
        ],
        61: [
            {"value": "0", "descr": "NORMAL"},
            {"value": "1", "descr": "FLASH"},
            {"value": "2", "descr": "BACKGROUND"},
        ],
        63: [
            {"value": "0", "descr": "REGULAR"},
            {"value": "1", "descr": "CASH"},
            {"value": "2", "descr": "NEXT_DAY"},
            {"value": "3", "descr": "T_PLUS_2"},
            {"value": "4", "descr": "T_PLUS_3"},
            {"value": "5", "descr": "T_PLUS_4"},
            {"value": "6", "descr": "FUTURE"},
            {"value": "7", "descr": "WHEN_AND_IF_ISSUED"},
            {"value": "8", "descr": "SELLERS_OPTION"},
            {"value": "9", "descr": "T_PLUS_5"},
            {"value": "B", "descr": "BROKEN_DATE"},
            {"value": "C", "descr": "FX_SPOT_NEXT_SETTLEMENT"},
        ],
        65: [
            {
                "value": "CD",
                "descr": "EUCP_WITH_LUMP_SUM_INTEREST_RATHER_THAN_DISCOUNT_PRICE",
            },
            {
                "value": "WI",
                "descr": "WHEN_ISSUED_FOR_A_SECURITY_TO_BE_REISSUED_UNDER_AN_OLD_CUSIP_OR_ISIN",
            },
        ],
        71: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "REPLACE"},
            {"value": "2", "descr": "CANCEL"},
            {"value": "3", "descr": "PRELIMINARY"},
            {"value": "4", "descr": "CALCULATED"},
            {"value": "5", "descr": "CALCULATED_WITHOUT_PRELIMINARY"},
            {"value": "6", "descr": "REVERSAL"},
        ],
        77: [
            {"value": "C", "descr": "CLOSE"},
            {"value": "F", "descr": "FIFO"},
            {"value": "O", "descr": "OPEN"},
            {"value": "R", "descr": "ROLLED"},
            {"value": "N", "descr": "CLOSE_BUT_NOTIFY_ON_OPEN"},
            {"value": "D", "descr": "DEFAULT"},
        ],
        81: [
            {"value": "0", "descr": "REGULAR"},
            {"value": "1", "descr": "SOFT_DOLLAR"},
            {"value": "2", "descr": "STEP_IN"},
            {"value": "3", "descr": "STEP_OUT"},
            {"value": "4", "descr": "SOFT_DOLLAR_STEP_IN"},
            {"value": "5", "descr": "SOFT_DOLLAR_STEP_OUT"},
            {"value": "6", "descr": "PLAN_SPONSOR"},
        ],
        87: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "BLOCK_LEVEL_REJECT"},
            {"value": "2", "descr": "ACCOUNT_LEVEL_REJECT"},
            {"value": "3", "descr": "RECEIVED"},
            {"value": "4", "descr": "INCOMPLETE"},
            {"value": "5", "descr": "REJECTED_BY_INTERMEDIARY"},
            {"value": "6", "descr": "ALLOCATION_PENDING"},
            {"value": "7", "descr": "REVERSED"},
        ],
        88: [
            {"value": "0", "descr": "UNKNOWN_ACCOUNT"},
            {"value": "1", "descr": "INCORRECT_QUANTITY"},
            {"value": "2", "descr": "INCORRECT_AVERAGEG_PRICE"},
            {"value": "3", "descr": "UNKNOWN_EXECUTING_BROKER_MNEMONIC"},
            {"value": "4", "descr": "COMMISSION_DIFFERENCE"},
            {"value": "5", "descr": "UNKNOWN_ORDERID"},
            {"value": "6", "descr": "UNKNOWN_LISTID"},
            {"value": "7", "descr": "OTHER_7"},
            {"value": "8", "descr": "INCORRECT_ALLOCATED_QUANTITY"},
            {"value": "9", "descr": "CALCULATION_DIFFERENCE"},
            {"value": "10", "descr": "UNKNOWN_OR_STALE_EXECID"},
            {"value": "11", "descr": "MISMATCHED_DATA"},
            {"value": "12", "descr": "UNKNOWN_CLORDID"},
            {"value": "13", "descr": "WAREHOUSE_REQUEST_REJECTED"},
            {"value": "99", "descr": "OTHER_99"},
        ],
        94: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "REPLY"},
            {"value": "2", "descr": "ADMIN_REPLY"},
        ],
        97: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        98: [
            {"value": "0", "descr": "NONE"},
            {"value": "1", "descr": "PKCS_1"},
            {"value": "2", "descr": "DES"},
            {"value": "3", "descr": "PKCS_3"},
            {"value": "4", "descr": "PGP_4"},
            {"value": "5", "descr": "PGP_5"},
            {"value": "6", "descr": "PEM"},
        ],
        102: [
            {"value": "0", "descr": "TOO_LATE_TO_CANCEL"},
            {"value": "1", "descr": "UNKNOWN_ORDER"},
            {"value": "2", "descr": "BROKER"},
            {
                "value": "3",
                "descr": "ORDER_ALREADY_IN_PENDING_CANCEL_OR_PENDING_REPLACE_STATUS",
            },
            {
                "value": "4",
                "descr": "UNABLE_TO_PROCESS_ORDER_MASS_CANCEL_REQUEST",
            },
            {"value": "5", "descr": "ORIGORDMODTIME"},
            {"value": "6", "descr": "DUPLICATE_CLORDID"},
            {"value": "7", "descr": "PRICE_EXCEEDS_CURRENT_PRICE"},
            {"value": "8", "descr": "PRICE_EXCEEDS_CURRENT_PRICE_BAND"},
            {"value": "18", "descr": "INVALID_PRICE_INCREMENT"},
            {"value": "99", "descr": "OTHER"},
        ],
        103: [
            {"value": "0", "descr": "BROKER"},
            {"value": "1", "descr": "UNKNOWN_SYMBOL"},
            {"value": "2", "descr": "EXCHANGE_CLOSED"},
            {"value": "3", "descr": "ORDER_EXCEEDS_LIMIT"},
            {"value": "4", "descr": "TOO_LATE_TO_ENTER"},
            {"value": "5", "descr": "UNKNOWN_ORDER"},
            {"value": "6", "descr": "DUPLICATE_ORDER"},
            {
                "value": "7",
                "descr": "DUPLICATE_OF_A_VERBALLY_COMMUNICATED_ORDER",
            },
            {"value": "8", "descr": "STALE_ORDER"},
            {"value": "9", "descr": "TRADE_ALONG_REQUIRED"},
            {"value": "10", "descr": "INVALID_INVESTOR_ID"},
            {"value": "11", "descr": "UNSUPPORTED_ORDER_CHARACTERISTIC"},
            {"value": "12", "descr": "SURVEILLENCE_OPTION"},
            {"value": "13", "descr": "INCORRECT_QUANTITY"},
            {"value": "14", "descr": "INCORRECT_ALLOCATED_QUANTITY"},
            {"value": "15", "descr": "UNKNOWN_ACCOUNT"},
            {"value": "16", "descr": "PRICE_EXCEEDS_CURRENT_PRICE_BAND"},
            {"value": "18", "descr": "INVALID_PRICE_INCREMENT"},
            {"value": "99", "descr": "OTHER"},
        ],
        104: [
            {"value": "A", "descr": "ALL_OR_NONE"},
            {"value": "B", "descr": "MARKET_ON_CLOSE"},
            {"value": "C", "descr": "AT_THE_CLOSE"},
            {"value": "D", "descr": "VWAP"},
            {"value": "I", "descr": "IN_TOUCH_WITH"},
            {"value": "L", "descr": "LIMIT"},
            {"value": "M", "descr": "MORE_BEHIND"},
            {"value": "O", "descr": "AT_THE_OPEN"},
            {"value": "P", "descr": "TAKING_A_POSITION"},
            {"value": "Q", "descr": "AT_THE_MARKET"},
            {"value": "R", "descr": "READY_TO_TRADE"},
            {"value": "S", "descr": "PORTFOLIO_SHOWN"},
            {"value": "T", "descr": "THROUGH_THE_DAY"},
            {"value": "V", "descr": "VERSUS"},
            {"value": "W", "descr": "INDICATION"},
            {"value": "X", "descr": "CROSSING_OPPORTUNITY"},
            {"value": "Y", "descr": "AT_THE_MIDPOINT"},
            {"value": "Z", "descr": "PRE_OPEN"},
        ],
        113: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        114: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        121: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        123: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        127: [
            {"value": "A", "descr": "UNKNOWN_SYMBOL"},
            {"value": "B", "descr": "WRONG_SIDE"},
            {"value": "C", "descr": "QUANTITY_EXCEEDS_ORDER"},
            {"value": "D", "descr": "NO_MATCHING_ORDER"},
            {"value": "E", "descr": "PRICE_EXCEEDS_LIMIT"},
            {"value": "F", "descr": "CALCULATION_DIFFERENCE"},
            {"value": "Z", "descr": "OTHER"},
        ],
        130: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        139: [
            {"value": "1", "descr": "REGULATORY"},
            {"value": "2", "descr": "TAX"},
            {"value": "3", "descr": "LOCAL_COMMISSION"},
            {"value": "4", "descr": "EXCHANGE_FEES"},
            {"value": "5", "descr": "STAMP"},
            {"value": "6", "descr": "LEVY"},
            {"value": "7", "descr": "OTHER"},
            {"value": "8", "descr": "MARKUP"},
            {"value": "9", "descr": "CONSUMPTION_TAX"},
            {"value": "10", "descr": "PER_TRANSACTION"},
            {"value": "11", "descr": "CONVERSION"},
            {"value": "12", "descr": "AGENT"},
            {"value": "13", "descr": "TRANSFER_FEE"},
            {"value": "14", "descr": "SECURITY_LENDING"},
        ],
        141: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        150: [
            {"value": "0", "descr": "NEW"},
            {"value": "3", "descr": "DONE_FOR_DAY"},
            {"value": "4", "descr": "CANCELED"},
            {"value": "5", "descr": "REPLACED"},
            {"value": "6", "descr": "PENDING_CANCEL"},
            {"value": "7", "descr": "STOPPED"},
            {"value": "8", "descr": "REJECTED"},
            {"value": "9", "descr": "SUSPENDED"},
            {"value": "A", "descr": "PENDING_NEW"},
            {"value": "B", "descr": "CALCULATED"},
            {"value": "C", "descr": "EXPIRED"},
            {"value": "D", "descr": "RESTATED"},
            {"value": "E", "descr": "PENDING_REPLACE"},
            {"value": "F", "descr": "TRADE"},
            {"value": "G", "descr": "TRADE_CORRECT"},
            {"value": "H", "descr": "TRADE_CANCEL"},
            {"value": "I", "descr": "ORDER_STATUS"},
            {"value": "J", "descr": "TRADE_IN_A_CLEARING_HOLD"},
            {"value": "K", "descr": "TRADE_HAS_BEEN_RELEASED_TO_CLEARING"},
            {"value": "L", "descr": "TRIGGERED_OR_ACTIVATED_BY_SYSTEM"},
        ],
        156: [
            {"value": "M", "descr": "MULTIPLY"},
            {"value": "D", "descr": "DIVIDE"},
        ],
        160: [
            {"value": "0", "descr": "DEFAULT"},
            {"value": "1", "descr": "STANDING_INSTRUCTIONS_PROVIDED"},
            {"value": "2", "descr": "SPECIFIC_ALLOCATION_ACCOUNT_OVERRIDING"},
            {"value": "3", "descr": "SPECIFIC_ALLOCATION_ACCOUNT_STANDING"},
            {"value": "4", "descr": "SPECIFIC_ORDER_FOR_A_SINGLE_ACCOUNT"},
            {"value": "5", "descr": "REQUEST_REJECT"},
        ],
        163: [
            {"value": "N", "descr": "NEW"},
            {"value": "C", "descr": "CANCEL"},
            {"value": "R", "descr": "REPLACE"},
            {"value": "T", "descr": "RESTATE"},
        ],
        165: [
            {"value": "1", "descr": "BROKERS_INSTRUCTIONS"},
            {"value": "2", "descr": "INSTITUTIONS_INSTRUCTIONS"},
            {"value": "3", "descr": "INVESTOR"},
        ],
        167: [
            {"value": "UST", "descr": "US_TREASURY_NOTE_UST"},
            {"value": "USTB", "descr": "US_TREASURY_BILL_USTB"},
            {"value": "EUSUPRA", "descr": "EURO_SUPRANATIONAL_COUPONS"},
            {"value": "FAC", "descr": "FEDERAL_AGENCY_COUPON"},
            {"value": "FADN", "descr": "FEDERAL_AGENCY_DISCOUNT_NOTE"},
            {"value": "PEF", "descr": "PRIVATE_EXPORT_FUNDING"},
            {"value": "SUPRA", "descr": "USD_SUPRANATIONAL_COUPONS"},
            {"value": "CORP", "descr": "CORPORATE_BOND"},
            {"value": "CPP", "descr": "CORPORATE_PRIVATE_PLACEMENT"},
            {"value": "CB", "descr": "CONVERTIBLE_BOND"},
            {"value": "DUAL", "descr": "DUAL_CURRENCY"},
            {"value": "EUCORP", "descr": "EURO_CORPORATE_BOND"},
            {"value": "EUFRN", "descr": "EURO_CORPORATE_FLOATING_RATE_NOTES"},
            {"value": "FRN", "descr": "US_CORPORATE_FLOATING_RATE_NOTES"},
            {"value": "XLINKD", "descr": "INDEXED_LINKED"},
            {"value": "STRUCT", "descr": "STRUCTURED_NOTES"},
            {"value": "YANK", "descr": "YANKEE_CORPORATE_BOND"},
            {"value": "FOR", "descr": "FOREIGN_EXCHANGE_CONTRACT"},
            {"value": "CDS", "descr": "CREDIT_DEFAULT_SWAP"},
            {"value": "FUT", "descr": "FUTURE"},
            {"value": "OPT", "descr": "OPTION"},
            {"value": "OOF", "descr": "OPTIONS_ON_FUTURES"},
            {"value": "OOP", "descr": "OPTIONS_ON_PHYSICAL"},
            {"value": "IRS", "descr": "INTEREST_RATE_SWAP"},
            {"value": "OOC", "descr": "OPTIONS_ON_COMBO"},
            {"value": "CS", "descr": "COMMON_STOCK"},
            {"value": "PS", "descr": "PREFERRED_STOCK"},
            {"value": "REPO", "descr": "REPURCHASE"},
            {"value": "FORWARD", "descr": "FORWARD"},
            {"value": "BUYSELL", "descr": "BUY_SELLBACK"},
            {"value": "SECLOAN", "descr": "SECURITIES_LOAN"},
            {"value": "SECPLEDGE", "descr": "SECURITIES_PLEDGE"},
            {"value": "BRADY", "descr": "BRADY_BOND"},
            {"value": "CAN", "descr": "CANADIAN_TREASURY_NOTES"},
            {"value": "CTB", "descr": "CANADIAN_TREASURY_BILLS"},
            {"value": "EUSOV", "descr": "EURO_SOVEREIGNS"},
            {"value": "PROV", "descr": "CANADIAN_PROVINCIAL_BONDS"},
            {"value": "TB", "descr": "TREASURY_BILL"},
            {"value": "TBOND", "descr": "US_TREASURY_BOND"},
            {"value": "TINT", "descr": "INTEREST_STRIP_FROM_ANY_BOND_OR_NOTE"},
            {"value": "TBILL", "descr": "US_TREASURY_BILL_TBILL"},
            {
                "value": "TIPS",
                "descr": "TREASURY_INFLATION_PROTECTED_SECURITIES",
            },
            {
                "value": "TCAL",
                "descr": "PRINCIPAL_STRIP_OF_A_CALLABLE_BOND_OR_NOTE",
            },
            {
                "value": "TPRN",
                "descr": "PRINCIPAL_STRIP_FROM_A_NON_CALLABLE_BOND_OR_NOTE",
            },
            {"value": "TNOTE", "descr": "US_TREASURY_NOTE_TNOTE"},
            {"value": "TERM", "descr": "TERM_LOAN"},
            {"value": "RVLV", "descr": "REVOLVER_LOAN"},
            {"value": "RVLVTRM", "descr": "REVOLVER_TERM_LOAN"},
            {"value": "BRIDGE", "descr": "BRIDGE_LOAN"},
            {"value": "LOFC", "descr": "LETTER_OF_CREDIT"},
            {"value": "SWING", "descr": "SWING_LINE_FACILITY"},
            {"value": "DINP", "descr": "DEBTOR_IN_POSSESSION"},
            {"value": "DEFLTED", "descr": "DEFAULTED"},
            {"value": "WITHDRN", "descr": "WITHDRAWN"},
            {"value": "REPLACD", "descr": "REPLACED"},
            {"value": "MATURED", "descr": "MATURED"},
            {"value": "AMENDED", "descr": "AMENDED_RESTATED"},
            {"value": "RETIRED", "descr": "RETIRED"},
            {"value": "BA", "descr": "BANKERS_ACCEPTANCE"},
            {"value": "BDN", "descr": "BANK_DEPOSITORY_NOTE"},
            {"value": "BN", "descr": "BANK_NOTES"},
            {"value": "BOX", "descr": "BILL_OF_EXCHANGES"},
            {"value": "CAMM", "descr": "CANADIAN_MONEY_MARKETS"},
            {"value": "CD", "descr": "CERTIFICATE_OF_DEPOSIT"},
            {"value": "CL", "descr": "CALL_LOANS"},
            {"value": "CP", "descr": "COMMERCIAL_PAPER"},
            {"value": "DN", "descr": "DEPOSIT_NOTES"},
            {"value": "EUCD", "descr": "EURO_CERTIFICATE_OF_DEPOSIT"},
            {"value": "EUCP", "descr": "EURO_COMMERCIAL_PAPER"},
            {"value": "LQN", "descr": "LIQUIDITY_NOTE"},
            {"value": "MTN", "descr": "MEDIUM_TERM_NOTES"},
            {"value": "ONITE", "descr": "OVERNIGHT"},
            {"value": "PN", "descr": "PROMISSORY_NOTE"},
            {"value": "STN", "descr": "SHORT_TERM_LOAN_NOTE"},
            {"value": "PZFJ", "descr": "PLAZOS_FIJOS"},
            {"value": "SLQN", "descr": "SECURED_LIQUIDITY_NOTE"},
            {"value": "TD", "descr": "TIME_DEPOSIT"},
            {"value": "TLQN", "descr": "TERM_LIQUIDITY_NOTE"},
            {"value": "XCN", "descr": "EXTENDED_COMM_NOTE"},
            {"value": "YCD", "descr": "YANKEE_CERTIFICATE_OF_DEPOSIT"},
            {"value": "ABS", "descr": "ASSET_BACKED_SECURITIES"},
            {"value": "CMB", "descr": "CANADIAN_MORTGAGE_BONDS"},
            {"value": "CMBS", "descr": "CORP_MORTGAGE_BACKED_SECURITIES"},
            {"value": "CMO", "descr": "COLLATERALIZED_MORTGAGE_OBLIGATION"},
            {"value": "IET", "descr": "IOETTE_MORTGAGE"},
            {"value": "MBS", "descr": "MORTGAGE_BACKED_SECURITIES"},
            {"value": "MIO", "descr": "MORTGAGE_INTEREST_ONLY"},
            {"value": "MPO", "descr": "MORTGAGE_PRINCIPAL_ONLY"},
            {"value": "MPP", "descr": "MORTGAGE_PRIVATE_PLACEMENT"},
            {"value": "MPT", "descr": "MISCELLANEOUS_PASS_THROUGH"},
            {"value": "PFAND", "descr": "PFANDBRIEFE"},
            {"value": "TBA", "descr": "TO_BE_ANNOUNCED"},
            {"value": "AN", "descr": "OTHER_ANTICIPATION_NOTES"},
            {"value": "COFO", "descr": "CERTIFICATE_OF_OBLIGATION"},
            {"value": "COFP", "descr": "CERTIFICATE_OF_PARTICIPATION"},
            {"value": "GO", "descr": "GENERAL_OBLIGATION_BONDS"},
            {"value": "MT", "descr": "MANDATORY_TENDER"},
            {"value": "RAN", "descr": "REVENUE_ANTICIPATION_NOTE"},
            {"value": "REV", "descr": "REVENUE_BONDS"},
            {"value": "SPCLA", "descr": "SPECIAL_ASSESSMENT"},
            {"value": "SPCLO", "descr": "SPECIAL_OBLIGATION"},
            {"value": "SPCLT", "descr": "SPECIAL_TAX"},
            {"value": "TAN", "descr": "TAX_ANTICIPATION_NOTE"},
            {"value": "TAXA", "descr": "TAX_ALLOCATION"},
            {"value": "TECP", "descr": "TAX_EXEMPT_COMMERCIAL_PAPER"},
            {"value": "TMCP", "descr": "TAXABLE_MUNICIPAL_CP"},
            {"value": "TRAN", "descr": "TAX_REVENUE_ANTICIPATION_NOTE"},
            {"value": "VRDN", "descr": "VARIABLE_RATE_DEMAND_NOTE"},
            {"value": "WAR", "descr": "WARRANT"},
            {"value": "MF", "descr": "MUTUAL_FUND"},
            {"value": "MLEG", "descr": "MULTILEG_INSTRUMENT"},
            {"value": "NONE", "descr": "NO_SECURITY_TYPE"},
            {
                "value": "?",
                "descr": "WILDCARD_ENTRY_FOR_USE_ON_SECURITY_DEFINITION_REQUEST",
            },
            {"value": "CASH", "descr": "CASH"},
            {"value": "FXNDF", "descr": "NON_DELIVERABLE_FORWARD"},
            {"value": "FXSPOT", "descr": "FX_SPOT"},
            {"value": "FXFWD", "descr": "FX_FORWARD"},
            {"value": "FXSWAP", "descr": "FX_SWAP"},
        ],
        169: [
            {"value": "0", "descr": "OTHER"},
            {"value": "1", "descr": "DTC_SID"},
            {"value": "2", "descr": "THOMSON_ALERT"},
            {"value": "3", "descr": "A_GLOBAL_CUSTODIAN"},
            {"value": "4", "descr": "ACCOUNTNET"},
        ],
        172: [
            {"value": "0", "descr": "VERSUS_PAYMENT_DELIVER"},
            {"value": "1", "descr": "FREE_DELIVER"},
            {"value": "2", "descr": "TRI_PARTY"},
            {"value": "3", "descr": "HOLD_IN_CUSTODY"},
        ],
        197: [
            {"value": "0", "descr": "FX_NETTING"},
            {"value": "1", "descr": "FX_SWAP"},
        ],
        201: [{"value": "0", "descr": "PUT"}, {"value": "1", "descr": "CALL"}],
        203: [
            {"value": "0", "descr": "COVERED"},
            {"value": "1", "descr": "UNCOVERED"},
        ],
        208: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        209: [
            {"value": "1", "descr": "MATCH"},
            {"value": "2", "descr": "FORWARD"},
            {"value": "3", "descr": "FORWARD_AND_MATCH"},
        ],
        216: [
            {"value": "1", "descr": "TARGET_FIRM"},
            {"value": "2", "descr": "TARGET_LIST"},
            {"value": "3", "descr": "BLOCK_FIRM"},
            {"value": "4", "descr": "BLOCK_LIST"},
        ],
        221: [
            {"value": "EONIA", "descr": "EONIA"},
            {"value": "EUREPO", "descr": "EUREPO"},
            {"value": "Euribor", "descr": "EURIBOR"},
            {"value": "FutureSWAP", "descr": "FUTURESWAP"},
            {"value": "LIBID", "descr": "LIBID"},
            {"value": "LIBOR", "descr": "LIBOR"},
            {"value": "MuniAAA", "descr": "MUNIAAA"},
            {"value": "OTHER", "descr": "OTHER"},
            {"value": "Pfandbriefe", "descr": "PFANDBRIEFE"},
            {"value": "SONIA", "descr": "SONIA"},
            {"value": "SWAP", "descr": "SWAP"},
            {"value": "Treasury", "descr": "TREASURY"},
        ],
        233: [
            {"value": "AMT", "descr": "ALTERNATIVE_MINIMUM_TAX"},
            {
                "value": "AUTOREINV",
                "descr": "AUTO_REINVESTMENT_AT_RATE_OR_BETTER",
            },
            {"value": "BANKQUAL", "descr": "BANK_QUALIFIED"},
            {"value": "BGNCON", "descr": "BARGAIN_CONDITIONS"},
            {"value": "COUPON", "descr": "COUPON_RANGE"},
            {"value": "CURRENCY", "descr": "ISO_CURRENCY_CODE"},
            {"value": "CUSTOMDATE", "descr": "CUSTOM_START_END_DATE"},
            {"value": "GEOG", "descr": "GEOGRAPHICS_AND_RANGE"},
            {"value": "HAIRCUT", "descr": "VALUATION_DISCOUNT"},
            {"value": "INSURED", "descr": "INSURED"},
            {"value": "ISSUE", "descr": "YEAR_OR_YEAR_MONTH_OF_ISSUE"},
            {"value": "ISSUER", "descr": "ISSUERS_TICKER"},
            {"value": "ISSUESIZE", "descr": "ISSUE_SIZE_RANGE"},
            {"value": "LOOKBACK", "descr": "LOOKBACK_DAYS"},
            {"value": "LOT", "descr": "EXPLICIT_LOT_IDENTIFIER"},
            {"value": "LOTVAR", "descr": "LOT_VARIANCE"},
            {"value": "MAT", "descr": "MATURITY_YEAR_AND_MONTH"},
            {"value": "MATURITY", "descr": "MATURITY_RANGE"},
            {"value": "MAXSUBS", "descr": "MAXIMUM_SUBSTITUTIONS"},
            {"value": "MINDNOM", "descr": "MINIMUM_DENOMINATION"},
            {"value": "MININCR", "descr": "MINIMUM_INCREMENT"},
            {"value": "MINQTY", "descr": "MINIMUM_QUANTITY"},
            {"value": "PAYFREQ", "descr": "PAYMENT_FREQUENCY_CALENDAR"},
            {"value": "PIECES", "descr": "NUMBER_OF_PIECES"},
            {"value": "PMAX", "descr": "POOLS_MAXIMUM"},
            {"value": "PPL", "descr": "POOLS_PER_LOT"},
            {"value": "PPM", "descr": "POOLS_PER_MILLION"},
            {"value": "PPT", "descr": "POOLS_PER_TRADE"},
            {"value": "PRICE", "descr": "PRICE_RANGE"},
            {"value": "PRICEFREQ", "descr": "PRICING_FREQUENCY"},
            {"value": "PROD", "descr": "PRODUCTION_YEAR"},
            {"value": "PROTECT", "descr": "CALL_PROTECTION"},
            {"value": "PURPOSE", "descr": "PURPOSE"},
            {"value": "PXSOURCE", "descr": "BENCHMARK_PRICE_SOURCE"},
            {"value": "RATING", "descr": "RATING_SOURCE_AND_RANGE"},
            {"value": "REDEMPTION", "descr": "TYPE_OF_REDEMPTION"},
            {"value": "RESTRICTED", "descr": "RESTRICTED"},
            {"value": "SECTOR", "descr": "MARKET_SECTOR"},
            {
                "value": "SECTYPE",
                "descr": "SECURITY_TYPE_INCLUDED_OR_EXCLUDED",
            },
            {"value": "STRUCT", "descr": "STRUCTURE"},
            {"value": "SUBSFREQ", "descr": "SUBSTITUTIONS_FREQUENCY"},
            {"value": "SUBSLEFT", "descr": "SUBSTITUTIONS_LEFT"},
            {"value": "TEXT", "descr": "FREEFORM_TEXT"},
            {"value": "TRDVAR", "descr": "TRADE_VARIANCE"},
            {"value": "WAC", "descr": "WEIGHTED_AVERAGE_COUPON"},
            {"value": "WAL", "descr": "WEIGHTED_AVERAGE_LIFE_COUPON"},
            {"value": "WALA", "descr": "WEIGHTED_AVERAGE_LOAN_AGE"},
            {"value": "WAM", "descr": "WEIGHTED_AVERAGE_MATURITY"},
            {"value": "WHOLE", "descr": "WHOLE_POOL"},
            {"value": "YIELD", "descr": "YIELD_RANGE"},
            {"value": "AVFICO", "descr": "AVERAGE_FICO_SCORE"},
            {"value": "AVSIZE", "descr": "AVERAGE_LOAN_SIZE"},
            {"value": "MAXBAL", "descr": "MAXIMUM_LOAN_BALANCE"},
            {"value": "POOL", "descr": "POOL_IDENTIFIER"},
            {"value": "ROLLTYPE", "descr": "TYPE_OF_ROLL_TRADE"},
            {
                "value": "REFTRADE",
                "descr": "REFERENCE_TO_ROLLING_OR_CLOSING_TRADE",
            },
            {
                "value": "REFPRIN",
                "descr": "PRINCIPAL_OF_ROLLING_OR_CLOSING_TRADE",
            },
            {
                "value": "REFINT",
                "descr": "INTEREST_OF_ROLLING_OR_CLOSING_TRADE",
            },
            {
                "value": "AVAILQTY",
                "descr": "AVAILABLE_OFFER_QUANTITY_TO_BE_SHOWN_TO_THE_STREET",
            },
            {"value": "BROKERCREDIT", "descr": "BROKERS_SALES_CREDIT"},
            {
                "value": "INTERNALPX",
                "descr": "OFFER_PRICE_TO_BE_SHOWN_TO_INTERNAL_BROKERS",
            },
            {
                "value": "INTERNALQTY",
                "descr": "OFFER_QUANTITY_TO_BE_SHOWN_TO_INTERNAL_BROKERS",
            },
            {
                "value": "LEAVEQTY",
                "descr": "THE_MINIMUM_RESIDUAL_OFFER_QUANTITY",
            },
            {"value": "MAXORDQTY", "descr": "MAXIMUM_ORDER_SIZE"},
            {"value": "ORDRINCR", "descr": "ORDER_QUANTITY_INCREMENT"},
            {
                "value": "PRIMARY",
                "descr": "PRIMARY_OR_SECONDARY_MARKET_INDICATOR",
            },
            {
                "value": "SALESCREDITOVR",
                "descr": "BROKER_SALES_CREDIT_OVERRIDE",
            },
            {"value": "TRADERCREDIT", "descr": "TRADERS_CREDIT"},
            {"value": "DISCOUNT", "descr": "DISCOUNT_RATE"},
            {"value": "YTM", "descr": "YIELD_TO_MATURITY"},
            {"value": "ABS", "descr": "ABSOLUTE_PREPAYMENT_SPEED"},
            {"value": "CPP", "descr": "CONSTANT_PREPAYMENT_PENALTY"},
            {"value": "CPR", "descr": "CONSTANT_PREPAYMENT_RATE"},
            {"value": "CPY", "descr": "CONSTANT_PREPAYMENT_YIELD"},
            {
                "value": "HEP",
                "descr": "FINAL_CPR_OF_HOME_EQUITY_PREPAYMENT_CURVE",
            },
            {
                "value": "MHP",
                "descr": "PERCENT_OF_MANUFACTURED_HOUSING_PREPAYMENT_CURVE",
            },
            {"value": "MPR", "descr": "MONTHLY_PREPAYMENT_RATE"},
            {
                "value": "PPC",
                "descr": "PERCENT_OF_PROSPECTUS_PREPAYMENT_CURVE",
            },
            {"value": "PSA", "descr": "PERCENT_OF_BMA_PREPAYMENT_CURVE"},
            {"value": "SMM", "descr": "SINGLE_MONTHLY_MORTALITY"},
        ],
        235: [
            {"value": "AFTERTAX", "descr": "AFTER_TAX_YIELD"},
            {"value": "ANNUAL", "descr": "ANNUAL_YIELD"},
            {"value": "ATISSUE", "descr": "YIELD_AT_ISSUE"},
            {"value": "AVGMATURITY", "descr": "YIELD_TO_AVG_MATURITY"},
            {"value": "BOOK", "descr": "BOOK_YIELD"},
            {"value": "CALL", "descr": "YIELD_TO_NEXT_CALL"},
            {"value": "CHANGE", "descr": "YIELD_CHANGE_SINCE_CLOSE"},
            {"value": "CLOSE", "descr": "CLOSING_YIELD"},
            {"value": "COMPOUND", "descr": "COMPOUND_YIELD"},
            {"value": "CURRENT", "descr": "CURRENT_YIELD"},
            {"value": "GOVTEQUIV", "descr": "GVNT_EQUIVALENT_YIELD"},
            {"value": "GROSS", "descr": "TRUE_GROSS_YIELD"},
            {"value": "INFLATION", "descr": "YIELD_WITH_INFLATION_ASSUMPTION"},
            {"value": "INVERSEFLOATER", "descr": "INVERSE_FLOATER_BOND_YIELD"},
            {"value": "LASTCLOSE", "descr": "MOST_RECENT_CLOSING_YIELD"},
            {"value": "LASTMONTH", "descr": "CLOSING_YIELD_MOST_RECENT_MONTH"},
            {
                "value": "LASTQUARTER",
                "descr": "CLOSING_YIELD_MOST_RECENT_QUARTER",
            },
            {"value": "LASTYEAR", "descr": "CLOSING_YIELD_MOST_RECENT_YEAR"},
            {"value": "LONGAVGLIFE", "descr": "YIELD_TO_LONGEST_AVERAGE_LIFE"},
            {"value": "MARK", "descr": "MARK_TO_MARKET_YIELD"},
            {"value": "MATURITY", "descr": "YIELD_TO_MATURITY"},
            {"value": "NEXTREFUND", "descr": "YIELD_TO_NEXT_REFUND"},
            {"value": "OPENAVG", "descr": "OPEN_AVERAGE_YIELD"},
            {"value": "PREVCLOSE", "descr": "PREVIOUS_CLOSE_YIELD"},
            {"value": "PROCEEDS", "descr": "PROCEEDS_YIELD"},
            {"value": "PUT", "descr": "YIELD_TO_NEXT_PUT"},
            {"value": "SEMIANNUAL", "descr": "SEMI_ANNUAL_YIELD"},
            {
                "value": "SHORTAVGLIFE",
                "descr": "YIELD_TO_SHORTEST_AVERAGE_LIFE",
            },
            {"value": "SIMPLE", "descr": "SIMPLE_YIELD"},
            {"value": "TAXEQUIV", "descr": "TAX_EQUIVALENT_YIELD"},
            {"value": "TENDER", "descr": "YIELD_TO_TENDER_DATE"},
            {"value": "TRUE", "descr": "TRUE_YIELD"},
            {"value": "VALUE1_32", "descr": "YIELD_VALUE_OF_1_32"},
            {"value": "WORST", "descr": "YIELD_TO_WORST"},
        ],
        258: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        263: [
            {"value": "0", "descr": "SNAPSHOT"},
            {"value": "1", "descr": "SNAPSHOT_PLUS_UPDATES"},
            {
                "value": "2",
                "descr": "DISABLE_PREVIOUS_SNAPSHOT_PLUS_UPDATE_REQUEST",
            },
        ],
        265: [
            {"value": "0", "descr": "FULL_REFRESH"},
            {"value": "1", "descr": "INCREMENTAL_REFRESH"},
        ],
        266: [{"value": "Y", "descr": "YES"}, {"value": "N", "descr": "NO"}],
        269: [
            {"value": "0", "descr": "BID"},
            {"value": "1", "descr": "OFFER"},
            {"value": "2", "descr": "TRADE"},
            {"value": "3", "descr": "INDEX_VALUE"},
            {"value": "4", "descr": "OPENING_PRICE"},
            {"value": "5", "descr": "CLOSING_PRICE"},
            {"value": "6", "descr": "SETTLEMENT_PRICE"},
            {"value": "7", "descr": "TRADING_SESSION_HIGH_PRICE"},
            {"value": "8", "descr": "TRADING_SESSION_LOW_PRICE"},
            {"value": "9", "descr": "TRADING_SESSION_VWAP_PRICE"},
            {"value": "A", "descr": "IMBALANCE"},
            {"value": "B", "descr": "TRADE_VOLUME"},
            {"value": "C", "descr": "OPEN_INTEREST"},
            {"value": "D", "descr": "COMPOSITE_UNDERLYING_PRICE"},
            {"value": "E", "descr": "SIMULATED_SELL_PRICE"},
            {"value": "F", "descr": "SIMULATED_BUY_PRICE"},
            {"value": "G", "descr": "MARGIN_RATE"},
            {"value": "H", "descr": "MID_PRICE"},
            {"value": "J", "descr": "EMPTY_BOOK"},
            {"value": "K", "descr": "SETTLE_HIGH_PRICE"},
            {"value": "L", "descr": "SETTLE_LOW_PRICE"},
            {"value": "M", "descr": "PRIOR_SETTLE_PRICE"},
            {"value": "N", "descr": "SESSION_HIGH_BID"},
            {"value": "O", "descr": "SESSION_LOW_OFFER"},
            {"value": "P", "descr": "EARLY_PRICES"},
            {"value": "Q", "descr": "AUCTION_CLEARING_PRICE"},
            {"value": "S", "descr": "SWAP_VALUE_FACTOR"},
            {
                "value": "R",
                "descr": "DAILY_VALUE_ADJUSTMENT_FOR_LONG_POSITIONS",
            },
            {
                "value": "T",
                "descr": "CUMULATIVE_VALUE_ADJUSTMENT_FOR_LONG_POSITIONS",
            },
            {
                "value": "U",
                "descr": "DAILY_VALUE_ADJUSTMENT_FOR_SHORT_POSITIONS",
            },
            {
                "value": "V",
                "descr": "CUMULATIVE_VALUE_ADJUSTMENT_FOR_SHORT_POSITIONS",
            },
            {"value": "Y", "descr": "RECOVERY_RATE"},
            {"value": "Z", "descr": "RECOVERY_RATE_FOR_LONG"},
            {"value": "a", "descr": "RECOVERY_RATE_FOR_SHORT"},
            {"value": "W", "descr": "FIXING_PRICE"},
            {"value": "X", "descr": "CASH_RATE"},
        ],
        274: [
            {"value": "0", "descr": "PLUS_TICK"},
            {"value": "1", "descr": "ZERO_PLUS_TICK"},
            {"value": "2", "descr": "MINUS_TICK"},
            {"value": "3", "descr": "ZERO_MINUS_TICK"},
        ],
        276: [
            {"value": "A", "descr": "OPEN_ACTIVE"},
            {"value": "B", "descr": "CLOSED_INACTIVE"},
            {"value": "C", "descr": "EXCHANGE_BEST"},
            {"value": "D", "descr": "CONSOLIDATED_BEST"},
            {"value": "E", "descr": "LOCKED"},
            {"value": "F", "descr": "CROSSED"},
            {"value": "G", "descr": "DEPTH"},
            {"value": "H", "descr": "FAST_TRADING"},
            {"value": "I", "descr": "NON_FIRM"},
            {"value": "L", "descr": "MANUAL_SLOW_QUOTE"},
            {"value": "J", "descr": "OUTRIGHT_PRICE"},
            {"value": "K", "descr": "IMPLIED_PRICE"},
            {"value": "M", "descr": "DEPTH_ON_OFFER"},
            {"value": "N", "descr": "DEPTH_ON_BID"},
            {"value": "O", "descr": "CLOSING"},
            {"value": "P", "descr": "NEWS_DISSEMINATION"},
            {"value": "Q", "descr": "TRADING_RANGE"},
            {"value": "R", "descr": "ORDER_INFLUX"},
            {"value": "S", "descr": "DUE_TO_RELATED"},
            {"value": "T", "descr": "NEWS_PENDING"},
            {"value": "U", "descr": "ADDITIONAL_INFO"},
            {"value": "V", "descr": "ADDITIONAL_INFO_DUE_TO_RELATED"},
            {"value": "W", "descr": "RESUME"},
            {"value": "X", "descr": "VIEW_OF_COMMON"},
            {"value": "Y", "descr": "VOLUME_ALERT"},
            {"value": "Z", "descr": "ORDER_IMBALANCE"},
            {"value": "a", "descr": "EQUIPMENT_CHANGEOVER"},
            {"value": "b", "descr": "NO_OPEN"},
            {"value": "c", "descr": "REGULAR_ETH"},
            {"value": "d", "descr": "AUTOMATIC_EXECUTION"},
            {"value": "e", "descr": "AUTOMATIC_EXECUTION_ETH"},
            {"value": "f ", "descr": "FAST_MARKET_ETH"},
            {"value": "g", "descr": "INACTIVE_ETH"},
            {"value": "h", "descr": "ROTATION"},
            {"value": "i", "descr": "ROTATION_ETH"},
            {"value": "j", "descr": "HALT"},
            {"value": "k", "descr": "HALT_ETH"},
            {"value": "l", "descr": "DUE_TO_NEWS_DISSEMINATION"},
            {"value": "m", "descr": "DUE_TO_NEWS_PENDING"},
            {"value": "n", "descr": "TRADING_RESUME"},
            {"value": "o", "descr": "OUT_OF_SEQUENCE"},
            {"value": "p", "descr": "BID_SPECIALIST"},
            {"value": "q", "descr": "OFFER_SPECIALIST"},
            {"value": "r", "descr": "BID_OFFER_SPECIALIST"},
            {"value": "s", "descr": "END_OF_DAY_SAM"},
            {"value": "t", "descr": "FORBIDDEN_SAM"},
            {"value": "u", "descr": "FROZEN_SAM"},
            {"value": "v", "descr": "PREOPENING_SAM"},
            {"value": "w", "descr": "OPENING_SAM"},
            {"value": "x", "descr": "OPEN_SAM"},
            {"value": "y", "descr": "SURVEILLANCE_SAM"},
            {"value": "z", "descr": "SUSPENDED_SAM"},
            {"value": "0", "descr": "RESERVED_SAM"},
            {"value": "1", "descr": "NO_ACTIVE_SAM"},
            {"value": "2", "descr": "RESTRICTED"},
            {"value": "3", "descr": "REST_OF_BOOK_VWAP"},
            {"value": "4", "descr": "BETTER_PRICES_IN_CONDITIONAL_ORDERS"},
            {"value": "5", "descr": "MEDIAN_PRICE"},
            {"value": "6", "descr": "FULL_CURVE"},
            {"value": "7", "descr": "FLAT_CURVE"},
        ],
        277: [
            {"value": "A", "descr": "CASH"},
            {"value": "B", "descr": "AVERAGE_PRICE_TRADE"},
            {"value": "C", "descr": "CASH_TRADE"},
            {"value": "D", "descr": "NEXT_DAY"},
            {"value": "E", "descr": "OPENING_REOPENING_TRADE_DETAIL"},
            {"value": "F", "descr": "INTRADAY_TRADE_DETAIL"},
            {"value": "G", "descr": "RULE_127_TRADE"},
            {"value": "H", "descr": "RULE_155_TRADE"},
            {"value": "I", "descr": "SOLD_LAST"},
            {"value": "J", "descr": "NEXT_DAY_TRADE"},
            {"value": "K", "descr": "OPENED"},
            {"value": "L", "descr": "SELLER"},
            {"value": "M", "descr": "SOLD"},
            {"value": "N", "descr": "STOPPED_STOCK"},
            {"value": "P", "descr": "IMBALANCE_MORE_BUYERS"},
            {"value": "Q", "descr": "IMBALANCE_MORE_SELLERS"},
            {"value": "R", "descr": "OPENING_PRICE"},
            {"value": "S", "descr": "BARGAIN_CONDITION"},
            {"value": "T", "descr": "CONVERTED_PRICE_INDICATOR"},
            {"value": "U", "descr": "EXCHANGE_LAST"},
            {"value": "V", "descr": "FINAL_PRICE_OF_SESSION"},
            {"value": "W", "descr": "EX_PIT"},
            {"value": "X", "descr": "CROSSED_X"},
            {"value": "Y", "descr": "TRADES_RESULTING_FROM_MANUAL_SLOW_QUOTE"},
            {"value": "Z", "descr": "TRADES_RESULTING_FROM_INTERMARKET_SWEEP"},
            {"value": "a", "descr": "VOLUME_ONLY"},
            {"value": "b", "descr": "DIRECT_PLUS"},
            {"value": "c", "descr": "ACQUISITION"},
            {"value": "d", "descr": "BUNCHED"},
            {"value": "e", "descr": "DISTRIBUTION"},
            {"value": "f", "descr": "BUNCHED_SALE"},
            {"value": "g", "descr": "SPLIT_TRADE"},
            {"value": "h", "descr": "CANCEL_STOPPED"},
            {"value": "i", "descr": "CANCEL_ETH"},
            {"value": "j", "descr": "CANCEL_STOPPED_ETH"},
            {"value": "k", "descr": "OUT_OF_SEQUENCE_ETH"},
            {"value": "l", "descr": "CANCEL_LAST_ETH"},
            {"value": "m", "descr": "SOLD_LAST_SALE_ETH"},
            {"value": "n", "descr": "CANCEL_LAST"},
            {"value": "o", "descr": "SOLD_LAST_SALE"},
            {"value": "p", "descr": "CANCEL_OPEN"},
            {"value": "q", "descr": "CANCEL_OPEN_ETH"},
            {"value": "r", "descr": "OPENED_SALE_ETH"},
            {"value": "s", "descr": "CANCEL_ONLY"},
            {"value": "t", "descr": "CANCEL_ONLY_ETH"},
            {"value": "u", "descr": "LATE_OPEN_ETH"},
            {"value": "v", "descr": "AUTO_EXECUTION_ETH"},
            {"value": "w", "descr": "REOPEN"},
            {"value": "x", "descr": "REOPEN_ETH"},
            {"value": "y", "descr": "ADJUSTED"},
            {"value": "z", "descr": "ADJUSTED_ETH"},
            {"value": "AA", "descr": "SPREAD"},
            {"value": "AB", "descr": "SPREAD_ETH"},
            {"value": "AC", "descr": "STRADDLE"},
            {"value": "AD", "descr": "STRADDLE_ETH"},
            {"value": "AE", "descr": "STOPPED"},
            {"value": "AF", "descr": "STOPPED_ETH"},
            {"value": "AG", "descr": "REGULAR_ETH"},
            {"value": "AH", "descr": "COMBO"},
            {"value": "AI", "descr": "COMBO_ETH"},
            {"value": "AJ", "descr": "OFFICIAL_CLOSING_PRICE"},
            {"value": "AK", "descr": "PRIOR_REFERENCE_PRICE"},
            {"value": "0", "descr": "CANCEL"},
            {"value": "AL", "descr": "STOPPED_SOLD_LAST"},
            {"value": "AM", "descr": "STOPPED_OUT_OF_SEQUENCE"},
            {"value": "AN", "descr": "OFFICAL_CLOSING_PRICE"},
            {"value": "AO", "descr": "CROSSED_AO"},
            {"value": "AP", "descr": "FAST_MARKET"},
            {"value": "AQ", "descr": "AUTOMATIC_EXECUTION"},
            {"value": "AR", "descr": "FORM_T"},
            {"value": "AS", "descr": "BASKET_INDEX"},
            {"value": "AT", "descr": "BURST_BASKET"},
            {"value": "AV", "descr": "OUTSIDE_SPREAD"},
            {"value": "1", "descr": "IMPLIED_TRADE"},
            {"value": "2", "descr": "MARKETPLACE_ENTERED_TRADE"},
            {"value": "3", "descr": "MULT_ASSET_CLASS_MULTILEG_TRADE"},
            {"value": "4", "descr": "MULTILEG_TO_MULTILEG_TRADE"},
        ],
        279: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "CHANGE"},
            {"value": "2", "descr": "DELETE"},
            {"value": "3", "descr": "DELETE_THRU"},
            {"value": "4", "descr": "DELETE_FROM"},
            {"value": "5", "descr": "OVERLAY"},
        ],
        281: [
            {"value": "0", "descr": "UNKNOWN_SYMBOL"},
            {"value": "1", "descr": "DUPLICATE_MDREQID"},
            {"value": "2", "descr": "INSUFFICIENT_BANDWIDTH"},
            {"value": "3", "descr": "INSUFFICIENT_PERMISSIONS"},
            {"value": "4", "descr": "UNSUPPORTED_SUBSCRIPTIONREQUESTTYPE"},
            {"value": "5", "descr": "UNSUPPORTED_MARKETDEPTH"},
            {"value": "6", "descr": "UNSUPPORTED_MDUPDATETYPE"},
            {"value": "7", "descr": "UNSUPPORTED_AGGREGATEDBOOK"},
            {"value": "8", "descr": "UNSUPPORTED_MDENTRYTYPE"},
            {"value": "9", "descr": "UNSUPPORTED_TRADINGSESSIONID"},
            {"value": "A", "descr": "UNSUPPORTED_SCOPE"},
            {"value": "B", "descr": "UNSUPPORTED_OPENCLOSESETTLEFLAG"},
            {"value": "C", "descr": "UNSUPPORTED_MDIMPLICITDELETE"},
            {"value": "D", "descr": "INSUFFICIENT_CREDIT"},
        ],
        285: [
            {"value": "0", "descr": "CANCELLATION"},
            {"value": "1", "descr": "ERROR"},
        ],
        286: [
            {"value": "0", "descr": "DAILY_OPEN"},
            {"value": "1", "descr": "SESSION_OPEN"},
            {"value": "2", "descr": "DELIVERY_SETTLEMENT_ENTRY"},
            {"value": "3", "descr": "EXPECTED_ENTRY"},
            {"value": "4", "descr": "ENTRY_FROM_PREVIOUS_BUSINESS_DAY"},
            {"value": "5", "descr": "THEORETICAL_PRICE_VALUE"},
        ],
        291: [
            {"value": "1", "descr": "BANKRUPT"},
            {"value": "2", "descr": "PENDING_DELISTING"},
            {"value": "3", "descr": "RESTRICTED"},
        ],
        292: [
            {"value": "A", "descr": "EX_DIVIDEND"},
            {"value": "B", "descr": "EX_DISTRIBUTION"},
            {"value": "C", "descr": "EX_RIGHTS"},
            {"value": "D", "descr": "NEW"},
            {"value": "E", "descr": "EX_INTEREST"},
            {"value": "F", "descr": "CASH_DIVIDEND"},
            {"value": "G", "descr": "STOCK_DIVIDEND"},
            {"value": "H", "descr": "NON_INTEGER_STOCK_SPLIT"},
            {"value": "I", "descr": "REVERSE_STOCK_SPLIT"},
            {"value": "J", "descr": "STANDARD_INTEGER_STOCK_SPLIT"},
            {"value": "K", "descr": "POSITION_CONSOLIDATION"},
            {"value": "L", "descr": "LIQUIDATION_REORGANIZATION"},
            {"value": "M", "descr": "MERGER_REORGANIZATION"},
            {"value": "N", "descr": "RIGHTS_OFFERING"},
            {"value": "O", "descr": "SHAREHOLDER_MEETING"},
            {"value": "P", "descr": "SPINOFF"},
            {"value": "Q", "descr": "TENDER_OFFER"},
            {"value": "R", "descr": "WARRANT"},
            {"value": "S", "descr": "SPECIAL_ACTION"},
            {"value": "T", "descr": "SYMBOL_CONVERSION"},
            {"value": "U", "descr": "CUSIP"},
            {"value": "V", "descr": "LEAP_ROLLOVER"},
            {"value": "W", "descr": "SUCCESSION_EVENT"},
        ],
        297: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "CANCEL_FOR_SYMBOL"},
            {"value": "2", "descr": "CANCELED_FOR_SECURITY_TYPE"},
            {"value": "3", "descr": "CANCELED_FOR_UNDERLYING"},
            {"value": "4", "descr": "CANCELED_ALL"},
            {"value": "5", "descr": "REJECTED"},
            {"value": "6", "descr": "REMOVED_FROM_MARKET"},
            {"value": "7", "descr": "EXPIRED"},
            {"value": "8", "descr": "QUERY"},
            {"value": "9", "descr": "QUOTE_NOT_FOUND"},
            {"value": "10", "descr": "PENDING"},
            {"value": "11", "descr": "PASS"},
            {"value": "12", "descr": "LOCKED_MARKET_WARNING"},
            {"value": "13", "descr": "CROSS_MARKET_WARNING"},
            {"value": "14", "descr": "CANCELED_DUE_TO_LOCK_MARKET"},
            {"value": "15", "descr": "CANCELED_DUE_TO_CROSS_MARKET"},
            {"value": "16", "descr": "ACTIVE"},
            {"value": "17", "descr": "CANCELED"},
            {"value": "18", "descr": "UNSOLICITED_QUOTE_REPLENISHMENT"},
            {"value": "19", "descr": "PENDING_END_TRADE"},
            {"value": "20", "descr": "TOO_LATE_TO_END"},
        ],
        298: [
            {"value": "1", "descr": "CANCEL_FOR_ONE_OR_MORE_SECURITIES"},
            {"value": "2", "descr": "CANCEL_FOR_SECURITY_TYPE"},
            {"value": "3", "descr": "CANCEL_FOR_UNDERLYING_SECURITY"},
            {"value": "4", "descr": "CANCEL_ALL_QUOTES"},
            {"value": "5", "descr": "CANCEL_QUOTE_SPECIFIED_IN_QUOTEID"},
            {"value": "6", "descr": "CANCEL_BY_QUOTETYPE"},
            {"value": "7", "descr": "CANCEL_FOR_SECURITY_ISSUER"},
            {
                "value": "8",
                "descr": "CANCEL_FOR_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        300: [
            {"value": "1", "descr": "UNKNOWN_SYMBOL"},
            {"value": "2", "descr": "EXCHANGE"},
            {"value": "3", "descr": "QUOTE_REQUEST_EXCEEDS_LIMIT"},
            {"value": "4", "descr": "TOO_LATE_TO_ENTER"},
            {"value": "5", "descr": "UNKNOWN_QUOTE"},
            {"value": "6", "descr": "DUPLICATE_QUOTE"},
            {"value": "7", "descr": "INVALID_BID_ASK_SPREAD"},
            {"value": "8", "descr": "INVALID_PRICE"},
            {"value": "9", "descr": "NOT_AUTHORIZED_TO_QUOTE_SECURITY"},
            {"value": "10", "descr": "PRICE_EXCEEDS_CURRENT_PRICE_BAND"},
            {"value": "11", "descr": "QUOTE_LOCKED"},
            {"value": "99", "descr": "OTHER"},
            {"value": "12", "descr": "INVALID_OR_UNKNOWN_SECURITY_ISSUER"},
            {
                "value": "13",
                "descr": "INVALID_OR_UNKNOWN_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        301: [
            {"value": "0", "descr": "NO_ACKNOWLEDGEMENT"},
            {
                "value": "1",
                "descr": "ACKNOWLEDGE_ONLY_NEGATIVE_OR_ERRONEOUS_QUOTES",
            },
            {"value": "2", "descr": "ACKNOWLEDGE_EACH_QUOTE_MESSAGE"},
            {"value": "3", "descr": "SUMMARY_ACKNOWLEDGEMENT"},
        ],
        303: [
            {"value": "1", "descr": "MANUAL"},
            {"value": "2", "descr": "AUTOMATIC"},
        ],
        321: [
            {
                "value": "0",
                "descr": "REQUEST_SECURITY_IDENTITY_AND_SPECIFICATIONS",
            },
            {
                "value": "1",
                "descr": "REQUEST_SECURITY_IDENTITY_FOR_THE_SPECIFICATIONS_PROVIDED",
            },
            {"value": "2", "descr": "REQUEST_LIST_SECURITY_TYPES"},
            {"value": "3", "descr": "REQUEST_LIST_SECURITIES"},
            {"value": "4", "descr": "SYMBOL"},
            {"value": "5", "descr": "SECURITYTYPE_AND_OR_CFICODE"},
            {"value": "6", "descr": "PRODUCT"},
            {"value": "7", "descr": "TRADINGSESSIONID"},
            {"value": "8", "descr": "ALL_SECURITIES"},
            {
                "value": "9",
                "descr": "MARKETID_OR_MARKETID_PLUS_MARKETSEGMENTID",
            },
        ],
        323: [
            {"value": "1", "descr": "ACCEPT_SECURITY_PROPOSAL_AS_IS"},
            {
                "value": "2",
                "descr": "ACCEPT_SECURITY_PROPOSAL_WITH_REVISIONS_AS_INDICATED_IN_THE_MESSAGE",
            },
            {
                "value": "3",
                "descr": "LIST_OF_SECURITY_TYPES_RETURNED_PER_REQUEST",
            },
            {"value": "4", "descr": "LIST_OF_SECURITIES_RETURNED_PER_REQUEST"},
            {"value": "5", "descr": "REJECT_SECURITY_PROPOSAL"},
            {"value": "6", "descr": "CANNOT_MATCH_SELECTION_CRITERIA"},
        ],
        325: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        326: [
            {"value": "1", "descr": "OPENING_DELAY"},
            {"value": "2", "descr": "TRADING_HALT"},
            {"value": "3", "descr": "RESUME"},
            {"value": "4", "descr": "NO_OPEN"},
            {"value": "5", "descr": "PRICE_INDICATION"},
            {"value": "6", "descr": "TRADING_RANGE_INDICATION"},
            {"value": "7", "descr": "MARKET_IMBALANCE_BUY"},
            {"value": "8", "descr": "MARKET_IMBALANCE_SELL"},
            {"value": "9", "descr": "MARKET_ON_CLOSE_IMBALANCE_BUY"},
            {"value": "10", "descr": "MARKET_ON_CLOSE_IMBALANCE_SELL"},
            {"value": "12", "descr": "NO_MARKET_IMBALANCE"},
            {"value": "13", "descr": "NO_MARKET_ON_CLOSE_IMBALANCE"},
            {"value": "14", "descr": "ITS_PRE_OPENING"},
            {"value": "15", "descr": "NEW_PRICE_INDICATION"},
            {"value": "16", "descr": "TRADE_DISSEMINATION_TIME"},
            {"value": "17", "descr": "READY_TO_TRADE"},
            {"value": "18", "descr": "NOT_AVAILABLE_FOR_TRADING"},
            {"value": "19", "descr": "NOT_TRADED_ON_THIS_MARKET"},
            {"value": "20", "descr": "UNKNOWN_OR_INVALID"},
            {"value": "21", "descr": "PRE_OPEN"},
            {"value": "22", "descr": "OPENING_ROTATION"},
            {"value": "23", "descr": "FAST_MARKET"},
            {"value": "24", "descr": "PRE_CROSS"},
            {"value": "25", "descr": "CROSS"},
            {"value": "26", "descr": "POST_CLOSE"},
        ],
        327: [
            {"value": "0", "descr": "NEWS_DISSEMINATION"},
            {"value": "1", "descr": "ORDER_INFLUX"},
            {"value": "2", "descr": "ORDER_IMBALANCE"},
            {"value": "3", "descr": "ADDITIONAL_INFORMATION"},
            {"value": "4", "descr": "NEWS_PENDING"},
            {"value": "5", "descr": "EQUIPMENT_CHANGEOVER"},
        ],
        328: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        329: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        334: [
            {"value": "1", "descr": "CANCEL"},
            {"value": "2", "descr": "ERROR"},
            {"value": "3", "descr": "CORRECTION"},
        ],
        336: [
            {"value": "1", "descr": "DAY"},
            {"value": "2", "descr": "HALFDAY"},
            {"value": "3", "descr": "MORNING"},
            {"value": "4", "descr": "AFTERNOON"},
            {"value": "5", "descr": "EVENING"},
            {"value": "6", "descr": "AFTER_HOURS"},
        ],
        338: [
            {"value": "1", "descr": "ELECTRONIC"},
            {"value": "2", "descr": "OPEN_OUTCRY"},
            {"value": "3", "descr": "TWO_PARTY"},
        ],
        339: [
            {"value": "1", "descr": "TESTING"},
            {"value": "2", "descr": "SIMULATED"},
            {"value": "3", "descr": "PRODUCTION"},
        ],
        340: [
            {"value": "0", "descr": "UNKNOWN"},
            {"value": "1", "descr": "HALTED"},
            {"value": "2", "descr": "OPEN"},
            {"value": "3", "descr": "CLOSED"},
            {"value": "4", "descr": "PRE_OPEN"},
            {"value": "5", "descr": "PRE_CLOSE"},
            {"value": "6", "descr": "REQUEST_REJECTED"},
        ],
        373: [
            {"value": "0", "descr": "INVALID_TAG_NUMBER"},
            {"value": "1", "descr": "REQUIRED_TAG_MISSING"},
            {"value": "2", "descr": "TAG_NOT_DEFINED_FOR_THIS_MESSAGE_TYPE"},
            {"value": "3", "descr": "UNDEFINED_TAG"},
            {"value": "4", "descr": "TAG_SPECIFIED_WITHOUT_A_VALUE"},
            {"value": "5", "descr": "VALUE_IS_INCORRECT"},
            {"value": "6", "descr": "INCORRECT_DATA_FORMAT_FOR_VALUE"},
            {"value": "7", "descr": "DECRYPTION_PROBLEM"},
            {"value": "8", "descr": "SIGNATURE_PROBLEM"},
            {"value": "9", "descr": "COMPID_PROBLEM"},
            {"value": "10", "descr": "SENDINGTIME_ACCURACY_PROBLEM"},
            {"value": "11", "descr": "INVALID_MSGTYPE"},
            {"value": "12", "descr": "XML_VALIDATION_ERROR"},
            {"value": "13", "descr": "TAG_APPEARS_MORE_THAN_ONCE"},
            {"value": "14", "descr": "TAG_SPECIFIED_OUT_OF_REQUIRED_ORDER"},
            {"value": "15", "descr": "REPEATING_GROUP_FIELDS_OUT_OF_ORDER"},
            {
                "value": "16",
                "descr": "INCORRECT_NUMINGROUP_COUNT_FOR_REPEATING_GROUP",
            },
            {
                "value": "17",
                "descr": "NON_DATA_VALUE_INCLUDES_FIELD_DELIMITER",
            },
            {
                "value": "18",
                "descr": "INVALID_UNSUPPORTED_APPLICATION_VERSION",
            },
            {"value": "99", "descr": "OTHER"},
        ],
        374: [
            {"value": "C", "descr": "CANCEL"},
            {"value": "N", "descr": "NO"},
        ],
        377: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        378: [
            {"value": "0", "descr": "GT_CORPORATE_ACTION"},
            {"value": "1", "descr": "GT_RENEWAL"},
            {"value": "2", "descr": "VERBAL_CHANGE"},
            {"value": "3", "descr": "REPRICING_OF_ORDER"},
            {"value": "4", "descr": "BROKER_OPTION"},
            {"value": "5", "descr": "PARTIAL_DECLINE_OF_ORDERQTY"},
            {"value": "6", "descr": "CANCEL_ON_TRADING_HALT"},
            {"value": "7", "descr": "CANCEL_ON_SYSTEM_FAILURE"},
            {"value": "8", "descr": "MARKET"},
            {"value": "9", "descr": "CANCELED_NOT_BEST"},
            {"value": "10", "descr": "WAREHOUSE_RECAP"},
            {"value": "11", "descr": "PEG_REFRESH"},
            {"value": "99", "descr": "OTHER"},
        ],
        380: [
            {"value": "0", "descr": "OTHER"},
            {"value": "1", "descr": "UNKNOWN_ID"},
            {"value": "2", "descr": "UNKNOWN_SECURITY"},
            {"value": "3", "descr": "UNSUPPORTED_MESSAGE_TYPE"},
            {"value": "4", "descr": "APPLICATION_NOT_AVAILABLE"},
            {"value": "5", "descr": "CONDITIONALLY_REQUIRED_FIELD_MISSING"},
            {"value": "6", "descr": "NOT_AUTHORIZED"},
            {
                "value": "7",
                "descr": "DELIVERTO_FIRM_NOT_AVAILABLE_AT_THIS_TIME",
            },
            {"value": "18", "descr": "INVALID_PRICE_INCREMENT"},
        ],
        385: [
            {"value": "R", "descr": "RECEIVE"},
            {"value": "S", "descr": "SEND"},
        ],
        388: [
            {"value": "0", "descr": "RELATED_TO_DISPLAYED_PRICE"},
            {"value": "1", "descr": "RELATED_TO_MARKET_PRICE"},
            {"value": "2", "descr": "RELATED_TO_PRIMARY_PRICE"},
            {"value": "3", "descr": "RELATED_TO_LOCAL_PRIMARY_PRICE"},
            {"value": "4", "descr": "RELATED_TO_MIDPOINT_PRICE"},
            {"value": "5", "descr": "RELATED_TO_LAST_TRADE_PRICE"},
            {"value": "6", "descr": "RELATED_TO_VWAP"},
            {"value": "7", "descr": "AVERAGE_PRICE_GUARANTEE"},
        ],
        394: [
            {"value": "1", "descr": "NON_DISCLOSED_STYLE"},
            {"value": "2", "descr": "DISCLOSED_SYTLE"},
            {"value": "3", "descr": "NO_BIDDING_PROCESS"},
        ],
        399: [
            {"value": "1", "descr": "SECTOR"},
            {"value": "2", "descr": "COUNTRY"},
            {"value": "3", "descr": "INDEX"},
        ],
        401: [
            {"value": "1", "descr": "SIDE_VALUE_1"},
            {"value": "2", "descr": "SIDE_VALUE_2"},
        ],
        409: [
            {"value": "1", "descr": "5_DAY_MOVING_AVERAGE"},
            {"value": "2", "descr": "20_DAY_MOVING_AVERAGE"},
            {"value": "3", "descr": "NORMAL_MARKET_SIZE"},
            {"value": "4", "descr": "OTHER"},
        ],
        411: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        414: [
            {
                "value": "1",
                "descr": "BUY_SIDE_EXPLICITLY_REQUESTS_STATUS_USING_STATUE_REQUEST",
            },
            {
                "value": "2",
                "descr": "SELL_SIDE_PERIODICALLY_SENDS_STATUS_USING_LIST_STATUS_PERIOD_OPTIONALLY_SPECIFIED_IN_PROGRESSPERIOD",
            },
            {"value": "3", "descr": "REAL_TIME_EXECUTION_REPORTS"},
        ],
        416: [
            {"value": "1", "descr": "NET"},
            {"value": "2", "descr": "GROSS"},
        ],
        418: [
            {"value": "A", "descr": "AGENCY"},
            {"value": "G", "descr": "VWAP_GUARANTEE"},
            {"value": "J", "descr": "GUARANTEED_CLOSE"},
            {"value": "R", "descr": "RISK_TRADE"},
        ],
        419: [
            {"value": "2", "descr": "CLOSING_PRICE_AT_MORNING_SESSION"},
            {"value": "3", "descr": "CLOSING_PRICE"},
            {"value": "4", "descr": "CURRENT_PRICE"},
            {"value": "5", "descr": "SQ"},
            {"value": "6", "descr": "VWAP_THROUGH_A_DAY"},
            {"value": "7", "descr": "VWAP_THROUGH_A_MORNING_SESSION"},
            {"value": "8", "descr": "VWAP_THROUGH_AN_AFTERNOON_SESSION"},
            {"value": "9", "descr": "VWAP_THROUGH_A_DAY_EXCEPT_YORI"},
            {
                "value": "A",
                "descr": "VWAP_THROUGH_A_MORNING_SESSION_EXCEPT_YORI",
            },
            {
                "value": "B",
                "descr": "VWAP_THROUGH_AN_AFTERNOON_SESSION_EXCEPT_YORI",
            },
            {"value": "C", "descr": "STRIKE"},
            {"value": "D", "descr": "OPEN"},
            {"value": "Z", "descr": "OTHERS"},
        ],
        423: [
            {"value": "1", "descr": "PERCENTAGE"},
            {"value": "2", "descr": "PER_UNIT"},
            {"value": "3", "descr": "FIXED_AMOUNT"},
            {"value": "4", "descr": "DISCOUNT"},
            {"value": "5", "descr": "PREMIUM"},
            {"value": "6", "descr": "SPREAD"},
            {"value": "7", "descr": "TED_PRICE"},
            {"value": "8", "descr": "TED_YIELD"},
            {"value": "9", "descr": "YIELD"},
            {"value": "10", "descr": "FIXED_CABINET_TRADE_PRICE"},
            {"value": "11", "descr": "VARIABLE_CABINET_TRADE_PRICE"},
            {"value": "13", "descr": "PRODUCT_TICKS_IN_HALFS"},
            {"value": "14", "descr": "PRODUCT_TICKS_IN_FOURTHS"},
            {"value": "15", "descr": "PRODUCT_TICKS_IN_EIGHTS"},
            {"value": "16", "descr": "PRODUCT_TICKS_IN_SIXTEENTHS"},
            {"value": "17", "descr": "PRODUCT_TICKS_IN_THIRTY_SECONDS"},
            {"value": "18", "descr": "PRODUCT_TICKS_IN_SIXTY_FORTHS"},
            {"value": "19", "descr": "PRODUCT_TICKS_IN_ONE_TWENTY_EIGHTS"},
        ],
        427: [
            {"value": "0", "descr": "BOOK_OUT_ALL_TRADES_ON_DAY_OF_EXECUTION"},
            {
                "value": "1",
                "descr": "ACCUMULATE_EXECTUIONS_UNTIL_FORDER_IS_FILLED_OR_EXPIRES",
            },
            {
                "value": "2",
                "descr": "ACCUMULATE_UNTIL_VERBALLLY_NOTIFIED_OTHERWISE",
            },
        ],
        429: [
            {"value": "1", "descr": "ACK"},
            {"value": "2", "descr": "RESPONSE"},
            {"value": "3", "descr": "TIMED"},
            {"value": "4", "descr": "EXEC_STARTED"},
            {"value": "5", "descr": "ALL_DONE"},
            {"value": "6", "descr": "ALERT"},
        ],
        430: [
            {"value": "1", "descr": "NET"},
            {"value": "2", "descr": "GROSS"},
        ],
        431: [
            {"value": "1", "descr": "IN_BIDDING_PROCESS"},
            {"value": "2", "descr": "RECEIVED_FOR_EXECUTION"},
            {"value": "3", "descr": "EXECUTING"},
            {"value": "4", "descr": "CANCELLING"},
            {"value": "5", "descr": "ALERT"},
            {"value": "6", "descr": "ALL_DONE"},
            {"value": "7", "descr": "REJECT"},
        ],
        433: [
            {"value": "1", "descr": "IMMEDIATE"},
            {"value": "2", "descr": "WAIT_FOR_EXECUT_INSTRUCTION"},
            {"value": "3", "descr": "EXCHANGE_SWITCH_CIV_ORDER_3"},
            {"value": "4", "descr": "EXCHANGE_SWITCH_CIV_ORDER_4"},
            {"value": "5", "descr": "EXCHANGE_SWITCH_CIV_ORDER_5"},
        ],
        434: [
            {"value": "1", "descr": "ORDER_CANCEL_REQUEST"},
            {"value": "2", "descr": "ORDER_CANCEL_REPLACE_REQUEST"},
        ],
        442: [
            {"value": "1", "descr": "SINGLE_SECURITY"},
            {"value": "2", "descr": "INDIVIDUAL_LEG_OF_A_MULTI_LEG_SECURITY"},
            {"value": "3", "descr": "MULTI_LEG_SECURITY"},
        ],
        447: [
            {"value": "6", "descr": "UK_NATIONAL_INSURANCE_OR_PENSION_NUMBER"},
            {"value": "7", "descr": "US_SOCIAL_SECURITY_NUMBER"},
            {"value": "8", "descr": "US_EMPLOYER_OR_TAX_ID_NUMBER"},
            {"value": "9", "descr": "AUSTRALIAN_BUSINESS_NUMBER"},
            {"value": "A", "descr": "AUSTRALIAN_TAX_FILE_NUMBER"},
            {"value": "1", "descr": "KOREAN_INVESTOR_ID"},
            {
                "value": "2",
                "descr": "TAIWANESE_QUALIFIED_FOREIGN_INVESTOR_ID_QFII_FID",
            },
            {"value": "3", "descr": "TAIWANESE_TRADING_ACCT"},
            {"value": "4", "descr": "MALAYSIAN_CENTRAL_DEPOSITORY"},
            {"value": "5", "descr": "CHINESE_INVESTOR_ID"},
            {
                "value": "I",
                "descr": "DIRECTED_BROKER_THREE_CHARACTER_ACRONYM_AS_DEFINED_IN_ISITC_ETC_BEST_PRACTICE_GUIDELINES_DOCUMENT",
            },
            {"value": "B", "descr": "BIC"},
            {
                "value": "C",
                "descr": "GENERALLY_ACCEPTED_MARKET_PARTICIPANT_IDENTIFIER",
            },
            {"value": "D", "descr": "PROPRIETARY"},
            {"value": "E", "descr": "ISO_COUNTRY_CODE"},
            {"value": "F", "descr": "SETTLEMENT_ENTITY_LOCATION"},
            {"value": "G", "descr": "MIC"},
            {"value": "H", "descr": "CSD_PARTICIPANT_MEMBER_CODE"},
        ],
        452: [
            {"value": "1", "descr": "EXECUTING_FIRM"},
            {"value": "2", "descr": "BROKER_OF_CREDIT"},
            {"value": "3", "descr": "CLIENT_ID"},
            {"value": "4", "descr": "CLEARING_FIRM"},
            {"value": "5", "descr": "INVESTOR_ID"},
            {"value": "6", "descr": "INTRODUCING_FIRM"},
            {"value": "7", "descr": "ENTERING_FIRM"},
            {"value": "8", "descr": "LOCATE"},
            {"value": "9", "descr": "FUND_MANAGER_CLIENT_ID"},
            {"value": "10", "descr": "SETTLEMENT_LOCATION"},
            {"value": "11", "descr": "ORDER_ORIGINATION_TRADER"},
            {"value": "12", "descr": "EXECUTING_TRADER"},
            {"value": "13", "descr": "ORDER_ORIGINATION_FIRM"},
            {"value": "14", "descr": "GIVEUP_CLEARING_FIRM"},
            {"value": "15", "descr": "CORRESPONDANT_CLEARING_FIRM"},
            {"value": "16", "descr": "EXECUTING_SYSTEM"},
            {"value": "17", "descr": "CONTRA_FIRM"},
            {"value": "18", "descr": "CONTRA_CLEARING_FIRM"},
            {"value": "19", "descr": "SPONSORING_FIRM"},
            {"value": "20", "descr": "UNDERLYING_CONTRA_FIRM"},
            {"value": "21", "descr": "CLEARING_ORGANIZATION"},
            {"value": "22", "descr": "EXCHANGE"},
            {"value": "24", "descr": "CUSTOMER_ACCOUNT"},
            {"value": "25", "descr": "CORRESPONDENT_CLEARING_ORGANIZATION"},
            {"value": "26", "descr": "CORRESPONDENT_BROKER"},
            {"value": "27", "descr": "BUYER_SELLER"},
            {"value": "28", "descr": "CUSTODIAN"},
            {"value": "29", "descr": "INTERMEDIARY"},
            {"value": "30", "descr": "AGENT"},
            {"value": "31", "descr": "SUB_CUSTODIAN"},
            {"value": "32", "descr": "BENEFICIARY"},
            {"value": "33", "descr": "INTERESTED_PARTY"},
            {"value": "34", "descr": "REGULATORY_BODY"},
            {"value": "35", "descr": "LIQUIDITY_PROVIDER"},
            {"value": "36", "descr": "ENTERING_TRADER"},
            {"value": "37", "descr": "CONTRA_TRADER"},
            {"value": "38", "descr": "POSITION_ACCOUNT"},
            {"value": "39", "descr": "CONTRA_INVESTOR_ID"},
            {"value": "40", "descr": "TRANSFER_TO_FIRM"},
            {"value": "41", "descr": "CONTRA_POSITION_ACCOUNT"},
            {"value": "42", "descr": "CONTRA_EXCHANGE"},
            {"value": "43", "descr": "INTERNAL_CARRY_ACCOUNT"},
            {"value": "44", "descr": "ORDER_ENTRY_OPERATOR_ID"},
            {"value": "45", "descr": "SECONDARY_ACCOUNT_NUMBER"},
            {"value": "46", "descr": "FOREIGN_FIRM"},
            {"value": "47", "descr": "THIRD_PARTY_ALLOCATION_FIRM"},
            {"value": "48", "descr": "CLAIMING_ACCOUNT"},
            {"value": "49", "descr": "ASSET_MANAGER"},
            {"value": "50", "descr": "PLEDGOR_ACCOUNT"},
            {"value": "51", "descr": "PLEDGEE_ACCOUNT"},
            {"value": "52", "descr": "LARGE_TRADER_REPORTABLE_ACCOUNT"},
            {"value": "53", "descr": "TRADER_MNEMONIC"},
            {"value": "54", "descr": "SENDER_LOCATION"},
            {"value": "55", "descr": "SESSION_ID"},
            {"value": "56", "descr": "ACCEPTABLE_COUNTERPARTY"},
            {"value": "57", "descr": "UNACCEPTABLE_COUNTERPARTY"},
            {"value": "58", "descr": "ENTERING_UNIT"},
            {"value": "59", "descr": "EXECUTING_UNIT"},
            {"value": "60", "descr": "INTRODUCING_BROKER"},
            {"value": "61", "descr": "QUOTE_ORIGINATOR"},
            {"value": "62", "descr": "REPORT_ORIGINATOR"},
            {"value": "63", "descr": "SYSTEMATIC_INTERNALISER"},
            {"value": "64", "descr": "MULTILATERAL_TRADING_FACILITY"},
            {"value": "65", "descr": "REGULATED_MARKET"},
            {"value": "66", "descr": "MARKET_MAKER"},
            {"value": "67", "descr": "INVESTMENT_FIRM"},
            {"value": "68", "descr": "HOST_COMPETENT_AUTHORITY"},
            {"value": "69", "descr": "HOME_COMPETENT_AUTHORITY"},
            {
                "value": "70",
                "descr": "COMPETENT_AUTHORITY_OF_THE_MOST_RELEVANT_MARKET_IN_TERMS_OF_LIQUIDITY",
            },
            {"value": "71", "descr": "COMPETENT_AUTHORITY_OF_THE_TRANSACTION"},
            {"value": "72", "descr": "REPORTING_INTERMEDIARY"},
            {"value": "73", "descr": "EXECUTION_VENUE"},
            {"value": "74", "descr": "MARKET_DATA_ENTRY_ORIGINATOR"},
            {"value": "75", "descr": "LOCATION_ID"},
            {"value": "76", "descr": "DESK_ID"},
            {"value": "77", "descr": "MARKET_DATA_MARKET"},
            {"value": "78", "descr": "ALLOCATION_ENTITY"},
            {
                "value": "79",
                "descr": "PRIME_BROKER_PROVIDING_GENERAL_TRADE_SERVICES",
            },
            {"value": "80", "descr": "STEP_OUT_FIRM"},
            {"value": "81", "descr": "BROKERCLEARINGID"},
            {"value": "82", "descr": "CENTRAL_REGISTRATION_DEPOSITORY"},
            {"value": "83", "descr": "CLEARING_ACCOUNT"},
            {"value": "84", "descr": "ACCEPTABLE_SETTLING_COUNTERPARTY"},
            {"value": "85", "descr": "UNACCEPTABLE_SETTLING_COUNTERPARTY"},
        ],
        460: [
            {"value": "1", "descr": "AGENCY"},
            {"value": "2", "descr": "COMMODITY"},
            {"value": "3", "descr": "CORPORATE"},
            {"value": "4", "descr": "CURRENCY"},
            {"value": "5", "descr": "EQUITY"},
            {"value": "6", "descr": "GOVERNMENT"},
            {"value": "7", "descr": "INDEX"},
            {"value": "8", "descr": "LOAN"},
            {"value": "9", "descr": "MONEYMARKET"},
            {"value": "10", "descr": "MORTGAGE"},
            {"value": "11", "descr": "MUNICIPAL"},
            {"value": "12", "descr": "OTHER"},
            {"value": "13", "descr": "FINANCING"},
        ],
        464: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        468: [
            {"value": "0", "descr": "ROUND_TO_NEAREST"},
            {"value": "1", "descr": "ROUND_DOWN"},
            {"value": "2", "descr": "ROUND_UP"},
        ],
        477: [
            {"value": "1", "descr": "CREST"},
            {"value": "2", "descr": "NSCC"},
            {"value": "3", "descr": "EUROCLEAR"},
            {"value": "4", "descr": "CLEARSTREAM"},
            {"value": "5", "descr": "CHEQUE"},
            {"value": "6", "descr": "TELEGRAPHIC_TRANSFER"},
            {"value": "7", "descr": "FED_WIRE"},
            {"value": "8", "descr": "DIRECT_CREDIT"},
            {"value": "9", "descr": "ACH_CREDIT"},
            {"value": "10", "descr": "BPAY"},
            {"value": "11", "descr": "HIGH_VALUE_CLEARING_SYSTEM_HVACS"},
            {"value": "12", "descr": "REINVEST_IN_FUND"},
        ],
        480: [
            {"value": "Y", "descr": "YES"},
            {"value": "N", "descr": "NO_N"},
            {"value": "M", "descr": "NO_M"},
            {"value": "O", "descr": "NO_O"},
        ],
        481: [
            {"value": "Y", "descr": "PASSED"},
            {"value": "N", "descr": "NOT_CHECKED"},
            {"value": "1", "descr": "EXEMPT_1"},
            {"value": "2", "descr": "EXEMPT_2"},
            {"value": "3", "descr": "EXEMPT_3"},
        ],
        484: [
            {"value": "B", "descr": "BID_PRICE"},
            {"value": "C", "descr": "CREATION_PRICE"},
            {"value": "D", "descr": "CREATION_PRICE_PLUS_ADJUSTMENT_PERCENT"},
            {"value": "E", "descr": "CREATION_PRICE_PLUS_ADJUSTMENT_AMOUNT"},
            {"value": "O", "descr": "OFFER_PRICE"},
            {"value": "P", "descr": "OFFER_PRICE_MINUS_ADJUSTMENT_PERCENT"},
            {"value": "Q", "descr": "OFFER_PRICE_MINUS_ADJUSTMENT_AMOUNT"},
            {"value": "S", "descr": "SINGLE_PRICE"},
        ],
        487: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "CANCEL"},
            {"value": "2", "descr": "REPLACE"},
            {"value": "3", "descr": "RELEASE"},
            {"value": "4", "descr": "REVERSE"},
            {"value": "5", "descr": "CANCEL_DUE_TO_BACK_OUT_OF_TRADE"},
        ],
        492: [
            {"value": "1", "descr": "CREST"},
            {"value": "2", "descr": "NSCC"},
            {"value": "3", "descr": "EUROCLEAR"},
            {"value": "4", "descr": "CLEARSTREAM"},
            {"value": "5", "descr": "CHEQUE"},
            {"value": "6", "descr": "TELEGRAPHIC_TRANSFER"},
            {"value": "7", "descr": "FED_WIRE"},
            {"value": "8", "descr": "DEBIT_CARD"},
            {"value": "9", "descr": "DIRECT_DEBIT"},
            {"value": "10", "descr": "DIRECT_CREDIT"},
            {"value": "11", "descr": "CREDIT_CARD"},
            {"value": "12", "descr": "ACH_DEBIT"},
            {"value": "13", "descr": "ACH_CREDIT"},
            {"value": "14", "descr": "BPAY"},
            {"value": "15", "descr": "HIGH_VALUE_CLEARING_SYSTEM"},
        ],
        495: [
            {"value": "0", "descr": "NONE_NOT_APPLICABLE"},
            {"value": "1", "descr": "MAXI_ISA"},
            {"value": "2", "descr": "TESSA"},
            {"value": "3", "descr": "MINI_CASH_ISA"},
            {"value": "4", "descr": "MINI_STOCKS_AND_SHARES_ISA"},
            {"value": "5", "descr": "MINI_INSURANCE_ISA"},
            {"value": "6", "descr": "CURRENT_YEAR_PAYMENT"},
            {"value": "7", "descr": "PRIOR_YEAR_PAYMENT"},
            {"value": "8", "descr": "ASSET_TRANSFER"},
            {"value": "9", "descr": "EMPLOYEE_9"},
            {"value": "10", "descr": "EMPLOYEE_10"},
            {"value": "11", "descr": "EMPLOYER_11"},
            {"value": "12", "descr": "EMPLOYER_12"},
            {"value": "13", "descr": "NON_FUND_PROTOTYPE_IRA"},
            {"value": "14", "descr": "NON_FUND_QUALIFIED_PLAN"},
            {"value": "15", "descr": "DEFINED_CONTRIBUTION_PLAN"},
            {"value": "16", "descr": "INDIVIDUAL_RETIREMENT_ACCOUNT_16"},
            {"value": "17", "descr": "INDIVIDUAL_RETIREMENT_ACCOUNT_17"},
            {"value": "18", "descr": "KEOGH"},
            {"value": "19", "descr": "PROFIT_SHARING_PLAN"},
            {"value": "20", "descr": "401"},
            {"value": "21", "descr": "SELF_DIRECTED_IRA"},
            {"value": "22", "descr": "403"},
            {"value": "23", "descr": "457"},
            {"value": "24", "descr": "ROTH_IRA_24"},
            {"value": "25", "descr": "ROTH_IRA_25"},
            {"value": "26", "descr": "ROTH_CONVERSION_IRA_26"},
            {"value": "27", "descr": "ROTH_CONVERSION_IRA_27"},
            {"value": "28", "descr": "EDUCATION_IRA_28"},
            {"value": "29", "descr": "EDUCATION_IRA_29"},
            {"value": "999", "descr": "OTHER"},
        ],
        497: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        506: [
            {"value": "A", "descr": "ACCEPTED"},
            {"value": "R", "descr": "REJECTED"},
            {"value": "H", "descr": "HELD"},
            {"value": "N", "descr": "REMINDER"},
        ],
        507: [
            {"value": "1", "descr": "INVALID_UNACCEPTABLE_ACCOUNT_TYPE"},
            {"value": "2", "descr": "INVALID_UNACCEPTABLE_TAX_EXEMPT_TYPE"},
            {"value": "3", "descr": "INVALID_UNACCEPTABLE_OWNERSHIP_TYPE"},
            {"value": "4", "descr": "INVALID_UNACCEPTABLE_NO_REG_DETAILS"},
            {"value": "5", "descr": "INVALID_UNACCEPTABLE_REG_SEQ_NO"},
            {"value": "6", "descr": "INVALID_UNACCEPTABLE_REG_DETAILS"},
            {"value": "7", "descr": "INVALID_UNACCEPTABLE_MAILING_DETAILS"},
            {
                "value": "8",
                "descr": "INVALID_UNACCEPTABLE_MAILING_INSTRUCTIONS",
            },
            {"value": "9", "descr": "INVALID_UNACCEPTABLE_INVESTOR_ID"},
            {
                "value": "10",
                "descr": "INVALID_UNACEEPTABLE_INVESTOR_ID_SOURCE",
            },
            {"value": "11", "descr": "INVALID_UNACCEPTABLE_DATE_OF_BIRTH"},
            {
                "value": "12",
                "descr": "INVALID_UNACCEPTABLE_INVESTOR_COUNTRY_OF_RESIDENCE",
            },
            {"value": "13", "descr": "INVALID_UNACCEPTABLE_NO_DISTRIB_INSTNS"},
            {
                "value": "14",
                "descr": "INVALID_UNACCEPTABLE_DISTRIB_PERCENTAGE",
            },
            {
                "value": "15",
                "descr": "INVALID_UNACCEPTABLE_DISTRIB_PAYMENT_METHOD",
            },
            {
                "value": "16",
                "descr": "INVALID_UNACCEPTABLE_CASH_DISTRIB_AGENT_ACCT_NAME",
            },
            {
                "value": "17",
                "descr": "INVALID_UNACCEPTABLE_CASH_DISTRIB_AGENT_CODE",
            },
            {
                "value": "18",
                "descr": "INVALID_UNACCEPTABLE_CASH_DISTRIB_AGENT_ACCT_NUM",
            },
            {"value": "99", "descr": "OTHER"},
        ],
        514: [
            {"value": "0", "descr": "NEW"},
            {"value": "2", "descr": "CANCEL"},
            {"value": "1", "descr": "REPLACE"},
        ],
        517: [
            {"value": "J", "descr": "JOINT_INVESTORS"},
            {"value": "T", "descr": "TENANTS_IN_COMMON"},
            {"value": "2", "descr": "JOINT_TRUSTEES"},
        ],
        519: [
            {"value": "1", "descr": "COMMISSION_AMOUNT"},
            {"value": "2", "descr": "COMMISSION_PERCENT"},
            {"value": "3", "descr": "INITIAL_CHARGE_AMOUNT"},
            {"value": "4", "descr": "INITIAL_CHARGE_PERCENT"},
            {"value": "5", "descr": "DISCOUNT_AMOUNT"},
            {"value": "6", "descr": "DISCOUNT_PERCENT"},
            {"value": "7", "descr": "DILUTION_LEVY_AMOUNT"},
            {"value": "8", "descr": "DILUTION_LEVY_PERCENT"},
            {"value": "9", "descr": "EXIT_CHARGE_AMOUNT"},
            {"value": "10", "descr": "EXIT_CHARGE_PERCENT"},
            {"value": "11", "descr": "FUND_BASED_RENEWAL_COMMISSION_PERCENT"},
            {"value": "12", "descr": "PROJECTED_FUND_VALUE"},
            {
                "value": "13",
                "descr": "FUND_BASED_RENEWAL_COMMISSION_AMOUNT_13",
            },
            {
                "value": "14",
                "descr": "FUND_BASED_RENEWAL_COMMISSION_AMOUNT_14",
            },
            {"value": "15", "descr": "NET_SETTLEMENT_AMOUNT"},
        ],
        522: [
            {"value": "1", "descr": "INDIVIDUAL_INVESTOR"},
            {"value": "2", "descr": "PUBLIC_COMPANY"},
            {"value": "3", "descr": "PRIVATE_COMPANY"},
            {"value": "4", "descr": "INDIVIDUAL_TRUSTEE"},
            {"value": "5", "descr": "COMPANY_TRUSTEE"},
            {"value": "6", "descr": "PENSION_PLAN"},
            {"value": "7", "descr": "CUSTODIAN_UNDER_GIFTS_TO_MINORS_ACT"},
            {"value": "8", "descr": "TRUSTS"},
            {"value": "9", "descr": "FIDUCIARIES"},
            {"value": "10", "descr": "NETWORKING_SUB_ACCOUNT"},
            {"value": "11", "descr": "NON_PROFIT_ORGANIZATION"},
            {"value": "12", "descr": "CORPORATE_BODY"},
            {"value": "13", "descr": "NOMINEE"},
        ],
        528: [
            {"value": "A", "descr": "AGENCY"},
            {"value": "G", "descr": "PROPRIETARY"},
            {"value": "I", "descr": "INDIVIDUAL"},
            {"value": "P", "descr": "PRINCIPAL"},
            {"value": "R", "descr": "RISKLESS_PRINCIPAL"},
            {"value": "W", "descr": "AGENT_FOR_OTHER_MEMBER"},
        ],
        529: [
            {"value": "1", "descr": "PROGRAM_TRADE"},
            {"value": "2", "descr": "INDEX_ARBITRAGE"},
            {"value": "3", "descr": "NON_INDEX_ARBITRAGE"},
            {"value": "4", "descr": "COMPETING_MARKET_MAKER"},
            {
                "value": "5",
                "descr": "ACTING_AS_MARKET_MAKER_OR_SPECIALIST_IN_THE_SECURITY",
            },
            {
                "value": "6",
                "descr": "ACTING_AS_MARKET_MAKER_OR_SPECIALIST_IN_THE_UNDERLYING_SECURITY_OF_A_DERIVATIVE_SECURITY",
            },
            {"value": "7", "descr": "FOREIGN_ENTITY"},
            {"value": "8", "descr": "EXTERNAL_MARKET_PARTICIPANT"},
            {"value": "9", "descr": "EXTERNAL_INTER_CONNECTED_MARKET_LINKAGE"},
            {"value": "A", "descr": "RISKLESS_ARBITRAGE"},
            {"value": "B", "descr": "ISSUER_HOLDING"},
            {"value": "C", "descr": "ISSUE_PRICE_STABILIZATION"},
            {"value": "D", "descr": "NON_ALGORITHMIC"},
            {"value": "E", "descr": "ALGORITHMIC"},
            {"value": "F", "descr": "CROSS"},
        ],
        530: [
            {"value": "1", "descr": "CANCEL_ORDERS_FOR_A_SECURITY"},
            {
                "value": "2",
                "descr": "CANCEL_ORDERS_FOR_AN_UNDERLYING_SECURITY",
            },
            {"value": "3", "descr": "CANCEL_ORDERS_FOR_A_PRODUCT"},
            {"value": "4", "descr": "CANCEL_ORDERS_FOR_A_CFICODE"},
            {"value": "5", "descr": "CANCEL_ORDERS_FOR_A_SECURITYTYPE"},
            {"value": "6", "descr": "CANCEL_ORDERS_FOR_A_TRADING_SESSION"},
            {"value": "7", "descr": "CANCEL_ALL_ORDERS"},
            {"value": "8", "descr": "CANCEL_ORDERS_FOR_A_MARKET"},
            {"value": "9", "descr": "CANCEL_ORDERS_FOR_A_MARKET_SEGMENT"},
            {"value": "A", "descr": "CANCEL_ORDERS_FOR_A_SECURITY_GROUP"},
            {"value": "B", "descr": "CANCEL_FOR_SECURITY_ISSUER"},
            {
                "value": "C",
                "descr": "CANCEL_FOR_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        531: [
            {"value": "0", "descr": "CANCEL_REQUEST_REJECTED"},
            {"value": "1", "descr": "CANCEL_ORDERS_FOR_A_SECURITY"},
            {
                "value": "2",
                "descr": "CANCEL_ORDERS_FOR_AN_UNDERLYING_SECURITY",
            },
            {"value": "3", "descr": "CANCEL_ORDERS_FOR_A_PRODUCT"},
            {"value": "4", "descr": "CANCEL_ORDERS_FOR_A_CFICODE"},
            {"value": "5", "descr": "CANCEL_ORDERS_FOR_A_SECURITYTYPE"},
            {"value": "6", "descr": "CANCEL_ORDERS_FOR_A_TRADING_SESSION"},
            {"value": "7", "descr": "CANCEL_ALL_ORDERS"},
            {"value": "8", "descr": "CANCEL_ORDERS_FOR_A_MARKET"},
            {"value": "9", "descr": "CANCEL_ORDERS_FOR_A_MARKET_SEGMENT"},
            {"value": "A", "descr": "CANCEL_ORDERS_FOR_A_SECURITY_GROUP"},
            {"value": "B", "descr": "CANCEL_ORDERS_FOR_A_SECURITIES_ISSUER"},
            {
                "value": "C",
                "descr": "CANCEL_ORDERS_FOR_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        532: [
            {"value": "0", "descr": "MASS_CANCEL_NOT_SUPPORTED"},
            {"value": "1", "descr": "INVALID_OR_UNKNOWN_SECURITY"},
            {"value": "2", "descr": "INVALID_OR_UNKOWN_UNDERLYING_SECURITY"},
            {"value": "3", "descr": "INVALID_OR_UNKNOWN_PRODUCT"},
            {"value": "4", "descr": "INVALID_OR_UNKNOWN_CFICODE"},
            {"value": "5", "descr": "INVALID_OR_UNKNOWN_SECURITYTYPE"},
            {"value": "6", "descr": "INVALID_OR_UNKNOWN_TRADING_SESSION"},
            {"value": "7", "descr": "INVALID_OR_UNKNOWN_MARKET"},
            {"value": "8", "descr": "INVALID_OR_UNKOWN_MARKET_SEGMENT"},
            {"value": "9", "descr": "INVALID_OR_UNKNOWN_SECURITY_GROUP"},
            {"value": "99", "descr": "OTHER"},
            {"value": "10", "descr": "INVALID_OR_UNKNOWN_SECURITY_ISSUER"},
            {
                "value": "11",
                "descr": "INVALID_OR_UNKNOWN_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        537: [
            {"value": "0", "descr": "INDICATIVE"},
            {"value": "1", "descr": "TRADEABLE"},
            {"value": "2", "descr": "RESTRICTED_TRADEABLE"},
            {"value": "3", "descr": "COUNTER"},
        ],
        544: [
            {"value": "1", "descr": "CASH"},
            {"value": "2", "descr": "MARGIN_OPEN"},
            {"value": "3", "descr": "MARGIN_CLOSE"},
        ],
        546: [
            {"value": "1", "descr": "LOCAL_MARKET"},
            {"value": "2", "descr": "NATIONAL"},
            {"value": "3", "descr": "GLOBAL"},
        ],
        547: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        549: [
            {"value": "1", "descr": "CROSS_AON"},
            {"value": "2", "descr": "CROSS_IOC"},
            {"value": "3", "descr": "CROSS_ONE_SIDE"},
            {"value": "4", "descr": "CROSS_SAME_PRICE"},
        ],
        550: [
            {"value": "0", "descr": "NONE"},
            {"value": "1", "descr": "BUY_SIDE_IS_PRIORITIZED"},
            {"value": "2", "descr": "SELL_SIDE_IS_PRIORITIZED"},
        ],
        552: [
            {"value": "1", "descr": "ONE_SIDE"},
            {"value": "2", "descr": "BOTH_SIDES"},
        ],
        559: [
            {"value": "0", "descr": "SYMBOL"},
            {"value": "1", "descr": "SECURITYTYPE_AND_OR_CFICODE"},
            {"value": "2", "descr": "PRODUCT"},
            {"value": "3", "descr": "TRADINGSESSIONID"},
            {"value": "4", "descr": "ALL_SECURITIES"},
            {
                "value": "5",
                "descr": "MARKETID_OR_MARKETID_PLUS_MARKETSEGMENTID",
            },
        ],
        560: [
            {"value": "0", "descr": "VALID_REQUEST"},
            {"value": "1", "descr": "INVALID_OR_UNSUPPORTED_REQUEST"},
            {
                "value": "2",
                "descr": "NO_INSTRUMENTS_FOUND_THAT_MATCH_SELECTION_CRITERIA",
            },
            {
                "value": "3",
                "descr": "NOT_AUTHORIZED_TO_RETRIEVE_INSTRUMENT_DATA",
            },
            {"value": "4", "descr": "INSTRUMENT_DATA_TEMPORARILY_UNAVAILABLE"},
            {
                "value": "5",
                "descr": "REQUEST_FOR_INSTRUMENT_DATA_NOT_SUPPORTED",
            },
        ],
        563: [
            {"value": "0", "descr": "REPORT_BY_MULITLEG_SECURITY_ONLY"},
            {
                "value": "1",
                "descr": "REPORT_BY_MULTILEG_SECURITY_AND_BY_INSTRUMENT_LEGS_BELONGING_TO_THE_MULTILEG_SECURITY",
            },
            {
                "value": "2",
                "descr": "REPORT_BY_INSTRUMENT_LEGS_BELONGING_TO_THE_MULTILEG_SECURITY_ONLY",
            },
        ],
        567: [
            {"value": "1", "descr": "UNKNOWN_OR_INVALID_TRADINGSESSIONID"},
            {"value": "99", "descr": "OTHER"},
        ],
        569: [
            {"value": "0", "descr": "ALL_TRADES"},
            {
                "value": "1",
                "descr": "MATCHED_TRADES_MATCHING_CRITERIA_PROVIDED_ON_REQUEST",
            },
            {"value": "2", "descr": "UNMATCHED_TRADES_THAT_MATCH_CRITERIA"},
            {"value": "3", "descr": "UNREPORTED_TRADES_THAT_MATCH_CRITERIA"},
            {"value": "4", "descr": "ADVISORIES_THAT_MATCH_CRITERIA"},
        ],
        570: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        573: [
            {"value": "0", "descr": "COMPARED_MATCHED_OR_AFFIRMED"},
            {"value": "1", "descr": "UNCOMPARED_UNMATCHED_OR_UNAFFIRMED"},
            {"value": "2", "descr": "ADVISORY_OR_ALERT"},
        ],
        574: [
            {"value": "1", "descr": "ONE_PARTY_TRADE_REPORT"},
            {"value": "2", "descr": "TWO_PARTY_TRADE_REPORT"},
            {"value": "3", "descr": "CONFIRMED_TRADE_REPORT"},
            {"value": "4", "descr": "AUTO_MATCH"},
            {"value": "5", "descr": "CROSS_AUCTION"},
            {"value": "6", "descr": "COUNTER_ORDER_SELECTION"},
            {"value": "7", "descr": "CALL_AUCTION"},
            {"value": "8", "descr": "ISSUING_BUY_BACK_AUCTION"},
            {"value": "M3", "descr": "ACT_ACCEPTED_TRADE"},
            {"value": "M4", "descr": "ACT_DEFAULT_TRADE"},
            {"value": "M5", "descr": "ACT_DEFAULT_AFTER_M2"},
            {"value": "M6", "descr": "ACT_M6_MATCH"},
            {
                "value": "A1",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADE_TYPE_AND_SPECIAL_TRADE_INDICATOR_PLUS_FOUR_BADGES_AND_EXECUTION_TIME",
            },
            {
                "value": "A2",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADE_TYPE_AND_SPECIAL_TRADE_INDICATOR_PLUS_FOUR_BADGES",
            },
            {
                "value": "A3",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADE_TYPE_AND_SPECIAL_TRADE_INDICATOR_PLUS_TWO_BADGES_AND_EXECUTION_TIME",
            },
            {
                "value": "A4",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADE_TYPE_AND_SPECIAL_TRADE_INDICATOR_PLUS_TWO_BADGES",
            },
            {
                "value": "A5",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADETYPE_AND_SPECIAL_TRADE_INDICATOR_PLUS_EXECUTION_TIME",
            },
            {
                "value": "AQ",
                "descr": "COMPARED_RECORDS_RESULTING_FROM_STAMPED_ADVISORIES_OR_SPECIALIST_ACCEPTS_PAIR_OFFS",
            },
            {
                "value": "S1",
                "descr": "SUMMARIZED_MATCH_USING_A1_EXACT_MATCH_CRITERIA_EXCEPT_QUANTITY_IS_SUMMARIED",
            },
            {
                "value": "S2",
                "descr": "SUMMARIZED_MATCH_USING_A2_EXACT_MATCH_CRITERIA_EXCEPT_QUANTITY_IS_SUMMARIZED",
            },
            {
                "value": "S3",
                "descr": "SUMMARIZED_MATCH_USING_A3_EXACT_MATCH_CRITERIA_EXCEPT_QUANTITY_IS_SUMMARIZED",
            },
            {
                "value": "S4",
                "descr": "SUMMARIZED_MATCH_USING_A4_EXACT_MATCH_CRITERIA_EXCEPT_QUANTITY_IS_SUMMARIZED",
            },
            {
                "value": "S5",
                "descr": "SUMMARIZED_MATCH_USING_A5_EXACT_MATCH_CRITERIA_EXCEPT_QUANTITY_IS_SUMMARIZED",
            },
            {
                "value": "M1",
                "descr": "EXACT_MATCH_ON_TRADE_DATE_STOCK_SYMBOL_QUANTITY_PRICE_TRADE_TYPE_AND_SPECIAL_TRADE_INDICATOR_MINUS_BADGES_AND_TIMES_ACT_M1_MATCH",
            },
            {
                "value": "M2",
                "descr": "SUMMARIZED_MATCH_MINUS_BADGES_AND_TIMES_ACT_M2_MATCH",
            },
            {"value": "MT", "descr": "OCS_LOCKED_IN_NON_ACT"},
        ],
        575: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        577: [
            {"value": "0", "descr": "PROCESS_NORMALLY"},
            {"value": "1", "descr": "EXCLUDE_FROM_ALL_NETTING"},
            {"value": "2", "descr": "BILATERAL_NETTING_ONLY"},
            {"value": "3", "descr": "EX_CLEARING"},
            {"value": "4", "descr": "SPECIAL_TRADE"},
            {"value": "5", "descr": "MULTILATERAL_NETTING"},
            {"value": "6", "descr": "CLEAR_AGAINST_CENTRAL_COUNTERPARTY"},
            {"value": "7", "descr": "EXCLUDE_FROM_CENTRAL_COUNTERPARTY"},
            {"value": "8", "descr": "MANUAL_MODE"},
            {"value": "9", "descr": "AUTOMATIC_POSTING_MODE"},
            {"value": "10", "descr": "AUTOMATIC_GIVE_UP_MODE"},
            {"value": "11", "descr": "QUALIFIED_SERVICE_REPRESENTATIVE_QSR"},
            {"value": "12", "descr": "CUSTOMER_TRADE"},
            {"value": "13", "descr": "SELF_CLEARING"},
        ],
        581: [
            {
                "value": "1",
                "descr": "ACCOUNT_IS_CARRIED_ON_CUSTOMER_SIDE_OF_THE_BOOKS",
            },
            {
                "value": "2",
                "descr": "ACCOUNT_IS_CARRIED_ON_NON_CUSTOMER_SIDE_OF_BOOKS",
            },
            {"value": "3", "descr": "HOUSE_TRADER"},
            {"value": "4", "descr": "FLOOR_TRADER"},
            {
                "value": "6",
                "descr": "ACCOUNT_IS_CARRIED_ON_NON_CUSTOMER_SIDE_OF_BOOKS_AND_IS_CROSS_MARGINED",
            },
            {
                "value": "7",
                "descr": "ACCOUNT_IS_HOUSE_TRADER_AND_IS_CROSS_MARGINED",
            },
            {"value": "8", "descr": "JOINT_BACK_OFFICE_ACCOUNT"},
        ],
        582: [
            {"value": "1", "descr": "MEMBER_TRADING_FOR_THEIR_OWN_ACCOUNT"},
            {
                "value": "2",
                "descr": "CLEARING_FIRM_TRADING_FOR_ITS_PROPRIETARY_ACCOUNT",
            },
            {"value": "3", "descr": "MEMBER_TRADING_FOR_ANOTHER_MEMBER"},
            {"value": "4", "descr": "ALL_OTHER"},
        ],
        585: [
            {"value": "1", "descr": "STATUS_FOR_ORDERS_FOR_A_SECURITY"},
            {
                "value": "2",
                "descr": "STATUS_FOR_ORDERS_FOR_AN_UNDERLYING_SECURITY",
            },
            {"value": "3", "descr": "STATUS_FOR_ORDERS_FOR_A_PRODUCT"},
            {"value": "4", "descr": "STATUS_FOR_ORDERS_FOR_A_CFICODE"},
            {"value": "5", "descr": "STATUS_FOR_ORDERS_FOR_A_SECURITYTYPE"},
            {"value": "6", "descr": "STATUS_FOR_ORDERS_FOR_A_TRADING_SESSION"},
            {"value": "7", "descr": "STATUS_FOR_ALL_ORDERS"},
            {"value": "8", "descr": "STATUS_FOR_ORDERS_FOR_A_PARTYID"},
            {"value": "9", "descr": "STATUS_FOR_SECURITY_ISSUER"},
            {
                "value": "10",
                "descr": "STATUS_FOR_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        589: [
            {
                "value": "0",
                "descr": "CAN_TRIGGER_BOOKING_WITHOUT_REFERENCE_TO_THE_ORDER_INITIATOR",
            },
            {
                "value": "1",
                "descr": "SPEAK_WITH_ORDER_INITIATOR_BEFORE_BOOKING",
            },
            {"value": "2", "descr": "ACCUMULATE"},
        ],
        590: [
            {
                "value": "0",
                "descr": "EACH_PARTIAL_EXECUTION_IS_A_BOOKABLE_UNIT",
            },
            {
                "value": "1",
                "descr": "AGGREGATE_PARTIAL_EXECUTIONS_ON_THIS_ORDER_AND_BOOK_ONE_TRADE_PER_ORDER",
            },
            {
                "value": "2",
                "descr": "AGGREGATE_EXECUTIONS_FOR_THIS_SYMBOL_SIDE_AND_SETTLEMENT_DATE",
            },
        ],
        591: [
            {"value": "0", "descr": "PRO_RATA"},
            {"value": "1", "descr": "DO_NOT_PRO_RATA"},
        ],
        625: [
            {"value": "1", "descr": "PRE_TRADING"},
            {"value": "2", "descr": "OPENING_OR_OPENING_AUCTION"},
            {"value": "3", "descr": "3"},
            {"value": "4", "descr": "CLOSING_OR_CLOSING_AUCTION"},
            {"value": "5", "descr": "POST_TRADING"},
            {"value": "6", "descr": "INTRADAY_AUCTION"},
            {"value": "7", "descr": "QUIESCENT"},
        ],
        626: [
            {"value": "1", "descr": "CALCULATED"},
            {"value": "2", "descr": "PRELIMINARY"},
            {"value": "3", "descr": "SELLSIDE_CALCULATED_USING_PRELIMINARY"},
            {"value": "4", "descr": "SELLSIDE_CALCULATED_WITHOUT_PRELIMINARY"},
            {"value": "5", "descr": "READY_TO_BOOK"},
            {"value": "6", "descr": "BUYSIDE_READY_TO_BOOK"},
            {"value": "7", "descr": "WAREHOUSE_INSTRUCTION"},
            {"value": "8", "descr": "REQUEST_TO_INTERMEDIARY"},
            {"value": "9", "descr": "ACCEPT"},
            {"value": "10", "descr": "REJECT"},
            {"value": "11", "descr": "ACCEPT_PENDING"},
            {"value": "12", "descr": "INCOMPLETE_GROUP"},
            {"value": "13", "descr": "COMPLETE_GROUP"},
            {"value": "14", "descr": "REVERSAL_PENDING"},
        ],
        635: [
            {
                "value": "1",
                "descr": "1ST_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {
                "value": "2",
                "descr": "2ND_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {
                "value": "3",
                "descr": "3RD_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {
                "value": "4",
                "descr": "4TH_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {
                "value": "5",
                "descr": "5TH_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {
                "value": "9",
                "descr": "6TH_YEAR_DELEGATE_TRADING_FOR_OWN_ACCOUNT",
            },
            {"value": "B", "descr": "CBOE_MEMBER"},
            {"value": "C", "descr": "NON_MEMBER_AND_CUSTOMER"},
            {"value": "E", "descr": "EQUITY_MEMBER_AND_CLEARING_MEMBER"},
            {
                "value": "F",
                "descr": "FULL_AND_ASSOCIATE_MEMBER_TRADING_FOR_OWN_ACCOUNT_AND_AS_FLOOR_BROKERS",
            },
            {"value": "H", "descr": "106H_AND_106J_FIRMS"},
            {
                "value": "I",
                "descr": "GIM_IDEM_AND_COM_MEMBERSHIP_INTEREST_HOLDERS",
            },
            {"value": "L", "descr": "LESSEE_106F_EMPLOYEES"},
            {"value": "M", "descr": "ALL_OTHER_OWNERSHIP_TYPES"},
        ],
        636: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        638: [
            {"value": "0", "descr": "PRIORITY_UNCHANGED"},
            {"value": "1", "descr": "LOST_PRIORITY_AS_RESULT_OF_ORDER_CHANGE"},
        ],
        650: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        658: [
            {"value": "1", "descr": "UNKNOWN_SYMBOL"},
            {"value": "2", "descr": "EXCHANGE"},
            {"value": "3", "descr": "QUOTE_REQUEST_EXCEEDS_LIMIT"},
            {"value": "4", "descr": "TOO_LATE_TO_ENTER"},
            {"value": "5", "descr": "INVALID_PRICE"},
            {"value": "6", "descr": "NOT_AUTHORIZED_TO_REQUEST_QUOTE"},
            {"value": "7", "descr": "NO_MATCH_FOR_INQUIRY"},
            {"value": "8", "descr": "NO_MARKET_FOR_INSTRUMENT"},
            {"value": "9", "descr": "NO_INVENTORY"},
            {"value": "10", "descr": "PASS"},
            {"value": "11", "descr": "INSUFFICIENT_CREDIT"},
            {"value": "99", "descr": "OTHER"},
        ],
        660: [
            {"value": "1", "descr": "BIC"},
            {"value": "2", "descr": "SID_CODE"},
            {"value": "3", "descr": "TFM"},
            {"value": "4", "descr": "OMGEO"},
            {"value": "5", "descr": "DTCC_CODE"},
            {"value": "99", "descr": "OTHER"},
        ],
        665: [
            {"value": "1", "descr": "RECEIVED"},
            {"value": "2", "descr": "MISMATCHED_ACCOUNT"},
            {"value": "3", "descr": "MISSING_SETTLEMENT_INSTRUCTIONS"},
            {"value": "4", "descr": "CONFIRMED"},
            {"value": "5", "descr": "REQUEST_REJECTED"},
        ],
        666: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "REPLACE"},
            {"value": "2", "descr": "CANCEL"},
        ],
        668: [
            {"value": "1", "descr": "BOOK_ENTRY"},
            {"value": "2", "descr": "BEARER"},
        ],
        690: [
            {"value": "1", "descr": "PAR_FOR_PAR"},
            {"value": "2", "descr": "MODIFIED_DURATION"},
            {"value": "4", "descr": "RISK"},
            {"value": "5", "descr": "PROCEEDS"},
        ],
        692: [
            {"value": "1", "descr": "PERCENT"},
            {"value": "2", "descr": "PER_SHARE"},
            {"value": "3", "descr": "FIXED_AMOUNT"},
            {"value": "4", "descr": "DISCOUNT"},
            {"value": "5", "descr": "PREMIUM"},
            {"value": "6", "descr": "SPREAD"},
            {"value": "7", "descr": "TED_PRICE"},
            {"value": "8", "descr": "TED_YIELD"},
            {"value": "9", "descr": "YIELD_SPREAD"},
            {"value": "10", "descr": "YIELD"},
        ],
        694: [
            {"value": "1", "descr": "HIT_LIFT"},
            {"value": "2", "descr": "COUNTER"},
            {"value": "3", "descr": "EXPIRED"},
            {"value": "4", "descr": "COVER"},
            {"value": "5", "descr": "DONE_AWAY"},
            {"value": "6", "descr": "PASS"},
            {"value": "7", "descr": "END_TRADE"},
            {"value": "8", "descr": "TIMED_OUT"},
        ],
        703: [
            {"value": "ALC", "descr": "ALLOCATION_TRADE_QTY"},
            {"value": "AS", "descr": "OPTION_ASSIGNMENT"},
            {"value": "ASF", "descr": "AS_OF_TRADE_QTY"},
            {"value": "DLV", "descr": "DELIVERY_QTY"},
            {"value": "ETR", "descr": "ELECTRONIC_TRADE_QTY"},
            {"value": "EX", "descr": "OPTION_EXERCISE_QTY"},
            {"value": "FIN", "descr": "END_OF_DAY_QTY"},
            {"value": "IAS", "descr": "INTRA_SPREAD_QTY"},
            {"value": "IES", "descr": "INTER_SPREAD_QTY"},
            {"value": "PA", "descr": "ADJUSTMENT_QTY"},
            {"value": "PIT", "descr": "PIT_TRADE_QTY"},
            {"value": "SOD", "descr": "START_OF_DAY_QTY"},
            {"value": "SPL", "descr": "INTEGRAL_SPLIT"},
            {"value": "TA", "descr": "TRANSACTION_FROM_ASSIGNMENT"},
            {"value": "TOT", "descr": "TOTAL_TRANSACTION_QTY"},
            {"value": "TQ", "descr": "TRANSACTION_QUANTITY"},
            {"value": "TRF", "descr": "TRANSFER_TRADE_QTY"},
            {"value": "TX", "descr": "TRANSACTION_FROM_EXERCISE"},
            {"value": "XM", "descr": "CROSS_MARGIN_QTY"},
            {"value": "RCV", "descr": "RECEIVE_QUANTITY"},
            {"value": "CAA", "descr": "CORPORATE_ACTION_ADJUSTMENT"},
            {"value": "DN", "descr": "DELIVERY_NOTICE_QTY"},
            {"value": "EP", "descr": "EXCHANGE_FOR_PHYSICAL_QTY"},
            {"value": "PNTN", "descr": "PRIVATELY_NEGOTIATED_TRADE_QTY"},
            {"value": "DLT", "descr": "NET_DELTA_QTY"},
            {"value": "CEA", "descr": "CREDIT_EVENT_ADJUSTMENT"},
            {"value": "SEA", "descr": "SUCCESSION_EVENT_ADJUSTMENT"},
        ],
        706: [
            {"value": "0", "descr": "SUBMITTED"},
            {"value": "1", "descr": "ACCEPTED"},
            {"value": "2", "descr": "REJECTED"},
        ],
        707: [
            {"value": "CASH", "descr": "CASH_AMOUNT"},
            {"value": "CRES", "descr": "CASH_RESIDUAL_AMOUNT"},
            {"value": "FMTM", "descr": "FINAL_MARK_TO_MARKET_AMOUNT"},
            {"value": "IMTM", "descr": "INCREMENTAL_MARK_TO_MARKET_AMOUNT"},
            {"value": "PREM", "descr": "PREMIUM_AMOUNT"},
            {"value": "SMTM", "descr": "START_OF_DAY_MARK_TO_MARKET_AMOUNT"},
            {"value": "TVAR", "descr": "TRADE_VARIATION_AMOUNT"},
            {"value": "VADJ", "descr": "VALUE_ADJUSTED_AMOUNT"},
            {"value": "SETL", "descr": "SETTLEMENT_VALUE"},
            {"value": "ICPN", "descr": "INITIAL_TRADE_COUPON_AMOUNT"},
            {"value": "ACPN", "descr": "ACCRUED_COUPON_AMOUNT"},
            {"value": "CPN", "descr": "COUPON_AMOUNT"},
            {"value": "IACPN", "descr": "INCREMENTAL_ACCRUED_COUPON"},
            {"value": "CMTM", "descr": "COLLATERALIZED_MARK_TO_MARKET"},
            {
                "value": "ICMTM",
                "descr": "INCREMENTAL_COLLATERALIZED_MARK_TO_MARKET",
            },
            {"value": "DLV", "descr": "COMPENSATION_AMOUNT"},
            {"value": "BANK", "descr": "TOTAL_BANKED_AMOUNT"},
            {"value": "COLAT", "descr": "TOTAL_COLLATERALIZED_AMOUNT"},
        ],
        709: [
            {"value": "1", "descr": "EXERCISE"},
            {"value": "2", "descr": "DO_NOT_EXERCISE"},
            {"value": "3", "descr": "POSITION_ADJUSTMENT"},
            {
                "value": "4",
                "descr": "POSITION_CHANGE_SUBMISSION_MARGIN_DISPOSITION",
            },
            {"value": "5", "descr": "PLEDGE"},
            {"value": "6", "descr": "LARGE_TRADER_SUBMISSION"},
        ],
        712: [
            {"value": "1", "descr": "NEW"},
            {"value": "2", "descr": "REPLACE"},
            {"value": "3", "descr": "CANCEL"},
            {"value": "4", "descr": "REVERSE"},
        ],
        716: [
            {"value": "ITD", "descr": "INTRADAY"},
            {"value": "RTH", "descr": "REGULAR_TRADING_HOURS"},
            {"value": "ETH", "descr": "ELECTRONIC_TRADING_HOURS"},
            {"value": "EOD", "descr": "END_OF_DAY"},
        ],
        718: [
            {"value": "0", "descr": "PROCESS_REQUEST_AS_MARGIN_DISPOSITION"},
            {"value": "1", "descr": "DELTA_PLUS"},
            {"value": "2", "descr": "DELTA_MINUS"},
            {"value": "3", "descr": "FINAL"},
        ],
        722: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "ACCEPTED_WITH_WARNINGS"},
            {"value": "2", "descr": "REJECTED"},
            {"value": "3", "descr": "COMPLETED"},
            {"value": "4", "descr": "COMPLETED_WITH_WARNINGS"},
        ],
        723: [
            {"value": "0", "descr": "SUCCESSFUL_COMPLETION"},
            {"value": "1", "descr": "REJECTED"},
            {"value": "99", "descr": "OTHER"},
        ],
        724: [
            {"value": "0", "descr": "POSITIONS"},
            {"value": "1", "descr": "TRADES"},
            {"value": "2", "descr": "EXERCISES"},
            {"value": "3", "descr": "ASSIGNMENTS"},
            {"value": "4", "descr": "SETTLEMENT_ACTIVITY"},
            {"value": "5", "descr": "BACKOUT_MESSAGE"},
            {"value": "6", "descr": "DELTA_POSITIONS"},
        ],
        725: [
            {"value": "0", "descr": "INBAND"},
            {"value": "1", "descr": "OUT_OF_BAND"},
        ],
        728: [
            {"value": "0", "descr": "VALID_REQUEST"},
            {"value": "1", "descr": "INVALID_OR_UNSUPPORTED_REQUEST"},
            {"value": "2", "descr": "NO_POSITIONS_FOUND_THAT_MATCH_CRITERIA"},
            {"value": "3", "descr": "NOT_AUTHORIZED_TO_REQUEST_POSITIONS"},
            {"value": "4", "descr": "REQUEST_FOR_POSITION_NOT_SUPPORTED"},
            {"value": "99", "descr": "OTHER"},
        ],
        729: [
            {"value": "0", "descr": "COMPLETED"},
            {"value": "1", "descr": "COMPLETED_WITH_WARNINGS"},
            {"value": "2", "descr": "REJECTED"},
        ],
        731: [
            {"value": "1", "descr": "FINAL"},
            {"value": "2", "descr": "THEORETICAL"},
        ],
        744: [
            {"value": "P", "descr": "PRO_RATA"},
            {"value": "R", "descr": "RANDOM"},
        ],
        747: [
            {"value": "A", "descr": "AUTOMATIC"},
            {"value": "M", "descr": "MANUAL"},
        ],
        749: [
            {"value": "0", "descr": "SUCCESSFUL"},
            {"value": "1", "descr": "INVALID_OR_UNKNOWN_INSTRUMENT"},
            {"value": "2", "descr": "INVALID_TYPE_OF_TRADE_REQUESTED"},
            {"value": "3", "descr": "INVALID_PARTIES"},
            {"value": "4", "descr": "INVALID_TRANSPORT_TYPE_REQUESTED"},
            {"value": "5", "descr": "INVALID_DESTINATION_REQUESTED"},
            {"value": "8", "descr": "TRADEREQUESTTYPE_NOT_SUPPORTED"},
            {"value": "9", "descr": "NOT_AUTHORIZED"},
            {"value": "99", "descr": "OTHER"},
        ],
        750: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "COMPLETED"},
            {"value": "2", "descr": "REJECTED"},
        ],
        751: [
            {"value": "0", "descr": "SUCCESSFUL"},
            {"value": "1", "descr": "INVALID_PARTY_ONFORMATION"},
            {"value": "2", "descr": "UNKNOWN_INSTRUMENT"},
            {"value": "3", "descr": "UNAUTHORIZED_TO_REPORT_TRADES"},
            {"value": "4", "descr": "INVALID_TRADE_TYPE"},
            {"value": "99", "descr": "OTHER"},
        ],
        752: [
            {"value": "1", "descr": "SINGLE_SECURITY"},
            {"value": "2", "descr": "INDIVIDUAL_LEG_OF_A_MULTILEG_SECURITY"},
            {"value": "3", "descr": "MULTILEG_SECURITY"},
        ],
        770: [
            {"value": "1", "descr": "EXECUTION_TIME"},
            {"value": "2", "descr": "TIME_IN"},
            {"value": "3", "descr": "TIME_OUT"},
            {"value": "4", "descr": "BROKER_RECEIPT"},
            {"value": "5", "descr": "BROKER_EXECUTION"},
            {"value": "6", "descr": "DESK_RECEIPT"},
            {"value": "7", "descr": "SUBMISSION_TO_CLEARING"},
        ],
        773: [
            {"value": "1", "descr": "STATUS"},
            {"value": "2", "descr": "CONFIRMATION"},
            {"value": "3", "descr": "CONFIRMATION_REQUEST_REJECTED"},
        ],
        774: [
            {"value": "1", "descr": "MISMATCHED_ACCOUNT"},
            {"value": "2", "descr": "MISSING_SETTLEMENT_INSTRUCTIONS"},
            {"value": "99", "descr": "OTHER"},
        ],
        775: [
            {"value": "0", "descr": "REGULAR_BOOKING"},
            {"value": "1", "descr": "CFD"},
            {"value": "2", "descr": "TOTAL_RETURN_SWAP"},
        ],
        780: [
            {"value": "0", "descr": "USE_DEFAULT_INSTRUCTIONS"},
            {"value": "1", "descr": "DERIVE_FROM_PARAMETERS_PROVIDED"},
            {"value": "2", "descr": "FULL_DETAILS_PROVIDED"},
            {"value": "3", "descr": "SSI_DB_IDS_PROVIDED"},
            {"value": "4", "descr": "PHONE_FOR_INSTRUCTIONS"},
        ],
        787: [
            {"value": "C", "descr": "CASH"},
            {"value": "S", "descr": "SECURITIES"},
        ],
        788: [
            {"value": "1", "descr": "OVERNIGHT"},
            {"value": "2", "descr": "TERM"},
            {"value": "3", "descr": "FLEXIBLE"},
            {"value": "4", "descr": "OPEN"},
        ],
        792: [
            {"value": "0", "descr": "UNABLE_TO_PROCESS_REQUEST"},
            {"value": "1", "descr": "UNKNOWN_ACCOUNT"},
            {
                "value": "2",
                "descr": "NO_MATCHING_SETTLEMENT_INSTRUCTIONS_FOUND",
            },
            {"value": "99", "descr": "OTHER"},
        ],
        794: [
            {"value": "2", "descr": "PRELIMINARY_REQUEST_TO_INTERMEDIARY"},
            {"value": "3", "descr": "SELLSIDE_CALCULATED_USING_PRELIMINARY"},
            {"value": "4", "descr": "SELLSIDE_CALCULATED_WITHOUT_PRELIMINARY"},
            {"value": "5", "descr": "WAREHOUSE_RECAP"},
            {"value": "8", "descr": "REQUEST_TO_INTERMEDIARY"},
            {"value": "9", "descr": "ACCEPT"},
            {"value": "10", "descr": "REJECT"},
            {"value": "11", "descr": "ACCEPT_PENDING"},
            {"value": "12", "descr": "COMPLETE"},
            {"value": "14", "descr": "REVERSE_PENDING"},
        ],
        796: [
            {"value": "1", "descr": "ORIGINAL_DETAILS_INCOMPLETE_INCORRECT"},
            {"value": "2", "descr": "CHANGE_IN_UNDERLYING_ORDER_DETAILS"},
            {"value": "99", "descr": "OTHER"},
        ],
        798: [
            {
                "value": "1",
                "descr": "ACCOUNT_IS_CARRIED_PN_CUSTOMER_SIDE_OF_BOOKS",
            },
            {
                "value": "2",
                "descr": "ACCOUNT_IS_CARRIED_ON_NON_CUSTOMER_SIDE_OF_BOOKS",
            },
            {"value": "3", "descr": "HOUSE_TRADER"},
            {"value": "4", "descr": "FLOOR_TRADER"},
            {
                "value": "6",
                "descr": "ACCOUNT_IS_CARRIED_ON_NON_CUSTOMER_SIDE_OF_BOOKS_AND_IS_CROSS_MARGINED",
            },
            {
                "value": "7",
                "descr": "ACCOUNT_IS_HOUSE_TRADER_AND_IS_CROSS_MARGINED",
            },
            {"value": "8", "descr": "JOINT_BACK_OFFICE_ACCOUNT"},
        ],
        803: [
            {"value": "1", "descr": "FIRM"},
            {"value": "2", "descr": "PERSON"},
            {"value": "3", "descr": "SYSTEM"},
            {"value": "4", "descr": "APPLICATION"},
            {"value": "5", "descr": "FULL_LEGAL_NAME_OF_FIRM"},
            {"value": "6", "descr": "POSTAL_ADDRESS"},
            {"value": "7", "descr": "PHONE_NUMBER"},
            {"value": "8", "descr": "EMAIL_ADDRESS"},
            {"value": "9", "descr": "CONTACT_NAME"},
            {"value": "10", "descr": "SECURITIES_ACCOUNT_NUMBER"},
            {"value": "11", "descr": "REGISTRATION_NUMBER"},
            {"value": "12", "descr": "REGISTERED_ADDRESS_12"},
            {"value": "13", "descr": "REGULATORY_STATUS"},
            {"value": "14", "descr": "REGISTRATION_NAME"},
            {"value": "15", "descr": "CASH_ACCOUNT_NUMBER"},
            {"value": "16", "descr": "BIC"},
            {"value": "17", "descr": "CSD_PARTICIPANT_MEMBER_CODE"},
            {"value": "18", "descr": "REGISTERED_ADDRESS_18"},
            {"value": "19", "descr": "FUND_ACCOUNT_NAME"},
            {"value": "20", "descr": "TELEX_NUMBER"},
            {"value": "21", "descr": "FAX_NUMBER"},
            {"value": "22", "descr": "SECURITIES_ACCOUNT_NAME"},
            {"value": "23", "descr": "CASH_ACCOUNT_NAME"},
            {"value": "24", "descr": "DEPARTMENT"},
            {"value": "25", "descr": "LOCATION_DESK"},
            {"value": "26", "descr": "POSITION_ACCOUNT_TYPE"},
            {"value": "27", "descr": "SECURITY_LOCATE_ID"},
            {"value": "28", "descr": "MARKET_MAKER"},
            {"value": "29", "descr": "ELIGIBLE_COUNTERPARTY"},
            {"value": "30", "descr": "PROFESSIONAL_CLIENT"},
            {"value": "31", "descr": "LOCATION"},
            {"value": "32", "descr": "EXECUTION_VENUE"},
            {"value": "33", "descr": "CURRENCY_DELIVERY_IDENTIFIER"},
        ],
        808: [
            {"value": "1", "descr": "PENDING_ACCEPT"},
            {"value": "2", "descr": "PENDING_RELEASE"},
            {"value": "3", "descr": "PENDING_REVERSAL"},
            {"value": "4", "descr": "ACCEPT"},
            {"value": "5", "descr": "BLOCK_LEVEL_REJECT"},
            {"value": "6", "descr": "ACCOUNT_LEVEL_REJECT"},
        ],
        814: [
            {"value": "0", "descr": "NO_ACTION_TAKEN"},
            {"value": "1", "descr": "QUEUE_FLUSHED"},
            {"value": "2", "descr": "OVERLAY_LAST"},
            {"value": "3", "descr": "END_SESSION"},
        ],
        815: [
            {"value": "0", "descr": "NO_ACTION_TAKEN"},
            {"value": "1", "descr": "QUEUE_FLUSHED"},
            {"value": "2", "descr": "OVERLAY_LAST"},
            {"value": "3", "descr": "END_SESSION"},
        ],
        819: [
            {"value": "0", "descr": "NO_AVERAGE_PRICING"},
            {
                "value": "1",
                "descr": "TRADE_IS_PART_OF_AN_AVERAGE_PRICE_GROUP_IDENTIFIED_BY_THE_TRADELINKID",
            },
            {
                "value": "2",
                "descr": "LAST_TRADE_IS_THE_AVERAGE_PRICE_GROUP_IDENTIFIED_BY_THE_TRADELINKID",
            },
        ],
        826: [
            {"value": "0", "descr": "ALLOCATION_NOT_REQUIRED"},
            {"value": "1", "descr": "ALLOCATION_REQUIRED"},
            {"value": "2", "descr": "USE_ALLOCATION_PROVIDED_WITH_THE_TRADE"},
            {"value": "3", "descr": "ALLOCATION_GIVE_UP_EXECUTOR"},
            {"value": "4", "descr": "ALLOCATION_FROM_EXECUTOR"},
            {"value": "5", "descr": "ALLOCATION_TO_CLAIM_ACCOUNT"},
        ],
        827: [
            {"value": "0", "descr": "EXPIRE_ON_TRADING_SESSION_CLOSE"},
            {"value": "1", "descr": "EXPIRE_ON_TRADING_SESSION_OPEN"},
            {
                "value": "2",
                "descr": "TRADING_ELIGIBILITY_EXPIRATION_SPECIFIED_IN_THE_DATE_AND_TIME_FIELDS_EVENTDATE",
            },
        ],
        828: [
            {"value": "0", "descr": "REGULAR_TRADE"},
            {"value": "1", "descr": "BLOCK_TRADE_1"},
            {"value": "2", "descr": "EFP"},
            {"value": "3", "descr": "TRANSFER"},
            {"value": "4", "descr": "LATE_TRADE"},
            {"value": "5", "descr": "T_TRADE"},
            {"value": "6", "descr": "WEIGHTED_AVERAGE_PRICE_TRADE"},
            {"value": "7", "descr": "BUNCHED_TRADE"},
            {"value": "8", "descr": "LATE_BUNCHED_TRADE"},
            {"value": "9", "descr": "PRIOR_REFERENCE_PRICE_TRADE"},
            {"value": "10", "descr": "AFTER_HOURS_TRADE"},
            {"value": "11", "descr": "EXCHANGE_FOR_RISK"},
            {"value": "12", "descr": "EXCHANGE_FOR_SWAP"},
            {"value": "13", "descr": "EXCHANGE_OF_FUTURES_FOR"},
            {"value": "14", "descr": "EXCHANGE_OF_OPTIONS_FOR_OPTIONS"},
            {"value": "15", "descr": "TRADING_AT_SETTLEMENT"},
            {"value": "16", "descr": "ALL_OR_NONE"},
            {"value": "17", "descr": "FUTURES_LARGE_ORDER_EXECUTION"},
            {"value": "18", "descr": "EXCHANGE_OF_FUTURES_FOR_FUTURES"},
            {"value": "19", "descr": "OPTION_INTERIM_TRADE"},
            {"value": "20", "descr": "OPTION_CABINET_TRADE"},
            {"value": "22", "descr": "PRIVATELY_NEGOTIATED_TRADES"},
            {"value": "23", "descr": "SUBSTITUTION_OF_FUTURES_FOR_FORWARDS"},
            {"value": "48", "descr": "NON_STANDARD_SETTLEMENT"},
            {"value": "49", "descr": "DERIVATIVE_RELATED_TRANSACTION"},
            {"value": "50", "descr": "PORTFOLIO_TRADE"},
            {"value": "51", "descr": "VOLUME_WEIGHTED_AVERAGE_TRADE"},
            {"value": "52", "descr": "EXCHANGE_GRANTED_TRADE"},
            {"value": "53", "descr": "REPURCHASE_AGREEMENT"},
            {"value": "54", "descr": "OTC"},
            {"value": "55", "descr": "EXCHANGE_BASIS_FACILITY"},
            {"value": "24", "descr": "ERROR_TRADE"},
            {"value": "25", "descr": "SPECIAL_CUM_DIVIDEND"},
            {"value": "26", "descr": "SPECIAL_EX_DIVIDEND"},
            {"value": "27", "descr": "SPECIAL_CUM_COUPON"},
            {"value": "28", "descr": "SPECIAL_EX_COUPON"},
            {"value": "29", "descr": "CASH_SETTLEMENT"},
            {"value": "30", "descr": "SPECIAL_PRICE"},
            {"value": "31", "descr": "GUARANTEED_DELIVERY"},
            {"value": "32", "descr": "SPECIAL_CUM_RIGHTS"},
            {"value": "33", "descr": "SPECIAL_EX_RIGHTS"},
            {"value": "34", "descr": "SPECIAL_CUM_CAPITAL_REPAYMENTS"},
            {"value": "35", "descr": "SPECIAL_EX_CAPITAL_REPAYMENTS"},
            {"value": "36", "descr": "SPECIAL_CUM_BONUS"},
            {"value": "37", "descr": "SPECIAL_EX_BONUS"},
            {"value": "38", "descr": "BLOCK_TRADE_38"},
            {"value": "39", "descr": "WORKED_PRINCIPAL_TRADE"},
            {"value": "40", "descr": "BLOCK_TRADES"},
            {"value": "41", "descr": "NAME_CHANGE"},
            {"value": "42", "descr": "PORTFOLIO_TRANSFER"},
            {"value": "43", "descr": "PROROGATION_BUY"},
            {"value": "44", "descr": "PROROGATION_SELL"},
            {"value": "45", "descr": "OPTION_EXERCISE"},
            {"value": "46", "descr": "DELTA_NEUTRAL_TRANSACTION"},
            {"value": "47", "descr": "FINANCING_TRANSACTION"},
        ],
        829: [
            {"value": "0", "descr": "CMTA"},
            {"value": "1", "descr": "INTERNAL_TRANSFER_OR_ADJUSTMENT"},
            {
                "value": "2",
                "descr": "EXTERNAL_TRANSFER_OR_TRANSFER_OF_ACCOUNT",
            },
            {"value": "3", "descr": "REJECT_FOR_SUBMITTING_SIDE"},
            {"value": "4", "descr": "ADVISORY_FOR_CONTRA_SIDE"},
            {"value": "5", "descr": "OFFSET_DUE_TO_AN_ALLOCATION"},
            {"value": "6", "descr": "ONSET_DUE_TO_AN_ALLOCATION"},
            {"value": "7", "descr": "DIFFERENTIAL_SPREAD"},
            {
                "value": "8",
                "descr": "IMPLIED_SPREAD_LEG_EXECUTED_AGAINST_AN_OUTRIGHT",
            },
            {"value": "9", "descr": "TRANSACTION_FROM_EXERCISE"},
            {"value": "10", "descr": "TRANSACTION_FROM_ASSIGNMENT"},
            {"value": "11", "descr": "ACATS"},
            {"value": "33", "descr": "OFF_HOURS_TRADE"},
            {"value": "34", "descr": "ON_HOURS_TRADE"},
            {"value": "35", "descr": "OTC_QUOTE"},
            {"value": "36", "descr": "CONVERTED_SWAP"},
            {"value": "14", "descr": "AI"},
            {"value": "15", "descr": "B"},
            {"value": "16", "descr": "K"},
            {"value": "17", "descr": "LC"},
            {"value": "18", "descr": "M"},
            {"value": "19", "descr": "N"},
            {"value": "20", "descr": "NM"},
            {"value": "21", "descr": "NR"},
            {"value": "22", "descr": "P"},
            {"value": "23", "descr": "PA"},
            {"value": "24", "descr": "PC"},
            {"value": "25", "descr": "PN"},
            {"value": "26", "descr": "R"},
            {"value": "27", "descr": "RO"},
            {"value": "28", "descr": "RT"},
            {"value": "29", "descr": "SW"},
            {"value": "30", "descr": "T"},
            {"value": "31", "descr": "WN"},
            {"value": "32", "descr": "WT"},
            {"value": "37", "descr": "CROSSED_TRADE"},
            {"value": "38", "descr": "INTERIM_PROTECTED_TRADE"},
            {"value": "39", "descr": "LARGE_IN_SCALE"},
        ],
        835: [
            {"value": "0", "descr": "FLOATING"},
            {"value": "1", "descr": "FIXED"},
        ],
        836: [
            {"value": "0", "descr": "PRICE"},
            {"value": "1", "descr": "BASIS_POINTS"},
            {"value": "2", "descr": "TICKS"},
            {"value": "3", "descr": "PRICE_TIER"},
        ],
        837: [
            {"value": "0", "descr": "OR_BETTER"},
            {"value": "1", "descr": "STRICT"},
            {"value": "2", "descr": "OR_WORSE"},
        ],
        838: [
            {"value": "1", "descr": "MORE_AGGRESSIVE"},
            {"value": "2", "descr": "MORE_PASSIVE"},
        ],
        840: [
            {"value": "1", "descr": "LOCAL"},
            {"value": "2", "descr": "NATIONAL"},
            {"value": "3", "descr": "GLOBAL"},
            {"value": "4", "descr": "NATIONAL_EXCLUDING_LOCAL"},
        ],
        841: [
            {"value": "0", "descr": "FLOATING"},
            {"value": "1", "descr": "FIXED"},
        ],
        842: [
            {"value": "0", "descr": "PRICE"},
            {"value": "1", "descr": "BASIS_POINTS"},
            {"value": "2", "descr": "TICKS"},
            {"value": "3", "descr": "PRICE_TIER"},
        ],
        843: [
            {"value": "0", "descr": "OR_BETTER"},
            {"value": "1", "descr": "STRICT"},
            {"value": "2", "descr": "OR_WORSE"},
        ],
        844: [
            {"value": "1", "descr": "MORE_AGGRESSIVE"},
            {"value": "2", "descr": "MORE_PASSIVE"},
        ],
        846: [
            {"value": "1", "descr": "LOCAL"},
            {"value": "2", "descr": "NATIONAL"},
            {"value": "3", "descr": "GLOBAL"},
            {"value": "4", "descr": "NATIONAL_EXCLUDING_LOCAL"},
        ],
        847: [
            {"value": "1", "descr": "VWAP"},
            {"value": "2", "descr": "PARTICIPATE"},
            {"value": "3", "descr": "MININIZE_MARKET_IMPACT"},
        ],
        851: [
            {"value": "1", "descr": "ADDED_LIQUIDITY"},
            {"value": "2", "descr": "REMOVED_LIQUIDITY"},
            {"value": "3", "descr": "LIQUIDITY_ROUTED_OUT"},
            {"value": "4", "descr": "AUCTION"},
        ],
        852: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        853: [
            {"value": "0", "descr": "DEALER_SOLD_SHORT"},
            {"value": "1", "descr": "DEALER_SOLD_SHORT_EXEMPT"},
            {"value": "2", "descr": "SELLING_CUSTOMER_SOLD_SHORT"},
            {"value": "3", "descr": "SELLING_CUSTOMER_SOLD_SHORT_EXEMPT"},
            {"value": "4", "descr": "QUALIFIED_SERVICE_REPRESENTATIVE"},
            {
                "value": "5",
                "descr": "QSR_OR_AGU_CONTRA_SIDE_SOLD_SHORT_EXEMPT",
            },
        ],
        854: [
            {"value": "0", "descr": "UNITS"},
            {"value": "1", "descr": "CONTRACTS"},
            {"value": "2", "descr": "UNITS_OF_MEASURE_PER_TIME_UNIT"},
        ],
        856: [
            {"value": "0", "descr": "SUBMIT"},
            {"value": "1", "descr": "ALLEGED_1"},
            {"value": "2", "descr": "ACCEPT"},
            {"value": "3", "descr": "DECLINE"},
            {"value": "4", "descr": "ADDENDUM"},
            {"value": "5", "descr": "NO_WAS"},
            {"value": "6", "descr": "TRADE_REPORT_CANCEL"},
            {"value": "7", "descr": "7"},
            {"value": "8", "descr": "DEFAULTED"},
            {"value": "9", "descr": "INVALID_CMTA"},
            {"value": "10", "descr": "PENDED"},
            {"value": "11", "descr": "ALLEGED_NEW"},
            {"value": "12", "descr": "ALLEGED_ADDENDUM"},
            {"value": "13", "descr": "ALLEGED_NO_WAS"},
            {"value": "14", "descr": "ALLEGED_TRADE_REPORT_CANCEL"},
            {"value": "15", "descr": "ALLEGED_15"},
        ],
        857: [
            {"value": "0", "descr": "NOT_SPECIFIED"},
            {"value": "1", "descr": "EXPLICIT_LIST_PROVIDED"},
        ],
        865: [
            {"value": "1", "descr": "PUT"},
            {"value": "2", "descr": "CALL"},
            {"value": "3", "descr": "TENDER"},
            {"value": "4", "descr": "SINKING_FUND_CALL"},
            {"value": "5", "descr": "ACTIVATION"},
            {"value": "6", "descr": "INACTIVIATION"},
            {"value": "7", "descr": "LAST_ELIGIBLE_TRADE_DATE"},
            {"value": "8", "descr": "SWAP_START_DATE"},
            {"value": "9", "descr": "SWAP_END_DATE"},
            {"value": "10", "descr": "SWAP_ROLL_DATE"},
            {"value": "11", "descr": "SWAP_NEXT_START_DATE"},
            {"value": "12", "descr": "SWAP_NEXT_ROLL_DATE"},
            {"value": "13", "descr": "FIRST_DELIVERY_DATE"},
            {"value": "14", "descr": "LAST_DELIVERY_DATE"},
            {"value": "15", "descr": "INITIAL_INVENTORY_DUE_DATE"},
            {"value": "16", "descr": "FINAL_INVENTORY_DUE_DATE"},
            {"value": "17", "descr": "FIRST_INTENT_DATE"},
            {"value": "18", "descr": "LAST_INTENT_DATE"},
            {"value": "19", "descr": "POSITION_REMOVAL_DATE"},
            {"value": "99", "descr": "OTHER"},
        ],
        871: [
            {"value": "1", "descr": "FLAT"},
            {"value": "2", "descr": "ZERO_COUPON"},
            {"value": "3", "descr": "INTEREST_BEARING"},
            {"value": "4", "descr": "NO_PERIODIC_PAYMENTS"},
            {"value": "5", "descr": "VARIABLE_RATE"},
            {"value": "6", "descr": "LESS_FEE_FOR_PUT"},
            {"value": "7", "descr": "STEPPED_COUPON"},
            {"value": "8", "descr": "COUPON_PERIOD"},
            {"value": "9", "descr": "WHEN_AND_IF_ISSUED"},
            {"value": "10", "descr": "ORIGINAL_ISSUE_DISCOUNT"},
            {"value": "11", "descr": "CALLABLE_PUTTABLE"},
            {"value": "12", "descr": "ESCROWED_TO_MATURITY"},
            {"value": "13", "descr": "ESCROWED_TO_REDEMPTION_DATE"},
            {"value": "14", "descr": "PRE_REFUNDED"},
            {"value": "15", "descr": "IN_DEFAULT"},
            {"value": "16", "descr": "UNRATED"},
            {"value": "17", "descr": "TAXABLE"},
            {"value": "18", "descr": "INDEXED"},
            {"value": "19", "descr": "SUBJECT_TO_ALTERNATIVE_MINIMUM_TAX"},
            {
                "value": "20",
                "descr": "ORIGINAL_ISSUE_DISCOUNT_PRICE_SUPPLY_PRICE_IN_THE_INSTRATTRIBVALUE",
            },
            {"value": "21", "descr": "CALLABLE_BELOW_MATURITY_VALUE"},
            {
                "value": "22",
                "descr": "CALLABLE_WITHOUT_NOTICE_BY_MAIL_TO_HOLDER_UNLESS_REGISTERED",
            },
            {"value": "23", "descr": "PRICE_TICK_RULES_FOR_SECURITY"},
            {
                "value": "24",
                "descr": "TRADE_TYPE_ELIGIBILITY_DETAILS_FOR_SECURITY",
            },
            {"value": "25", "descr": "INSTRUMENT_DENOMINATOR"},
            {"value": "26", "descr": "INSTRUMENT_NUMERATOR"},
            {"value": "27", "descr": "INSTRUMENT_PRICE_PRECISION"},
            {"value": "28", "descr": "INSTRUMENT_STRIKE_PRICE"},
            {"value": "29", "descr": "TRADEABLE_INDICATOR"},
            {
                "value": "99",
                "descr": "TEXT_SUPPLY_THE_TEXT_OF_THE_ATTRIBUTE_OR_DISCLAIMER_IN_THE_INSTRATTRIBVALUE",
            },
        ],
        875: [
            {"value": "1", "descr": "3"},
            {"value": "2", "descr": "4"},
            {"value": "99", "descr": "OTHER"},
        ],
        891: [
            {"value": "0", "descr": "ABSOLUTE"},
            {"value": "1", "descr": "PER_UNIT"},
            {"value": "2", "descr": "PERCENTAGE"},
        ],
        893: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        895: [
            {"value": "0", "descr": "INITIAL"},
            {"value": "1", "descr": "SCHEDULED"},
            {"value": "2", "descr": "TIME_WARNING"},
            {"value": "3", "descr": "MARGIN_DEFICIENCY"},
            {"value": "4", "descr": "MARGIN_EXCESS"},
            {"value": "5", "descr": "FORWARD_COLLATERAL_DEMAND"},
            {"value": "6", "descr": "EVENT_OF_DEFAULT"},
            {"value": "7", "descr": "ADVERSE_TAX_EVENT"},
        ],
        896: [
            {"value": "0", "descr": "TRADE_DATE"},
            {"value": "1", "descr": "GC_INSTRUMENT"},
            {"value": "2", "descr": "COLLATERAL_INSTRUMENT"},
            {"value": "3", "descr": "SUBSTITUTION_ELIGIBLE"},
            {"value": "4", "descr": "NOT_ASSIGNED"},
            {"value": "5", "descr": "PARTIALLY_ASSIGNED"},
            {"value": "6", "descr": "FULLY_ASSIGNED"},
            {"value": "7", "descr": "OUTSTANDING_TRADES"},
        ],
        903: [
            {"value": "0", "descr": "NEW"},
            {"value": "1", "descr": "REPLACE"},
            {"value": "2", "descr": "CANCEL"},
            {"value": "3", "descr": "RELEASE"},
            {"value": "4", "descr": "REVERSE"},
        ],
        905: [
            {"value": "0", "descr": "RECEIVED"},
            {"value": "1", "descr": "ACCEPTED"},
            {"value": "2", "descr": "DECLINED"},
            {"value": "3", "descr": "REJECTED"},
        ],
        906: [
            {"value": "0", "descr": "UNKNOWN_DEAL"},
            {"value": "1", "descr": "UNKNOWN_OR_INVALID_INSTRUMENT"},
            {"value": "2", "descr": "UNAUTHORIZED_TRANSACTION"},
            {"value": "3", "descr": "INSUFFICIENT_COLLATERAL"},
            {"value": "4", "descr": "INVALID_TYPE_OF_COLLATERAL"},
            {"value": "5", "descr": "EXCESSIVE_SUBSTITUTION"},
            {"value": "99", "descr": "OTHER"},
        ],
        910: [
            {"value": "0", "descr": "UNASSIGNED"},
            {"value": "1", "descr": "PARTIALLY_ASSIGNED"},
            {"value": "2", "descr": "ASSIGNMENT_PROPOSED"},
            {"value": "3", "descr": "ASSIGNED"},
            {"value": "4", "descr": "CHALLENGED"},
        ],
        912: [{"value": "N", "descr": "NO"}, {"value": "Y", "descr": "YES"}],
        919: [
            {"value": "0", "descr": "VERSUS_PAYMENT_DELIVER"},
            {"value": "1", "descr": "FREE_DELIVER"},
            {"value": "2", "descr": "TRI_PARTY"},
            {"value": "3", "descr": "HOLD_IN_CUSTODY"},
        ],
        924: [
            {"value": "1", "descr": "LOG_ON_USER"},
            {"value": "2", "descr": "LOG_OFF_USER"},
            {"value": "3", "descr": "CHANGE_PASSWORD_FOR_USER"},
            {"value": "4", "descr": "REQUEST_INDIVIDUAL_USER_STATUS"},
        ],
        926: [
            {"value": "1", "descr": "LOGGED_IN"},
            {"value": "2", "descr": "NOT_LOGGED_IN"},
            {"value": "3", "descr": "USER_NOT_RECOGNISED"},
            {"value": "4", "descr": "PASSWORD_INCORRECT"},
            {"value": "5", "descr": "PASSWORD_CHANGED"},
            {"value": "6", "descr": "OTHER"},
            {"value": "7", "descr": "FORCED_USER_LOGOUT_BY_EXCHANGE"},
            {"value": "8", "descr": "SESSION_SHUTDOWN_WARNING"},
        ],
        928: [
            {"value": "1", "descr": "CONNECTED"},
            {"value": "2", "descr": "NOT_CONNECTED_2"},
            {"value": "3", "descr": "NOT_CONNECTED_3"},
            {"value": "4", "descr": "IN_PROCESS"},
        ],
        935: [
            {"value": "1", "descr": "SNAPSHOT"},
            {"value": "2", "descr": "SUBSCRIBE"},
            {"value": "4", "descr": "STOP_SUBSCRIBING"},
            {
                "value": "8",
                "descr": "LEVEL_OF_DETAIL_THEN_NOCOMPIDS_BECOMES_REQUIRED",
            },
        ],
        937: [
            {"value": "1", "descr": "FULL"},
            {"value": "2", "descr": "INCREMENTAL_UPDATE"},
        ],
        939: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "REJECTED"},
            {"value": "3", "descr": "ACCEPTED_WITH_ERRORS"},
        ],
        940: [
            {"value": "1", "descr": "RECEIVED"},
            {"value": "2", "descr": "CONFIRM_REJECTED_IE_NOT_AFFIRMED"},
            {"value": "3", "descr": "AFFIRMED"},
        ],
        944: [
            {"value": "0", "descr": "RETAIN"},
            {"value": "1", "descr": "ADD"},
            {"value": "2", "descr": "REMOVE"},
        ],
        945: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "1", "descr": "ACCEPTED_WITH_WARNINGS"},
            {"value": "2", "descr": "COMPLETED"},
            {"value": "3", "descr": "COMPLETED_WITH_WARNINGS"},
            {"value": "4", "descr": "REJECTED"},
        ],
        946: [
            {"value": "0", "descr": "SUCCESSFUL"},
            {"value": "1", "descr": "INVALID_OR_UNKNOWN_INSTRUMENT"},
            {"value": "2", "descr": "INVALID_OR_UNKNOWN_COLLATERAL_TYPE"},
            {"value": "3", "descr": "INVALID_PARTIES"},
            {"value": "4", "descr": "INVALID_TRANSPORT_TYPE_REQUESTED"},
            {"value": "5", "descr": "INVALID_DESTINATION_REQUESTED"},
            {
                "value": "6",
                "descr": "NO_COLLATERAL_FOUND_FOR_THE_TRADE_SPECIFIED",
            },
            {
                "value": "7",
                "descr": "NO_COLLATERAL_FOUND_FOR_THE_ORDER_SPECIFIED",
            },
            {"value": "8", "descr": "COLLATERAL_INQUIRY_TYPE_NOT_SUPPORTED"},
            {"value": "9", "descr": "UNAUTHORIZED_FOR_COLLATERAL_INQUIRY"},
            {"value": "99", "descr": "OTHER"},
        ],
        959: [
            {"value": "1", "descr": "INT"},
            {"value": "2", "descr": "LENGTH"},
            {"value": "3", "descr": "NUMINGROUP"},
            {"value": "4", "descr": "SEQNUM"},
            {"value": "5", "descr": "TAGNUM"},
            {"value": "6", "descr": "FLOAT"},
            {"value": "7", "descr": "QTY"},
            {"value": "8", "descr": "PRICE"},
            {"value": "9", "descr": "PRICEOFFSET"},
            {"value": "10", "descr": "AMT"},
            {"value": "11", "descr": "PERCENTAGE"},
            {"value": "12", "descr": "CHAR"},
            {"value": "13", "descr": "BOOLEAN"},
            {"value": "14", "descr": "STRING"},
            {"value": "15", "descr": "MULTIPLECHARVALUE"},
            {"value": "16", "descr": "CURRENCY"},
            {"value": "17", "descr": "EXCHANGE"},
            {"value": "18", "descr": "MONTHYEAR"},
            {"value": "19", "descr": "UTCTIMESTAMP"},
            {"value": "20", "descr": "UTCTIMEONLY"},
            {"value": "21", "descr": "LOCALMKTDATE"},
            {"value": "22", "descr": "UTCDATEONLY"},
            {"value": "23", "descr": "DATA"},
            {"value": "24", "descr": "MULTIPLESTRINGVALUE"},
            {"value": "25", "descr": "COUNTRY"},
            {"value": "26", "descr": "LANGUAGE"},
            {"value": "27", "descr": "TZTIMEONLY"},
            {"value": "28", "descr": "TZTIMESTAMP"},
            {"value": "29", "descr": "TENOR"},
        ],
        965: [
            {"value": "1", "descr": "ACTIVE"},
            {"value": "2", "descr": "INACTIVE"},
        ],
        974: [
            {"value": "FIXED", "descr": "FIXED"},
            {"value": "DIFF", "descr": "DIFF"},
        ],
        975: [
            {"value": "2", "descr": "T_PLUS_1"},
            {"value": "4", "descr": "T_PLUS_3"},
            {"value": "5", "descr": "T_PLUS_4"},
        ],
        980: [
            {"value": "A", "descr": "ADD"},
            {"value": "D", "descr": "DELETE"},
            {"value": "M", "descr": "MODIFY"},
        ],
        982: [
            {"value": "1", "descr": "AUTO_EXERCISE"},
            {"value": "2", "descr": "NON_AUTO_EXERCISE"},
            {"value": "3", "descr": "FINAL_WILL_BE_EXERCISED"},
            {"value": "4", "descr": "CONTRARY_INTENTION"},
            {"value": "5", "descr": "DIFFERENCE"},
        ],
        992: [
            {"value": "1", "descr": "SUB_ALLOCATE"},
            {"value": "2", "descr": "THIRD_PARTY_ALLOCATION"},
        ],
        996: [
            {"value": "Bcf", "descr": "BILLION_CUBIC_FEET"},
            {"value": "MMbbl", "descr": "MILLION_BARRELS"},
            {"value": "MMBtu", "descr": "ONE_MILLION_BTU"},
            {"value": "MWh", "descr": "MEGAWATT_HOURS"},
            {"value": "Bbl", "descr": "BARRELS"},
            {"value": "Bu", "descr": "BUSHELS"},
            {"value": "lbs", "descr": "POUNDS"},
            {"value": "Gal", "descr": "GALLONS"},
            {"value": "oz_tr", "descr": "TROY_OUNCES"},
            {"value": "t", "descr": "METRIC_TONS"},
            {"value": "tn", "descr": "TONS"},
            {"value": "USD", "descr": "US_DOLLARS"},
            {"value": "Alw", "descr": "ALLOWANCES"},
        ],
        997: [
            {"value": "H", "descr": "HOUR"},
            {"value": "Min", "descr": "MINUTE"},
            {"value": "S", "descr": "SECOND"},
            {"value": "D", "descr": "DAY"},
            {"value": "Wk", "descr": "WEEK"},
            {"value": "Mo", "descr": "MONTH"},
            {"value": "Yr", "descr": "YEAR"},
        ],
        1002: [
            {"value": "1", "descr": "AUTOMATIC"},
            {"value": "2", "descr": "GUARANTOR"},
            {"value": "3", "descr": "MANUAL"},
        ],
        1015: [
            {"value": "0", "descr": "FALSE"},
            {"value": "1", "descr": "TRUE"},
        ],
        1021: [
            {"value": "1", "descr": "TOP_OF_BOOK"},
            {"value": "2", "descr": "PRICE_DEPTH"},
            {"value": "3", "descr": "ORDER_DEPTH"},
        ],
        1024: [
            {"value": "0", "descr": "BOOK"},
            {"value": "1", "descr": "OFF_BOOK"},
            {"value": "2", "descr": "CROSS"},
        ],
        1031: [
            {"value": "ADD", "descr": "ADD_ON_ORDER"},
            {"value": "AON", "descr": "ALL_OR_NONE"},
            {"value": "CNH", "descr": "CASH_NOT_HELD"},
            {"value": "DIR", "descr": "DIRECTED_ORDER"},
            {"value": "E.W", "descr": "EXCHANGE_FOR_PHYSICAL_TRANSACTION"},
            {"value": "FOK", "descr": "FILL_OR_KILL"},
            {"value": "IO", "descr": "IMBALANCE_ONLY"},
            {"value": "IOC", "descr": "IMMEDIATE_OR_CANCEL"},
            {"value": "LOO", "descr": "LIMIT_ON_OPEN"},
            {"value": "LOC", "descr": "LIMIT_ON_CLOSE"},
            {"value": "MAO", "descr": "MARKET_AT_OPEN"},
            {"value": "MAC", "descr": "MARKET_AT_CLOSE"},
            {"value": "MOO", "descr": "MARKET_ON_OPEN"},
            {"value": "MOC", "descr": "MARKET_ON_CLOSE"},
            {"value": "MQT", "descr": "MINIMUM_QUANTITY"},
            {"value": "NH", "descr": "NOT_HELD"},
            {"value": "OVD", "descr": "OVER_THE_DAY"},
            {"value": "PEG", "descr": "PEGGED"},
            {"value": "RSV", "descr": "RESERVE_SIZE_ORDER"},
            {"value": "S.W", "descr": "STOP_STOCK_TRANSACTION"},
            {"value": "SCL", "descr": "SCALE"},
            {"value": "TMO", "descr": "TIME_ORDER"},
            {"value": "TS", "descr": "TRAILING_STOP"},
            {"value": "WRK", "descr": "WORK"},
        ],
        1032: [{"value": "1", "descr": "NASD_OATS"}],
        1033: [
            {"value": "A", "descr": "AGENCY"},
            {"value": "AR", "descr": "ARBITRAGE"},
            {"value": "D", "descr": "DERIVATIVES"},
            {"value": "IN", "descr": "INTERNATIONAL"},
            {"value": "IS", "descr": "INSTITUTIONAL"},
            {"value": "O", "descr": "OTHER"},
            {"value": "PF", "descr": "PREFERRED_TRADING"},
            {"value": "PR", "descr": "PROPRIETARY"},
            {"value": "PT", "descr": "PROGRAM_TRADING"},
            {"value": "S", "descr": "SALES"},
            {"value": "T", "descr": "TRADING"},
        ],
        1034: [{"value": "1", "descr": "NASD_OATS"}],
        1035: [
            {"value": "ADD", "descr": "ADD_ON_ORDER"},
            {"value": "AON", "descr": "ALL_OR_NONE"},
            {"value": "CNH", "descr": "CASH_NOT_HELD"},
            {"value": "DIR", "descr": "DIRECTED_ORDER"},
            {"value": "E.W", "descr": "EXCHANGE_FOR_PHYSICAL_TRANSACTION"},
            {"value": "FOK", "descr": "FILL_OR_KILL"},
            {"value": "IO", "descr": "IMBALANCE_ONLY"},
            {"value": "IOC", "descr": "IMMEDIATE_OR_CANCEL"},
            {"value": "LOO", "descr": "LIMIT_ON_OPEN"},
            {"value": "LOC", "descr": "LIMIT_ON_CLOSE"},
            {"value": "MAO", "descr": "MARKET_AT_OPEN"},
            {"value": "MAC", "descr": "MARKET_AT_CLOSE"},
            {"value": "MOO", "descr": "MARKET_ON_OPEN"},
            {"value": "MOC", "descr": "MARKET_ON_CLOSE"},
            {"value": "MQT", "descr": "MINIMUM_QUANTITY"},
            {"value": "NH", "descr": "NOT_HELD"},
            {"value": "OVD", "descr": "OVER_THE_DAY"},
            {"value": "PEG", "descr": "PEGGED"},
            {"value": "RSV", "descr": "RESERVE_SIZE_ORDER"},
            {"value": "S.W", "descr": "STOP_STOCK_TRANSACTION"},
            {"value": "SCL", "descr": "SCALE"},
            {"value": "TMO", "descr": "TIME_ORDER"},
            {"value": "TS", "descr": "TRAILING_STOP"},
            {"value": "WRK", "descr": "WORK"},
        ],
        1036: [
            {"value": "0", "descr": "RECEIVED_NOT_YET_PROCESSED"},
            {"value": "1", "descr": "ACCEPTED"},
            {"value": "2", "descr": "DONT_KNOW"},
        ],
        1043: [
            {"value": "0", "descr": "SPECIFIC_DEPOSIT"},
            {"value": "1", "descr": "GENERAL"},
        ],
        1046: [
            {"value": "D", "descr": "DIVIDE"},
            {"value": "M", "descr": "MULTIPLY"},
        ],
        1047: [
            {"value": "O", "descr": "OPEN"},
            {"value": "C", "descr": "CLOSE"},
            {"value": "R", "descr": "ROLLED"},
            {"value": "F", "descr": "FIFO"},
        ],
        1048: [
            {"value": "A", "descr": "AGENT"},
            {"value": "P", "descr": "PRINCIPAL"},
            {"value": "R", "descr": "RISKLESS_PRINCIPAL"},
        ],
        1057: [{"value": "Y", "descr": "YES"}, {"value": "N", "descr": "NO"}],
        1070: [
            {"value": "0", "descr": "INDICATIVE"},
            {"value": "1", "descr": "TRADEABLE"},
            {"value": "2", "descr": "RESTRICTED_TRADEABLE"},
            {"value": "3", "descr": "COUNTER"},
            {"value": "4", "descr": "INDICATIVE_AND_TRADEABLE"},
        ],
        1081: [
            {"value": "0", "descr": "SECONDARYORDERID"},
            {"value": "1", "descr": "ORDERID"},
            {"value": "2", "descr": "MDENTRYID"},
            {"value": "3", "descr": "QUOTEENTRYID"},
            {"value": "4", "descr": "ORIGINAL_ORDER_ID"},
        ],
        1083: [
            {"value": "1", "descr": "IMMEDIATE"},
            {"value": "2", "descr": "EXHAUST"},
        ],
        1084: [
            {"value": "1", "descr": "INITIAL"},
            {"value": "2", "descr": "NEW"},
            {"value": "3", "descr": "RANDOM"},
            {"value": "4", "descr": "UNDISCLOSED"},
        ],
        1092: [
            {"value": "0", "descr": "NONE"},
            {"value": "1", "descr": "LOCAL"},
            {"value": "2", "descr": "NATIONAL"},
            {"value": "3", "descr": "GLOBAL"},
        ],
        1093: [
            {"value": "1", "descr": "ODD_LOT"},
            {"value": "2", "descr": "ROUND_LOT"},
            {"value": "3", "descr": "BLOCK_LOT"},
            {"value": "4", "descr": "ROUND_LOT_BASED_UPON_UNITOFMEASURE"},
        ],
        1094: [
            {"value": "1", "descr": "LAST_PEG"},
            {"value": "2", "descr": "MID_PRICE_PEG"},
            {"value": "3", "descr": "OPENING_PEG"},
            {"value": "4", "descr": "MARKET_PEG"},
            {"value": "5", "descr": "PRIMARY_PEG"},
            {"value": "7", "descr": "PEG_TO_VWAP"},
            {"value": "8", "descr": "TRAILING_STOP_PEG"},
            {"value": "9", "descr": "PEG_TO_LIMIT_PRICE"},
        ],
        1100: [
            {"value": "1", "descr": "PARTIAL_EXECUTION"},
            {"value": "2", "descr": "SPECIFIED_TRADING_SESSION"},
            {"value": "3", "descr": "NEXT_AUCTION"},
            {"value": "4", "descr": "PRICE_MOVEMENT"},
        ],
        1101: [
            {"value": "1", "descr": "ACTIVATE"},
            {"value": "2", "descr": "MODIFY"},
            {"value": "3", "descr": "CANCEL"},
        ],
        1107: [
            {"value": "1", "descr": "BEST_OFFER"},
            {"value": "2", "descr": "LAST_TRADE"},
            {"value": "3", "descr": "BEST_BID"},
            {"value": "4", "descr": "BEST_BID_OR_LAST_TRADE"},
            {"value": "5", "descr": "BEST_OFFER_OR_LAST_TRADE"},
            {"value": "6", "descr": "BEST_MID"},
        ],
        1108: [
            {"value": "0", "descr": "NONE"},
            {"value": "1", "descr": "LOCAL"},
            {"value": "2", "descr": "NATIONAL"},
            {"value": "3", "descr": "GLOBAL"},
        ],
        1109: [
            {
                "value": "U",
                "descr": "TRIGGER_IF_THE_PRICE_OF_THE_SPECIFIED_TYPE_GOES_UP_TO_OR_THROUGH_THE_SPECIFIED_TRIGGER_PRICE",
            },
            {
                "value": "D",
                "descr": "TRIGGER_IF_THE_PRICE_OF_THE_SPECIFIED_TYPE_GOES_DOWN_TO_OR_THROUGH_THE_SPECIFIED_TRIGGER_PRICE",
            },
        ],
        1111: [
            {"value": "1", "descr": "MARKET"},
            {"value": "2", "descr": "LIMIT"},
        ],
        1115: [
            {"value": "1", "descr": "ORDER"},
            {"value": "2", "descr": "QUOTE"},
            {"value": "3", "descr": "PRIVATELY_NEGOTIATED_TRADE"},
            {"value": "4", "descr": "MULTILEG_ORDER"},
            {"value": "5", "descr": "LINKED_ORDER"},
            {"value": "6", "descr": "QUOTE_REQUEST"},
            {"value": "7", "descr": "IMPLIED_ORDER"},
            {"value": "8", "descr": "CROSS_ORDER"},
            {"value": "9", "descr": "STREAMING_PRICE"},
        ],
        1123: [
            {"value": "0", "descr": "TRADE_CONFIRMATION"},
            {"value": "1", "descr": "TWO_PARTY_REPORT"},
            {"value": "2", "descr": "ONE_PARTY_REPORT_FOR_MATCHING"},
            {"value": "3", "descr": "ONE_PARTY_REPORT_FOR_PASS_THROUGH"},
            {"value": "4", "descr": "AUTOMATED_FLOOR_ORDER_ROUTING"},
            {"value": "5", "descr": "TWO_PARTY_REPORT_FOR_CLAIM"},
        ],
        1128: [
            {"value": "0", "descr": "FIX27"},
            {"value": "1", "descr": "FIX30"},
            {"value": "2", "descr": "FIX40"},
            {"value": "3", "descr": "FIX41"},
            {"value": "4", "descr": "FIX42"},
            {"value": "5", "descr": "FIX43"},
            {"value": "6", "descr": "FIX44"},
            {"value": "7", "descr": "FIX50"},
            {"value": "8", "descr": "FIX50SP1"},
            {"value": "9", "descr": "FIX50SP2"},
        ],
        1133: [
            {"value": "B", "descr": "BIC"},
            {
                "value": "C",
                "descr": "GENERALLY_ACCEPTED_MARKET_PARTICIPANT_IDENTIFIER",
            },
            {"value": "D", "descr": "PROPRIETARY"},
            {"value": "E", "descr": "ISO_COUNTRY_CODE"},
            {"value": "G", "descr": "MIC"},
        ],
        1144: [
            {"value": "0", "descr": "NOT_IMPLIED"},
            {"value": "1", "descr": "IMPLIED_IN"},
            {"value": "2", "descr": "IMPLIED_OUT"},
            {"value": "3", "descr": "BOTH_IMPLIED_IN_AND_IMPLIED_OUT"},
        ],
        1159: [
            {"value": "1", "descr": "PRELIMINARY"},
            {"value": "2", "descr": "FINAL"},
        ],
        1162: [
            {"value": "C", "descr": "CANCEL"},
            {"value": "N", "descr": "NEW"},
            {"value": "R", "descr": "REPLACE"},
            {"value": "T", "descr": "RESTATE"},
        ],
        1164: [
            {"value": "1", "descr": "INSTRUCTIONS_OF_BROKER"},
            {"value": "2", "descr": "INSTRUCTIONS_FOR_INSTITUTION"},
            {"value": "3", "descr": "INVESTOR"},
        ],
        1167: [
            {"value": "0", "descr": "ACCEPTED"},
            {"value": "5", "descr": "REJECTED"},
            {"value": "6", "descr": "REMOVED_FROM_MARKET"},
            {"value": "7", "descr": "EXPIRED"},
            {"value": "12", "descr": "LOCKED_MARKET_WARNING"},
            {"value": "13", "descr": "CROSS_MARKET_WARNING"},
            {"value": "14", "descr": "CANCELED_DUE_TO_LOCK_MARKET"},
            {"value": "15", "descr": "CANCELED_DUE_TO_CROSS_MARKET"},
            {"value": "16", "descr": "ACTIVE"},
        ],
        1172: [
            {"value": "1", "descr": "ALL_MARKET_PARTICIPANTS"},
            {"value": "2", "descr": "SPECIFIED_MARKET_PARTICIPANTS"},
            {"value": "3", "descr": "ALL_MARKET_MAKERS"},
            {"value": "4", "descr": "PRIMARY_MARKET_MAKER"},
        ],
        1174: [
            {"value": "1", "descr": "ORDER_IMBALANCE_AUCTION_IS_EXTENDED"},
            {"value": "2", "descr": "TRADING_RESUMES"},
            {"value": "3", "descr": "PRICE_VOLATILITY_INTERRUPTION"},
            {"value": "4", "descr": "CHANGE_OF_TRADING_SESSION"},
            {"value": "5", "descr": "CHANGE_OF_TRADING_SUBSESSION"},
            {"value": "6", "descr": "CHANGE_OF_SECURITY_TRADING_STATUS"},
            {"value": "7", "descr": "CHANGE_OF_BOOK_TYPE"},
            {"value": "8", "descr": "CHANGE_OF_MARKET_DEPTH"},
        ],
        1176: [
            {"value": "1", "descr": "EXCHANGE_LAST"},
            {"value": "2", "descr": "HIGH"},
            {"value": "3", "descr": "AVERAGE_PRICE"},
            {"value": "4", "descr": "TURNOVER"},
        ],
        1178: [{"value": "1", "descr": "CUSTOMER"}],
        1193: [
            {"value": "C", "descr": "CASH_SETTLEMENT_REQUIRED"},
            {"value": "P", "descr": "PHYSICAL_SETTLEMENT_REQUIRED"},
        ],
        1194: [
            {"value": "0", "descr": "EUROPEAN"},
            {"value": "1", "descr": "AMERICAN"},
            {"value": "2", "descr": "BERMUDA"},
        ],
        1196: [
            {"value": "STD", "descr": "STANDARD_MONEY_PER_UNIT_OF_A_PHYSICAL"},
            {"value": "INX", "descr": "INDEX"},
            {"value": "INT", "descr": "INTEREST_RATE_INDEX"},
            {"value": "PCTPAR", "descr": "PERCENT_OF_PAR"},
        ],
        1197: [
            {"value": "EQTY", "descr": "PREMIUM_STYLE"},
            {"value": "FUT", "descr": "FUTURES_STYLE_MARK_TO_MARKET"},
            {
                "value": "FUTDA",
                "descr": "FUTURES_STYLE_WITH_AN_ATTACHED_CASH_ADJUSTMENT",
            },
            {
                "value": "CDS",
                "descr": "CDS_STYLE_COLLATERALIZATION_OF_MARKET_TO_MARKET_AND_COUPON",
            },
            {"value": "CDSD", "descr": "CDS_IN_DELIVERY"},
        ],
        1198: [
            {"value": "0", "descr": "PRE_LISTED_ONLY"},
            {"value": "1", "descr": "USER_REQUESTED"},
        ],
        1209: [
            {"value": "0", "descr": "REGULAR"},
            {"value": "1", "descr": "VARIABLE"},
            {"value": "2", "descr": "FIXED"},
            {"value": "3", "descr": "TRADED_AS_A_SPREAD_LEG"},
            {"value": "4", "descr": "SETTLED_AS_A_SPREAD_LEG"},
        ],
        1302: [
            {"value": "0", "descr": "MONTHS"},
            {"value": "1", "descr": "DAYS"},
            {"value": "2", "descr": "WEEKS"},
            {"value": "3", "descr": "YEARS"},
        ],
        1303: [
            {"value": "0", "descr": "YEARMONTH_ONLY"},
            {"value": "1", "descr": "YEARMONTHDAY"},
            {"value": "2", "descr": "YEARMONTHWEEK"},
        ],
        1306: [
            {"value": "0", "descr": "PRICE"},
            {"value": "1", "descr": "TICKS"},
            {"value": "2", "descr": "PERCENTAGE"},
        ],
        1347: [
            {
                "value": "0",
                "descr": "RETRANSMISSION_OF_APPLICATION_MESSAGES_FOR_THE_SPECIFIED_APPLICATIONS",
            },
            {
                "value": "1",
                "descr": "SUBSCRIPTION_TO_THE_SPECIFIED_APPLICATIONS",
            },
            {
                "value": "2",
                "descr": "REQUEST_FOR_THE_LAST_APPLLASTSEQNUM_PUBLISHED_FOR_THE_SPECIFIED_APPLICATIONS",
            },
            {"value": "3", "descr": "REQUEST_VALID_SET_OF_APPLICATIONS"},
            {
                "value": "4",
                "descr": "UNSUBSCRIBE_TO_THE_SPECIFIED_APPLICATIONS",
            },
            {"value": "5", "descr": "CANCEL_RETRANSMISSION"},
            {
                "value": "6",
                "descr": "CANCEL_RETRANSMISSION_AND_UNSUBSCRIBE_TO_THE_SPECIFIED_APPLICATIONS",
            },
        ],
        1348: [
            {"value": "0", "descr": "REQUEST_SUCCESSFULLY_PROCESSED"},
            {"value": "1", "descr": "APPLICATION_DOES_NOT_EXIST"},
            {"value": "2", "descr": "MESSAGES_NOT_AVAILABLE"},
        ],
        1354: [
            {"value": "0", "descr": "APPLICATION_DOES_NOT_EXIST"},
            {"value": "1", "descr": "MESSAGES_REQUESTED_ARE_NOT_AVAILABLE"},
            {"value": "2", "descr": "USER_NOT_AUTHORIZED_FOR_APPLICATION"},
        ],
        1368: [
            {"value": "0", "descr": "TRADING_RESUMES"},
            {"value": "1", "descr": "CHANGE_OF_TRADING_SESSION"},
            {"value": "2", "descr": "CHANGE_OF_TRADING_SUBSESSION"},
            {"value": "3", "descr": "CHANGE_OF_TRADING_STATUS"},
        ],
        1373: [
            {"value": "1", "descr": "SUSPEND_ORDERS"},
            {"value": "2", "descr": "RELEASE_ORDERS_FROM_SUSPENSION"},
            {"value": "3", "descr": "CANCEL_ORDERS"},
        ],
        1374: [
            {"value": "1", "descr": "ALL_ORDERS_FOR_A_SECURITY"},
            {"value": "2", "descr": "ALL_ORDERS_FOR_AN_UNDERLYING_SECURITY"},
            {"value": "3", "descr": "ALL_ORDERS_FOR_A_PRODUCT"},
            {"value": "4", "descr": "ALL_ORDERS_FOR_A_CFICODE"},
            {"value": "5", "descr": "ALL_ORDERS_FOR_A_SECURITYTYPE"},
            {"value": "6", "descr": "ALL_ORDERS_FOR_A_TRADING_SESSION"},
            {"value": "7", "descr": "ALL_ORDERS"},
            {"value": "8", "descr": "ALL_ORDERS_FOR_A_MARKET"},
            {"value": "9", "descr": "ALL_ORDERS_FOR_A_MARKET_SEGMENT"},
            {"value": "10", "descr": "ALL_ORDERS_FOR_A_SECURITY_GROUP"},
            {"value": "11", "descr": "CANCEL_FOR_SECURITY_ISSUER"},
            {
                "value": "12",
                "descr": "CANCEL_FOR_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        1375: [
            {"value": "0", "descr": "REJECTED"},
            {"value": "1", "descr": "ACCEPTED"},
        ],
        1376: [
            {"value": "0", "descr": "MASS_ACTION_NOT_SUPPORTED"},
            {"value": "1", "descr": "INVALID_OR_UNKNOWN_SECURITY"},
            {"value": "2", "descr": "INVALID_OR_UNKNOWN_UNDERLYING_SECURITY"},
            {"value": "3", "descr": "INVALID_OR_UNKNOWN_PRODUCT"},
            {"value": "4", "descr": "INVALID_OR_UNKNOWN_CFICODE"},
            {"value": "5", "descr": "INVALID_OR_UNKNOWN_SECURITYTYPE"},
            {"value": "6", "descr": "INVALID_OR_UNKNOWN_TRADING_SESSION"},
            {"value": "7", "descr": "INVALID_OR_UNKNOWN_MARKET"},
            {"value": "8", "descr": "INVALID_OR_UNKNOWN_MARKET_SEGMENT"},
            {"value": "9", "descr": "INVALID_OR_UNKNOWN_SECURITY_GROUP"},
            {"value": "99", "descr": "OTHER"},
            {"value": "10", "descr": "INVALID_OR_UNKNOWN_SECURITY_ISSUER"},
            {
                "value": "11",
                "descr": "INVALID_OR_UNKNOWN_ISSUER_OF_UNDERLYING_SECURITY",
            },
        ],
        1377: [
            {"value": "0", "descr": "PREDEFINED_MULTILEG_SECURITY"},
            {"value": "1", "descr": "USER_DEFINED_MULTLEG_SECURITY"},
            {"value": "2", "descr": "USER_DEFINED_NON_SECURITIZED_MULTILEG"},
        ],
        1378: [
            {"value": "0", "descr": "NET_PRICE"},
            {"value": "1", "descr": "REVERSED_NET_PRICE"},
            {"value": "2", "descr": "YIELD_DIFFERENCE"},
            {"value": "3", "descr": "INDIVIDUAL"},
            {"value": "4", "descr": "CONTRACT_WEIGHTED_AVERAGE_PRICE"},
            {"value": "5", "descr": "MULTIPLIED_PRICE"},
        ],
        1385: [
            {"value": "1", "descr": "ONE_CANCELS_THE_OTHER"},
            {"value": "2", "descr": "ONE_TRIGGERS_THE_OTHER"},
            {"value": "3", "descr": "ONE_UPDATES_THE_OTHER_3"},
            {"value": "4", "descr": "ONE_UPDATES_THE_OTHER_4"},
        ],
        1386: [
            {"value": "0", "descr": "BROKER"},
            {"value": "2", "descr": "EXCHANGE_CLOSED"},
            {"value": "4", "descr": "TOO_LATE_TO_ENTER"},
            {"value": "5", "descr": "UNKNOWN_ORDER"},
            {"value": "6", "descr": "DUPLICATE_ORDER"},
            {"value": "11", "descr": "UNSUPPORTED_ORDER_CHARACTERISTIC"},
            {"value": "99", "descr": "OTHER"},
        ],
        1390: [
            {"value": "0", "descr": "DO_NOT_PUBLISH_TRADE"},
            {"value": "1", "descr": "PUBLISH_TRADE"},
            {"value": "2", "descr": "DEFERRED_PUBLICATION"},
        ],
        1395: [
            {"value": "A", "descr": "ADD"},
            {"value": "D", "descr": "DELETE"},
            {"value": "M", "descr": "MODIFY"},
        ],
        1409: [
            {"value": "0", "descr": "SESSION_ACTIVE"},
            {"value": "1", "descr": "SESSION_PASSWORD_CHANGED"},
            {"value": "2", "descr": "SESSION_PASSWORD_DUE_TO_EXPIRE"},
            {
                "value": "3",
                "descr": "NEW_SESSION_PASSWORD_DOES_NOT_COMPLY_WITH_POLICY",
            },
            {"value": "4", "descr": "SESSION_LOGOUT_COMPLETE"},
            {"value": "5", "descr": "INVALID_USERNAME_OR_PASSWORD"},
            {"value": "6", "descr": "ACCOUNT_LOCKED"},
            {"value": "7", "descr": "LOGONS_ARE_NOT_ALLOWED_AT_THIS_TIME"},
            {"value": "8", "descr": "PASSWORD_EXPIRED"},
        ],
        1426: [
            {
                "value": "0",
                "descr": "RESET_APPLSEQNUM_TO_NEW_VALUE_SPECIFIED_IN_APPLNEWSEQNUM",
            },
            {
                "value": "1",
                "descr": "REPORTS_THAT_THE_LAST_MESSAGE_HAS_BEEN_SENT_FOR_THE_APPLIDS_REFER_TO_REFAPPLLASTSEQNUM",
            },
            {
                "value": "2",
                "descr": "HEARTBEAT_MESSAGE_INDICATING_THAT_APPLICATION_IDENTIFIED_BY_REFAPPLID",
            },
            {"value": "3", "descr": "APPLICATION_MESSAGE_RE_SEND_COMPLETED"},
        ],
        1429: [
            {"value": "0", "descr": "SECONDS"},
            {"value": "1", "descr": "TENTHS_OF_A_SECOND"},
            {"value": "2", "descr": "HUNDREDTHS_OF_A_SECOND"},
            {"value": "3", "descr": "MILLISECONDS"},
            {"value": "4", "descr": "MICROSECONDS"},
            {"value": "5", "descr": "NANOSECONDS"},
            {"value": "10", "descr": "MINUTES"},
            {"value": "11", "descr": "HOURS"},
            {"value": "12", "descr": "DAYS"},
            {"value": "13", "descr": "WEEKS"},
            {"value": "14", "descr": "MONTHS"},
            {"value": "15", "descr": "YEARS"},
        ],
        1430: [
            {"value": "E", "descr": "ELECTRONIC"},
            {"value": "P", "descr": "PIT"},
            {"value": "X", "descr": "EX_PIT"},
        ],
        1431: [
            {"value": "0", "descr": "GTC_FROM_PREVIOUS_DAY"},
            {"value": "1", "descr": "PARTIAL_FILL_REMAINING"},
            {"value": "2", "descr": "ORDER_CHANGED"},
        ],
        1432: [
            {"value": "1", "descr": "MEMBER_TRADING_FOR_THEIR_OWN_ACCOUNT"},
            {
                "value": "2",
                "descr": "CLEARING_FIRM_TRADING_FOR_ITS_PROPRIETARY_ACCOUNT",
            },
            {"value": "3", "descr": "MEMBER_TRADING_FOR_ANOTHER_MEMBER"},
            {"value": "4", "descr": "ALL_OTHER"},
        ],
        1434: [
            {"value": "0", "descr": "UTILITY_PROVIDED_STANDARD_MODEL"},
            {"value": "1", "descr": "PROPRIETARY"},
        ],
        1435: [
            {"value": "0", "descr": "SHARES"},
            {"value": "1", "descr": "HOURS"},
            {"value": "2", "descr": "DAYS"},
        ],
        1439: [
            {"value": "0", "descr": "NERC_EASTERN_OFF_PEAK"},
            {"value": "1", "descr": "NERC_WESTERN_OFF_PEAK"},
            {"value": "2", "descr": "NERC_CALENDAR_ALL_DAYS_IN_MONTH"},
            {"value": "3", "descr": "NERC_EASTERN_PEAK"},
            {"value": "4", "descr": "NERC_WESTERN_PEAK"},
        ],
        1446: [
            {"value": "0", "descr": "BLOOMBERG"},
            {"value": "1", "descr": "REUTERS"},
            {"value": "2", "descr": "TELERATE"},
            {"value": "99", "descr": "OTHER"},
        ],
        1447: [
            {"value": "0", "descr": "PRIMARY"},
            {"value": "1", "descr": "SECONDARY"},
        ],
        1449: [
            {"value": "FR", "descr": "FULL_RESTRUCTURING"},
            {"value": "MR", "descr": "MODIFIED_RESTRUCTURING"},
            {"value": "MM", "descr": "MODIFIED_MOD_RESTRUCTURING"},
            {"value": "XR", "descr": "NO_RESTRUCTURING_SPECIFIED"},
        ],
        1450: [
            {"value": "SD", "descr": "SENIOR_SECURED"},
            {"value": "SR", "descr": "SENIOR"},
            {"value": "SB", "descr": "SUBORDINATED"},
        ],
        1470: [
            {"value": "1", "descr": "INDUSTRY_CLASSIFICATION"},
            {"value": "2", "descr": "TRADING_LIST"},
            {"value": "3", "descr": "MARKET"},
            {"value": "4", "descr": "NEWSPAPER_LIST"},
        ],
        1471: [
            {"value": "1", "descr": "ICB"},
            {"value": "2", "descr": "NAICS"},
            {"value": "3", "descr": "GICS"},
        ],
        1473: [
            {"value": "0", "descr": "COMPANY_NEWS"},
            {"value": "1", "descr": "MARKETPLACE_NEWS"},
            {"value": "2", "descr": "FINANCIAL_MARKET_NEWS"},
            {"value": "3", "descr": "TECHNICAL_NEWS"},
            {"value": "99", "descr": "OTHER_NEWS"},
        ],
        1477: [
            {"value": "0", "descr": "REPLACEMENT"},
            {"value": "1", "descr": "OTHER_LANGUAGE"},
            {"value": "2", "descr": "COMPLIMENTARY"},
        ],
        1478: [
            {"value": "1", "descr": "FIXED_STRIKE"},
            {
                "value": "2",
                "descr": "STRIKE_SET_AT_EXPIRATION_TO_UNDERLYING_OR_OTHER_VALUE",
            },
            {
                "value": "3",
                "descr": "STRIKE_SET_TO_AVERAGE_OF_UNDERLYING_SETTLEMENT_PRICE_ACROSS_THE_LIFE_OF_THE_OPTION",
            },
            {"value": "4", "descr": "STRIKE_SET_TO_OPTIMAL_VALUE"},
        ],
        1479: [
            {
                "value": "1",
                "descr": "LESS_THAN_UNDERLYING_PRICE_IS_IN_THE_MONEY",
            },
            {
                "value": "2",
                "descr": "LESS_THAN_OR_EQUAL_TO_THE_UNDERLYING_PRICE_IS_IN_THE_MONEY",
            },
            {
                "value": "3",
                "descr": "EQUAL_TO_THE_UNDERLYING_PRICE_IS_IN_THE_MONEY",
            },
            {
                "value": "4",
                "descr": "GREATER_THAN_OR_EQUAL_TO_UNDERLYING_PRICE_IS_IN_THE_MONEY",
            },
            {"value": "5", "descr": "GREATER_THAN_UNDERLYING_IS_IN_THE_MONEY"},
        ],
        1481: [
            {"value": "1", "descr": "REGULAR"},
            {"value": "2", "descr": "SPECIAL_REFERENCE"},
            {"value": "3", "descr": "OPTIMAL_VALUE"},
            {"value": "4", "descr": "AVERAGE_VALUE"},
        ],
        1482: [
            {"value": "1", "descr": "VANILLA"},
            {"value": "2", "descr": "CAPPED"},
            {"value": "3", "descr": "BINARY"},
        ],
        1484: [
            {"value": "1", "descr": "CAPPED"},
            {"value": "2", "descr": "TRIGGER"},
            {"value": "3", "descr": "KNOCK_IN_UP"},
            {"value": "4", "descr": "KOCK_IN_DOWN"},
            {"value": "5", "descr": "KNOCK_OUT_UP"},
            {"value": "6", "descr": "KNOCK_OUT_DOWN"},
            {"value": "7", "descr": "UNDERLYING"},
            {"value": "8", "descr": "RESET_BARRIER"},
            {"value": "9", "descr": "ROLLING_BARRIER"},
        ],
        1487: [
            {"value": "1", "descr": "LESS_THAN_COMPLEXEVENTPRICE"},
            {"value": "2", "descr": "LESS_THAN_OR_EQUAL_TO_COMPLEXEVENTPRICE"},
            {"value": "3", "descr": "EQUAL_TO_COMPLEXEVENTPRICE"},
            {
                "value": "4",
                "descr": "GREATER_THAN_OR_EQUAL_TO_COMPLEXEVENTPRICE",
            },
            {"value": "5", "descr": "GREATER_THAN_COMPLEXEVENTPRICE"},
        ],
        1489: [
            {"value": "1", "descr": "EXPIRATION"},
            {"value": "2", "descr": "IMMEDIATE"},
            {"value": "3", "descr": "SPECIFIED_DATE_TIME"},
        ],
        1490: [{"value": "1", "descr": "AND"}, {"value": "2", "descr": "OR"}],
        1498: [
            {"value": "1", "descr": "STREAM_ASSIGNMENT_FOR_NEW_CUSTOMER"},
            {"value": "2", "descr": "STREAM_ASSIGNMENT_FOR_EXISTING_CUSTOMER"},
        ],
        1502: [
            {"value": "0", "descr": "UNKNOWN_CLIENT"},
            {"value": "1", "descr": "EXCEEDS_MAXIMUM_SIZE"},
            {"value": "2", "descr": "UNKNOWN_OR_INVALID_CURRENCY_PAIR"},
            {"value": "3", "descr": "NO_AVAILABLE_STREAM"},
            {"value": "99", "descr": "OTHER"},
        ],
        1503: [
            {"value": "0", "descr": "ASSIGNMENT_ACCEPTED"},
            {"value": "1", "descr": "ASSIGNMENT_REJECTED"},
        ],
        1617: [
            {"value": "1", "descr": "ASSIGNMENT"},
            {"value": "2", "descr": "REJECTED"},
            {"value": "3", "descr": "TERMINATE_UNASSIGN"},
        ],
    },
}
